# IO.Swagger - the C# library for the Topal REST API

No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

This C# SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0
- SDK version: 1.0.0
- Build package: io.swagger.codegen.languages.CSharpClientCodegen

<a name="frameworks-supported"></a>
## Frameworks supported
- .NET 4.0 or later
- Windows Phone 7.1 (Mango)

<a name="dependencies"></a>
## Dependencies
- [RestSharp](https://www.nuget.org/packages/RestSharp) - 105.1.0 or later
- [Json.NET](https://www.nuget.org/packages/Newtonsoft.Json/) - 7.0.0 or later
- [JsonSubTypes](https://www.nuget.org/packages/JsonSubTypes/) - 1.2.0 or later

The DLLs included in the package may not be the latest version. We recommend using [NuGet](https://docs.nuget.org/consume/installing-nuget) to obtain the latest version of the packages:
```
Install-Package RestSharp
Install-Package Newtonsoft.Json
Install-Package JsonSubTypes
```

NOTE: RestSharp versions greater than 105.1.0 have a bug which causes file uploads to fail. See [RestSharp#742](https://github.com/restsharp/RestSharp/issues/742)

<a name="installation"></a>
## Installation
Run the following command to generate the DLL
- [Mac/Linux] `/bin/sh build.sh`
- [Windows] `build.bat`

Then include the DLL (under the `bin` folder) in the C# project, and use the namespaces:
```csharp
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;
```
<a name="packaging"></a>
## Packaging

A `.nuspec` is included with the project. You can follow the Nuget quickstart to [create](https://docs.microsoft.com/en-us/nuget/quickstart/create-and-publish-a-package#create-the-package) and [publish](https://docs.microsoft.com/en-us/nuget/quickstart/create-and-publish-a-package#publish-the-package) packages.

This `.nuspec` uses placeholders from the `.csproj`, so build the `.csproj` directly:

```
nuget pack -Build -OutputDirectory out IO.Swagger.csproj
```

Then, publish to a [local feed](https://docs.microsoft.com/en-us/nuget/hosting-packages/local-feeds) or [other host](https://docs.microsoft.com/en-us/nuget/hosting-packages/overview) and consume the new package via Nuget as usual.

<a name="getting-started"></a>
## Getting Started

```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class Example
    {
        public void main()
        {

            var apiInstance = new AccountAreasApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete AccountArea
                Object result = apiInstance.AccountAreasDelete(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountAreasApi.AccountAreasDelete: " + e.Message );
            }

        }
    }
}
```

<a name="documentation-for-api-endpoints"></a>
## Documentation for API Endpoints

All URIs are relative to *https://websolution.topal.ch*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountAreasApi* | [**AccountAreasDelete**](docs/AccountAreasApi.md#accountareasdelete) | **DELETE** /api/v1/clients/{clientId}/accountAreas/{id} | Delete AccountArea
*AccountAreasApi* | [**AccountAreasGet**](docs/AccountAreasApi.md#accountareasget) | **GET** /api/v1/clients/{clientId}/accountareas | get list of accountAreas
*AccountAreasApi* | [**AccountAreasGet_0**](docs/AccountAreasApi.md#accountareasget_0) | **GET** /api/v1/clients/{clientId}/accountareas/{id} | Get accountArea by id
*AccountAreasApi* | [**AccountAreasPost**](docs/AccountAreasApi.md#accountareaspost) | **POST** /api/v1/clients/{clientId}/accountAreas | Save AccountArea
*AccountsApi* | [**AccountsGet**](docs/AccountsApi.md#accountsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts | Gets list of accounts
*AccountsApi* | [**AccountsGetStatement**](docs/AccountsApi.md#accountsgetstatement) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}/statement | get account statement
*AccountsApi* | [**AccountsGetSummary**](docs/AccountsApi.md#accountsgetsummary) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}/summary | get account summary
*AccountsApi* | [**AccountsGet_0**](docs/AccountsApi.md#accountsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id} | Gets account by id
*BankAccountApi* | [**BankAccountDelete**](docs/BankAccountApi.md#bankaccountdelete) | **DELETE** /api/v1/clients/{clientId}/bankaccounts/{id} | Delete bankAccount
*BankAccountApi* | [**BankAccountGet**](docs/BankAccountApi.md#bankaccountget) | **GET** /api/v1/clients/{clientId}/bankaccounts | Retreives list of bankAccounts
*BankAccountApi* | [**BankAccountGet_0**](docs/BankAccountApi.md#bankaccountget_0) | **GET** /api/v1/clients/{clientId}/bankaccounts/{id} | Get bankAccount by id
*BankAccountApi* | [**BankAccountGet_1**](docs/BankAccountApi.md#bankaccountget_1) | **GET** /api/v1/clients/{clientId}/bankaccounts/byname/{name} | Get bankAccount by name
*BankAccountApi* | [**BankAccountPost**](docs/BankAccountApi.md#bankaccountpost) | **POST** /api/v1/clients/{clientId}/bankaccounts | Save bankAccount
*BanksApi* | [**BanksDelete**](docs/BanksApi.md#banksdelete) | **DELETE** /api/v1/clients/{clientId}/banks/{id} | Delete bank
*BanksApi* | [**BanksGet**](docs/BanksApi.md#banksget) | **GET** /api/v1/clients/{clientId}/banks | Retreives list of banks
*BanksApi* | [**BanksGetByCode**](docs/BanksApi.md#banksgetbycode) | **GET** /api/v1/clients/{clientId}/banks/bycode/{code} | Get bank by code
*BanksApi* | [**BanksGet_0**](docs/BanksApi.md#banksget_0) | **GET** /api/v1/clients/{clientId}/banks/{id} | Get bank by id
*BanksApi* | [**BanksPost**](docs/BanksApi.md#bankspost) | **POST** /api/v1/clients/{clientId}/banks | Save bank
*BudgetApi* | [**BudgetGet**](docs/BudgetApi.md#budgetget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/budgets | Retreives list of buget
*BudgetApi* | [**BudgetGet_0**](docs/BudgetApi.md#budgetget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/budgets/{id} | Get budget by id
*COATreeViewsApi* | [**COATreeViewsDelete**](docs/COATreeViewsApi.md#coatreeviewsdelete) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coaTreeViews/{id} | Delete coaTreeViewTreeView
*COATreeViewsApi* | [**COATreeViewsGet**](docs/COATreeViewsApi.md#coatreeviewsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews | get list of coatreeViews
*COATreeViewsApi* | [**COATreeViewsGetByCOA**](docs/COATreeViewsApi.md#coatreeviewsgetbycoa) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coas/{coaId}/coatreeviews | Get coaTreeView by id within given coa
*COATreeViewsApi* | [**COATreeViewsGet_0**](docs/COATreeViewsApi.md#coatreeviewsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews/{id} | Get coaTreeView by id
*COATreeViewsApi* | [**COATreeViewsGet_1**](docs/COATreeViewsApi.md#coatreeviewsget_1) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews/byCode/{code} | Get coaTreeView by code
*COATreeViewsApi* | [**COATreeViewsPost**](docs/COATreeViewsApi.md#coatreeviewspost) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews |  saves CoaTreeView   COATreeView item type:  - Account = 1  - COA Group = 2  - Counter = 3  - Mirror Account = 4  - Account Copy = 5  - Result = 6  - Commentary Line = 7
*COAViewsApi* | [**COAViewsDelete**](docs/COAViewsApi.md#coaviewsdelete) | **DELETE** /api/v1/clients/{clientId}/coaViews/{id} | Delete coaView
*COAViewsApi* | [**COAViewsGet**](docs/COAViewsApi.md#coaviewsget) | **GET** /api/v1/clients/{clientId}/coaviews | get list of coaViews
*COAViewsApi* | [**COAViewsGet_0**](docs/COAViewsApi.md#coaviewsget_0) | **GET** /api/v1/clients/{clientId}/coaviews/{id} | Get coaView by id
*COAViewsApi* | [**COAViewsPost**](docs/COAViewsApi.md#coaviewspost) | **POST** /api/v1/clients/{clientId}/coaViews | Save coaView
*COAsApi* | [**COAsDelete**](docs/COAsApi.md#coasdelete) | **DELETE** /api/v1/clients/{clientId}/coas/{id} | Delete coa
*COAsApi* | [**COAsGet**](docs/COAsApi.md#coasget) | **GET** /api/v1/clients/{clientId}/coas | get list of coas
*COAsApi* | [**COAsGet_0**](docs/COAsApi.md#coasget_0) | **GET** /api/v1/clients/{clientId}/coas/{id} | gets coa by id
*COAsApi* | [**COAsPost**](docs/COAsApi.md#coaspost) | **POST** /api/v1/clients/{clientId}/coas | Save coa
*ChartsApi* | [**ChartsGetFormulaList**](docs/ChartsApi.md#chartsgetformulalist) | **GET** /api/v1/clients/{clientId}/charts/formula/templates | Gets list of MIS formulas trees of client
*ChartsApi* | [**ChartsGetFormulaStatement**](docs/ChartsApi.md#chartsgetformulastatement) | **GET** /api/v1/clients/{clientId}/charts/formula | Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12
*ChartsApi* | [**ChartsGetStatement**](docs/ChartsApi.md#chartsgetstatement) | **GET** /api/v1/clients/{clientId}/charts/statement | Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12
*ChartsApi* | [**ChartsValidateFormula**](docs/ChartsApi.md#chartsvalidateformula) | **GET** /api/v1/clients/{clientId}/charts/formula/validate | Validates given formula for errors
*ClientSettingsApi* | [**ClientSettingsDelete**](docs/ClientSettingsApi.md#clientsettingsdelete) | **DELETE** /api/v1/clients/{clientId}/settings/{name} | Delete settings by name
*ClientSettingsApi* | [**ClientSettingsGet**](docs/ClientSettingsApi.md#clientsettingsget) | **GET** /api/v1/clients/{clientId}/settings | get list of settings names
*ClientSettingsApi* | [**ClientSettingsGet_0**](docs/ClientSettingsApi.md#clientsettingsget_0) | **GET** /api/v1/clients/{clientId}/settings/{name} | get settings by names
*ClientSettingsApi* | [**ClientSettingsPost**](docs/ClientSettingsApi.md#clientsettingspost) | **POST** /api/v1/clients/{clientId}/settings/{name} | save settings by name
*ClientsApi* | [**ClientsGet**](docs/ClientsApi.md#clientsget) | **GET** /api/v1/clients | Retreives list of client
*ClientsApi* | [**ClientsGet_0**](docs/ClientsApi.md#clientsget_0) | **GET** /api/v1/clients/{id} | Retreives a client with specified unique identifier
*ClientsApi* | [**ClientsPost**](docs/ClientsApi.md#clientspost) | **POST** /api/v1/clients | Save client
*ClientsApi* | [**ClientsUnprotect**](docs/ClientsApi.md#clientsunprotect) | **POST** /api/v1/clients/{id}/unprotect | Unprotects client protected by password
*CostCentersApi* | [**CostCentersGet**](docs/CostCentersApi.md#costcentersget) | **GET** /api/v1/clients/{clientId}/costcenters | gets list of costCenters
*CostCentersApi* | [**CostCentersGetByCode**](docs/CostCentersApi.md#costcentersgetbycode) | **GET** /api/v1/clients/{clientId}/costcenters/byCode/{code} | Get costCenter by code
*CostCentersApi* | [**CostCentersGet_0**](docs/CostCentersApi.md#costcentersget_0) | **GET** /api/v1/clients/{clientId}/costcenters/{id} | Get costCenter by id
*CostCentersApi* | [**CostCentersPost**](docs/CostCentersApi.md#costcenterspost) | **POST** /api/v1/clients/{clientId}/costcenters | Save costCenter
*CountriesApi* | [**CountriesGet**](docs/CountriesApi.md#countriesget) | **GET** /api/v1/clients/{clientId}/countries | Retreives list of countries
*CountriesApi* | [**CountriesGetByCode**](docs/CountriesApi.md#countriesgetbycode) | **GET** /api/v1/clients/{clientId}/countries/bycode/{code} | Get country by code
*CountriesApi* | [**CountriesGet_0**](docs/CountriesApi.md#countriesget_0) | **GET** /api/v1/clients/{clientId}/countries/{id} | Get country by id
*CurrenciesApi* | [**CurrenciesGet**](docs/CurrenciesApi.md#currenciesget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies | Retreives list of currencies
*CurrenciesApi* | [**CurrenciesGetByCode**](docs/CurrenciesApi.md#currenciesgetbycode) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/bycode/{code} | Get country by code
*CurrenciesApi* | [**CurrenciesGet_0**](docs/CurrenciesApi.md#currenciesget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/bydate/{date} | Retreives list of currencies
*CurrenciesApi* | [**CurrenciesGet_1**](docs/CurrenciesApi.md#currenciesget_1) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/{id} | Get country by id
*CustomSettingsApi* | [**CustomSettingsDelete**](docs/CustomSettingsApi.md#customsettingsdelete) | **DELETE** /api/v1/customsettings/{name} | Delete settings by name
*CustomSettingsApi* | [**CustomSettingsGet**](docs/CustomSettingsApi.md#customsettingsget) | **GET** /api/v1/customsettings/{name} | Retreives custom settings by name
*CustomSettingsApi* | [**CustomSettingsGet_0**](docs/CustomSettingsApi.md#customsettingsget_0) | **GET** /api/v1/customsettings | Retreives custom settings list
*CustomSettingsApi* | [**CustomSettingsPost**](docs/CustomSettingsApi.md#customsettingspost) | **POST** /api/v1/customsettings/{name} | Save custom settings
*DefaultsApi* | [**DefaultsGet**](docs/DefaultsApi.md#defaultsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/defaults | Gets current defaults
*DepreciationsApi* | [**DepreciationsGet**](docs/DepreciationsApi.md#depreciationsget) | **GET** /api/v1/clients/{clientId}/depreciations | gets list of depreciations
*DepreciationsApi* | [**DepreciationsGet_0**](docs/DepreciationsApi.md#depreciationsget_0) | **GET** /api/v1/clients/{clientId}/depreciations/{id} | Get depreciation by id
*DocumentsApi* | [**DocumentsDelete**](docs/DocumentsApi.md#documentsdelete) | **DELETE** /api/v1/clients/{clientId}/documents | download report
*DocumentsApi* | [**DocumentsDownload**](docs/DocumentsApi.md#documentsdownload) | **GET** /api/v1/clients/{clientId}/documents/download | download report
*FiscalYearApi* | [**FiscalYearDelete**](docs/FiscalYearApi.md#fiscalyeardelete) | **DELETE** /api/v1/clients/{clientId}/fiscalyears/{id} | delete fiscal year by id
*FiscalYearApi* | [**FiscalYearGet**](docs/FiscalYearApi.md#fiscalyearget) | **GET** /api/v1/clients/{clientId}/fiscalyears | Retreives list of fiscal years
*FiscalYearApi* | [**FiscalYearGet_0**](docs/FiscalYearApi.md#fiscalyearget_0) | **GET** /api/v1/clients/{clientId}/fiscalyears/{id} | get fiscal year by id
*FiscalYearApi* | [**FiscalYearPost**](docs/FiscalYearApi.md#fiscalyearpost) | **POST** /api/v1/clients/{clientId}/fiscalyears | saves fiscal year
*InterestsApi* | [**InterestsGet**](docs/InterestsApi.md#interestsget) | **GET** /api/v1/clients/{clientId}/interests | get list of interests
*InterestsApi* | [**InterestsGet_0**](docs/InterestsApi.md#interestsget_0) | **GET** /api/v1/clients/{clientId}/interests/{id} | Get interest by id
*LanguagesApi* | [**LanguagesGet**](docs/LanguagesApi.md#languagesget) | **GET** /api/v1/clients/{clientId}/languages | Retreives list of languages
*LanguagesApi* | [**LanguagesGetByCode**](docs/LanguagesApi.md#languagesgetbycode) | **GET** /api/v1/clients/{clientId}/languages/bycode/{code} | Get language by code
*LanguagesApi* | [**LanguagesGet_0**](docs/LanguagesApi.md#languagesget_0) | **GET** /api/v1/clients/{clientId}/languages/{id} | Get language by id
*NumRangesApi* | [**NumRangesGet**](docs/NumRangesApi.md#numrangesget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/numranges | get list of numRanges
*NumRangesApi* | [**NumRangesGetByCode**](docs/NumRangesApi.md#numrangesgetbycode) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/numranges/bycode/{code} | Get numRange by code
*NumRangesApi* | [**NumRangesGet_0**](docs/NumRangesApi.md#numrangesget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/numranges/{id} | Get numRange by id
*PartiesApi* | [**PartiesDelete**](docs/PartiesApi.md#partiesdelete) | **DELETE** /api/v1/clients/{clientId}/parties/{id} | Delete party by id
*PartiesApi* | [**PartiesDeleteCreditor**](docs/PartiesApi.md#partiesdeletecreditor) | **DELETE** /api/v1/clients/{clientId}/parties/{id}/creditor | Delete creditor by party id
*PartiesApi* | [**PartiesDeleteDebtor**](docs/PartiesApi.md#partiesdeletedebtor) | **DELETE** /api/v1/clients/{clientId}/parties/{id}/debtor | Delete debtor by party id
*PartiesApi* | [**PartiesGet**](docs/PartiesApi.md#partiesget) | **GET** /api/v1/clients/{clientId}/parties | Retreives list of parties
*PartiesApi* | [**PartiesGetByFreeNumber**](docs/PartiesApi.md#partiesgetbyfreenumber) | **GET** /api/v1/clients/{clientId}/parties/byfreenumber/{freePartyNum} | Get party by freePartyNum
*PartiesApi* | [**PartiesGetByNumber**](docs/PartiesApi.md#partiesgetbynumber) | **GET** /api/v1/clients/{clientId}/parties/bynumber/{partyNum} | Get party by partyNum
*PartiesApi* | [**PartiesGet_0**](docs/PartiesApi.md#partiesget_0) | **GET** /api/v1/clients/{clientId}/parties/{id} | Get party by id
*PartiesApi* | [**PartiesPost**](docs/PartiesApi.md#partiespost) | **POST** /api/v1/clients/{clientId}/parties | Save party
*PartiesApi* | [**PartiesPost_0**](docs/PartiesApi.md#partiespost_0) | **POST** /api/v1/clients/{clientId}/parties/{id}/creditor | Assign creditor to party creditor
*PartiesApi* | [**PartiesPost_1**](docs/PartiesApi.md#partiespost_1) | **POST** /api/v1/clients/{clientId}/parties/{id}/debtor | Assign debtor to party
*PartnersApi* | [**PartnersGet**](docs/PartnersApi.md#partnersget) | **GET** /api/v1/clients/{clientId}/partners | get list of partners
*PartnersApi* | [**PartnersGet_0**](docs/PartnersApi.md#partnersget_0) | **GET** /api/v1/clients/{clientId}/partners/{id} | Get partner by id
*PayTermApi* | [**PayTermDelete**](docs/PayTermApi.md#paytermdelete) | **DELETE** /api/v1/clients/{clientId}/payTerms/{id} | Delete payTerm
*PayTermApi* | [**PayTermGet**](docs/PayTermApi.md#paytermget) | **GET** /api/v1/clients/{clientId}/payterms | Retreives list of payterms
*PayTermApi* | [**PayTermGetByCode**](docs/PayTermApi.md#paytermgetbycode) | **GET** /api/v1/clients/{clientId}/payterms/bycode/{code} | Get payTerm by code
*PayTermApi* | [**PayTermGet_0**](docs/PayTermApi.md#paytermget_0) | **GET** /api/v1/clients/{clientId}/payterms/{id} | Get payTerm by id
*PayTermApi* | [**PayTermPost**](docs/PayTermApi.md#paytermpost) | **POST** /api/v1/clients/{clientId}/payTerms | Save payTerm
*PayTypeApi* | [**PayTypeGet**](docs/PayTypeApi.md#paytypeget) | **GET** /api/v1/clients/{clientId}/paytypes | Retreives list of payTypes
*PayTypeApi* | [**PayTypeGetByCode**](docs/PayTypeApi.md#paytypegetbycode) | **GET** /api/v1/clients/{clientId}/paytypes/byname/{name} | Get payType by name
*PayTypeApi* | [**PayTypeGet_0**](docs/PayTypeApi.md#paytypeget_0) | **GET** /api/v1/clients/{clientId}/paytypes/{id} | Get payType by id
*PayablesApi* | [**PayablesDelete**](docs/PayablesApi.md#payablesdelete) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/{id} | Delete payables invoice by id
*PayablesApi* | [**PayablesDeleteManualPayment**](docs/PayablesApi.md#payablesdeletemanualpayment) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/manualpayments/{id} | delete manualPayment by id
*PayablesApi* | [**PayablesGet**](docs/PayablesApi.md#payablesget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices | Retreives list of payables invoices
*PayablesApi* | [**PayablesGetAll**](docs/PayablesApi.md#payablesgetall) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/all | Retreives list of payables invoices
*PayablesApi* | [**PayablesGetAllPartyInvoices**](docs/PayablesApi.md#payablesgetallpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{id}/invoices/all | Retreives list of party all payables invoices
*PayablesApi* | [**PayablesGetByFreeInvoiceNum**](docs/PayablesApi.md#payablesgetbyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/byfreeinvoicenum/{freeInvoiceNum} | Get payables invoice by freeInvoiceNum, return error if there is more than one invoice with this number
*PayablesApi* | [**PayablesGetByFreeInvoicesNum**](docs/PayablesApi.md#payablesgetbyfreeinvoicesnum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/byfreeinvoicenum/{freeInvoiceNum}/all | Get list of payables invoices by freeInvoiceNum
*PayablesApi* | [**PayablesGetByInvoiceNum**](docs/PayablesApi.md#payablesgetbyinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/byinvoicenum/{invoiceNum} | Get payables invoice by invoiceNum
*PayablesApi* | [**PayablesGetInvoicesByPeriod**](docs/PayablesApi.md#payablesgetinvoicesbyperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/byperiod | Retreives list of payables invoices by period
*PayablesApi* | [**PayablesGetManualPayment**](docs/PayablesApi.md#payablesgetmanualpayment) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/manualpayments/{id} | get manualPayment by id
*PayablesApi* | [**PayablesGetManualPayments**](docs/PayablesApi.md#payablesgetmanualpayments) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/manualpayments | Retreives list of Manual Payments
*PayablesApi* | [**PayablesGetOpen**](docs/PayablesApi.md#payablesgetopen) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/open | Retreives list of payables invoices
*PayablesApi* | [**PayablesGetOpenInvoicesByPeriod**](docs/PayablesApi.md#payablesgetopeninvoicesbyperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/open/byperiod | Retreives list of payables invoices by period
*PayablesApi* | [**PayablesGetOpenPartyInvoices**](docs/PayablesApi.md#payablesgetopenpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{id}/invoices/open | Retreives list of party open payables invoices
*PayablesApi* | [**PayablesGetPartyInvoiceByFreeInvoiceNum**](docs/PayablesApi.md#payablesgetpartyinvoicebyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{partyID}/invoices/byfreeinvoicenum/{freeInvoiceNum} | Get payables invoice by party ID and freeInvoiceNum, return error if there is more than one invoice with this number
*PayablesApi* | [**PayablesGetPartyInvoices**](docs/PayablesApi.md#payablesgetpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{id}/invoices | Retreives list of party payables invoices
*PayablesApi* | [**PayablesGetPartyInvoicesByFreeInvoiceNum**](docs/PayablesApi.md#payablesgetpartyinvoicesbyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{partyID}/invoices/byfreeinvoicenum/{freeInvoiceNum}/all | Get list of payables invoices by partyFID freeInvoiceNum
*PayablesApi* | [**PayablesGetPendingDocuments**](docs/PayablesApi.md#payablesgetpendingdocuments) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/documents/pending | get not procssed documents from dms
*PayablesApi* | [**PayablesGet_0**](docs/PayablesApi.md#payablesget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/{id} | Get payables invoice by id
*PayablesApi* | [**PayablesNew**](docs/PayablesApi.md#payablesnew) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/new | creates new invoice
*PayablesApi* | [**PayablesPayInvoice**](docs/PayablesApi.md#payablespayinvoice) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/{id}/pay | pay invoice by id
*PayablesApi* | [**PayablesPost**](docs/PayablesApi.md#payablespost) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices | Save payables invouce
*PayablesApi* | [**PayablesPostFromQrBill**](docs/PayablesApi.md#payablespostfromqrbill) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/qrbill | Creates payables invoice out of QrBill
*PayablesApi* | [**PayablesPostManualPayment**](docs/PayablesApi.md#payablespostmanualpayment) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/manualpayments | saves manualPayment
*PayablesApi* | [**PayablesUpload**](docs/PayablesApi.md#payablesupload) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/documents | create invoice from qrBill and save document to DMS
*ReceivablesApi* | [**ReceivablesDelete**](docs/ReceivablesApi.md#receivablesdelete) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/{id} | Delete receivables invoice by id
*ReceivablesApi* | [**ReceivablesDeleteManualPayment**](docs/ReceivablesApi.md#receivablesdeletemanualpayment) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/manualpayments/{id} | delete manualPayment by id
*ReceivablesApi* | [**ReceivablesGet**](docs/ReceivablesApi.md#receivablesget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices | Retreives list of receivables invoices
*ReceivablesApi* | [**ReceivablesGetAll**](docs/ReceivablesApi.md#receivablesgetall) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/all | Retreives list of receivables invoices
*ReceivablesApi* | [**ReceivablesGetAllPartyInvoices**](docs/ReceivablesApi.md#receivablesgetallpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{id}/invoices/all | Retreives list of party all receivables invoices
*ReceivablesApi* | [**ReceivablesGetByFreeInvoiceNum**](docs/ReceivablesApi.md#receivablesgetbyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/byfreeinvoicenum/{freeInvoiceNum} | Get receivables invoice by freeInvoiceNum, return error if there is more than one invoice with this number
*ReceivablesApi* | [**ReceivablesGetByFreeInvoicesNum**](docs/ReceivablesApi.md#receivablesgetbyfreeinvoicesnum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/byfreeinvoicenum/{freeInvoiceNum}/all | Get list of receivables invoices by freeInvoiceNum
*ReceivablesApi* | [**ReceivablesGetByInvoiceNum**](docs/ReceivablesApi.md#receivablesgetbyinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/byinvoicenum/{invoiceNum} | Get receivables invoice by invoiceNum
*ReceivablesApi* | [**ReceivablesGetInvoicesByPeriod**](docs/ReceivablesApi.md#receivablesgetinvoicesbyperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/byperiod | Retreives list of receivables invoices by period
*ReceivablesApi* | [**ReceivablesGetManualPayment**](docs/ReceivablesApi.md#receivablesgetmanualpayment) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/manualpayments/{id} | get manualPayment by id
*ReceivablesApi* | [**ReceivablesGetManualPayments**](docs/ReceivablesApi.md#receivablesgetmanualpayments) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/manualpayments | Retreives list of Manual Payments
*ReceivablesApi* | [**ReceivablesGetOpen**](docs/ReceivablesApi.md#receivablesgetopen) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/open | Retreives list of receivables invoices
*ReceivablesApi* | [**ReceivablesGetOpenInvoicesByPeriod**](docs/ReceivablesApi.md#receivablesgetopeninvoicesbyperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/open/byperiod | Retreives list of receivables invoices by period
*ReceivablesApi* | [**ReceivablesGetOpenPartyInvoices**](docs/ReceivablesApi.md#receivablesgetopenpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{id}/invoices/open | Retreives list of party open receivables invoices
*ReceivablesApi* | [**ReceivablesGetPartyInvoiceByFreeInvoiceNum**](docs/ReceivablesApi.md#receivablesgetpartyinvoicebyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{partyID}/invoices/byfreeinvoicenum/{freeInvoiceNum} | Get receivables invoice by party ID and freeInvoiceNum, return error if there is more than one invoice with this number
*ReceivablesApi* | [**ReceivablesGetPartyInvoices**](docs/ReceivablesApi.md#receivablesgetpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{id}/invoices | Retreives list of party receivables invoices
*ReceivablesApi* | [**ReceivablesGetPartyInvoicesByFreeInvoiceNum**](docs/ReceivablesApi.md#receivablesgetpartyinvoicesbyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{partyID}/invoices/byfreeinvoicenum/{freeInvoiceNum}/all | Get list of receivables invoices by partyFID freeInvoiceNum
*ReceivablesApi* | [**ReceivablesGet_0**](docs/ReceivablesApi.md#receivablesget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/{id} | Get receivables invoice by id
*ReceivablesApi* | [**ReceivablesNew**](docs/ReceivablesApi.md#receivablesnew) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/new | creates new invoice
*ReceivablesApi* | [**ReceivablesPayInvoice**](docs/ReceivablesApi.md#receivablespayinvoice) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/{id}/pay | pay invoice by id
*ReceivablesApi* | [**ReceivablesPost**](docs/ReceivablesApi.md#receivablespost) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices | Save receivables invouce
*ReceivablesApi* | [**ReceivablesPostManualPayment**](docs/ReceivablesApi.md#receivablespostmanualpayment) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/manualpayments | saves manualPayment
*RepLanguageApi* | [**RepLanguageGet**](docs/RepLanguageApi.md#replanguageget) | **GET** /api/v1/clients/{clientId}/replanguages | Retreives list of report languages
*RepLanguageApi* | [**RepLanguageGet_0**](docs/RepLanguageApi.md#replanguageget_0) | **GET** /api/v1/clients/{clientId}/replanguages/{id} | get report language by id
*ReportJobApi* | [**ReportJobGet**](docs/ReportJobApi.md#reportjobget) | **GET** /api/v1/clients/{clientId}/reportjobs | Retreives list of report jobs
*ReportJobApi* | [**ReportJobGet_0**](docs/ReportJobApi.md#reportjobget_0) | **GET** /api/v1/clients/{clientId}/reportjobs/{id} | get report job by id
*ReportsApi* | [**ReportsDownload**](docs/ReportsApi.md#reportsdownload) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/download | download report
*ReportsApi* | [**ReportsDownloadWithFilter**](docs/ReportsApi.md#reportsdownloadwithfilter) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/downloadwithfilter | Post report filter and apply it to report
*ReportsApi* | [**ReportsGet**](docs/ReportsApi.md#reportsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports | get list of reports
*ReportsApi* | [**ReportsGetReportFilter**](docs/ReportsApi.md#reportsgetreportfilter) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/reportfilter | gets report filter
*ReportsApi* | [**ReportsGet_0**](docs/ReportsApi.md#reportsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id} | get list of reports
*ReportsApi* | [**ReportsPostReportFilter**](docs/ReportsApi.md#reportspostreportfilter) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/reportfilter | gets report filter
*ReportsApi* | [**ReportsPreview**](docs/ReportsApi.md#reportspreview) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/preview | preview report
*TransactionsApi* | [**TransactionsCreatePosting**](docs/TransactionsApi.md#transactionscreateposting) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/posting | create posting based on optinal parameters
*TransactionsApi* | [**TransactionsDelete**](docs/TransactionsApi.md#transactionsdelete) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id} | delete transaction
*TransactionsApi* | [**TransactionsDeleteDocument**](docs/TransactionsApi.md#transactionsdeletedocument) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id}/document | delete document
*TransactionsApi* | [**TransactionsDownloadDocument**](docs/TransactionsApi.md#transactionsdownloaddocument) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id}/document | download document
*TransactionsApi* | [**TransactionsGet**](docs/TransactionsApi.md#transactionsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id} | get transaction by id
*TransactionsApi* | [**TransactionsGetByDocNum**](docs/TransactionsApi.md#transactionsgetbydocnum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/bydocnum/{docNum} | get transaction by docNum
*TransactionsApi* | [**TransactionsGetPendingDocuments**](docs/TransactionsApi.md#transactionsgetpendingdocuments) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/documents/pending | get not procssed documents from dms
*TransactionsApi* | [**TransactionsGetVatPosting**](docs/TransactionsApi.md#transactionsgetvatposting) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPosting | create posting with calculated vat amounts
*TransactionsApi* | [**TransactionsGet_0**](docs/TransactionsApi.md#transactionsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions | get all transactions within fiscal year
*TransactionsApi* | [**TransactionsLinkDocument**](docs/TransactionsApi.md#transactionslinkdocument) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id}/document | link document
*TransactionsApi* | [**TransactionsNew**](docs/TransactionsApi.md#transactionsnew) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/new/{transactionType} | creates new transaction of given type
*TransactionsApi* | [**TransactionsPost**](docs/TransactionsApi.md#transactionspost) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions | saves transaction
*TransactionsApi* | [**TransactionsUpload**](docs/TransactionsApi.md#transactionsupload) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/documents | save  document to DMS as unrecognized transaction
*UserAccountApi* | [**UserAccountChangePassword**](docs/UserAccountApi.md#useraccountchangepassword) | **POST** /api/v1/useraccount/changepassword | Change user password
*UserAccountApi* | [**UserAccountGet**](docs/UserAccountApi.md#useraccountget) | **GET** /api/v1/useraccounts | Retreives list of user accounts
*UserAccountApi* | [**UserAccountGetLocalization**](docs/UserAccountApi.md#useraccountgetlocalization) | **GET** /api/v1/useraccount/localization | Get current user localization
*UserAccountApi* | [**UserAccountLogout**](docs/UserAccountApi.md#useraccountlogout) | **GET** /api/v1/useraccount/logout | Disconnects from topal server
*UserAccountApi* | [**UserAccountProfile**](docs/UserAccountApi.md#useraccountprofile) | **GET** /api/v1/useraccount/profile | Get user profile data
*UserAccountApi* | [**UserAccountSaveLocalization**](docs/UserAccountApi.md#useraccountsavelocalization) | **POST** /api/v1/useraccount/localization/{localization} | Change user localization
*UserAccountApi* | [**UserAccountSaveProfile**](docs/UserAccountApi.md#useraccountsaveprofile) | **POST** /api/v1/useraccount/profile | Save user profile data
*VATsApi* | [**VATsGet**](docs/VATsApi.md#vatsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats | Get list of VATs (depricated: use vats/bydate instead )
*VATsApi* | [**VATsGetByCode**](docs/VATsApi.md#vatsgetbycode) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/bycode/{code} | Get VAT by code
*VATsApi* | [**VATsGetByCode_0**](docs/VATsApi.md#vatsgetbycode_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats/bycode/{code} | Get VAT by code
*VATsApi* | [**VATsGetByVatPeriod**](docs/VATsApi.md#vatsgetbyvatperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats | Get list of VATs by vatPeriodId
*VATsApi* | [**VATsGet_0**](docs/VATsApi.md#vatsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/bydate | Get list of VATs of period of given date
*VATsApi* | [**VATsGet_1**](docs/VATsApi.md#vatsget_1) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/{id} | Get VAT by id
*VATsApi* | [**VATsGet_2**](docs/VATsApi.md#vatsget_2) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats/{id} | Get VAT by id


<a name="documentation-for-models"></a>
## Documentation for Models

 - [Model.Account](docs/Account.md)
 - [Model.AccountArea](docs/AccountArea.md)
 - [Model.AccountSummary](docs/AccountSummary.md)
 - [Model.BalancePosting](docs/BalancePosting.md)
 - [Model.Bank](docs/Bank.md)
 - [Model.BankAccount](docs/BankAccount.md)
 - [Model.Budget](docs/Budget.md)
 - [Model.COA](docs/COA.md)
 - [Model.COATreeView](docs/COATreeView.md)
 - [Model.COAView](docs/COAView.md)
 - [Model.ChangePassword](docs/ChangePassword.md)
 - [Model.CostCenter](docs/CostCenter.md)
 - [Model.CostCenterMethod](docs/CostCenterMethod.md)
 - [Model.Country](docs/Country.md)
 - [Model.Creditor](docs/Creditor.md)
 - [Model.Currency](docs/Currency.md)
 - [Model.CurrencyRate](docs/CurrencyRate.md)
 - [Model.Debtor](docs/Debtor.md)
 - [Model.Defaults](docs/Defaults.md)
 - [Model.Depreciation](docs/Depreciation.md)
 - [Model.Document](docs/Document.md)
 - [Model.FiscalYear](docs/FiscalYear.md)
 - [Model.FormulaStatement](docs/FormulaStatement.md)
 - [Model.Interest](docs/Interest.md)
 - [Model.Invoice](docs/Invoice.md)
 - [Model.Language](docs/Language.md)
 - [Model.MisFormulaTree](docs/MisFormulaTree.md)
 - [Model.MisTreeItem](docs/MisTreeItem.md)
 - [Model.ModelClient](docs/ModelClient.md)
 - [Model.NumRange](docs/NumRange.md)
 - [Model.Partner](docs/Partner.md)
 - [Model.Party](docs/Party.md)
 - [Model.PayMethod](docs/PayMethod.md)
 - [Model.PayTerm](docs/PayTerm.md)
 - [Model.PayTermDetail](docs/PayTermDetail.md)
 - [Model.PayType](docs/PayType.md)
 - [Model.Payment](docs/Payment.md)
 - [Model.PaymentDetail](docs/PaymentDetail.md)
 - [Model.Period](docs/Period.md)
 - [Model.PeriodBalance](docs/PeriodBalance.md)
 - [Model.PeriodFormula](docs/PeriodFormula.md)
 - [Model.Person](docs/Person.md)
 - [Model.Posting](docs/Posting.md)
 - [Model.QrBill](docs/QrBill.md)
 - [Model.RepLanguage](docs/RepLanguage.md)
 - [Model.Report](docs/Report.md)
 - [Model.ReportFilter](docs/ReportFilter.md)
 - [Model.ReportJob](docs/ReportJob.md)
 - [Model.Statement](docs/Statement.md)
 - [Model.StatementItem](docs/StatementItem.md)
 - [Model.Transaction](docs/Transaction.md)
 - [Model.UserAccount](docs/UserAccount.md)
 - [Model.VAT](docs/VAT.md)
 - [Model.VATPeriod](docs/VATPeriod.md)


<a name="documentation-for-authorization"></a>
## Documentation for Authorization

<a name="Token"></a>
### Token

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header

