# IO.Swagger.Api.AccountAreasApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**AccountAreasDelete**](AccountAreasApi.md#accountareasdelete) | **DELETE** /api/v1/clients/{clientId}/accountAreas/{id} | Delete AccountArea
[**AccountAreasGet**](AccountAreasApi.md#accountareasget) | **GET** /api/v1/clients/{clientId}/accountareas | get list of accountAreas
[**AccountAreasGet_0**](AccountAreasApi.md#accountareasget_0) | **GET** /api/v1/clients/{clientId}/accountareas/{id} | Get accountArea by id
[**AccountAreasPost**](AccountAreasApi.md#accountareaspost) | **POST** /api/v1/clients/{clientId}/accountAreas | Save AccountArea


<a name="accountareasdelete"></a>
# **AccountAreasDelete**
> Object AccountAreasDelete (int? id, string clientId)

Delete AccountArea

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountAreasDeleteExample
    {
        public void main()
        {
            var apiInstance = new AccountAreasApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete AccountArea
                Object result = apiInstance.AccountAreasDelete(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountAreasApi.AccountAreasDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountareasget"></a>
# **AccountAreasGet**
> List<AccountArea> AccountAreasGet (string clientId)

get list of accountAreas

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountAreasGetExample
    {
        public void main()
        {
            var apiInstance = new AccountAreasApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // get list of accountAreas
                List&lt;AccountArea&gt; result = apiInstance.AccountAreasGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountAreasApi.AccountAreasGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<AccountArea>**](AccountArea.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountareasget_0"></a>
# **AccountAreasGet_0**
> AccountArea AccountAreasGet_0 (int? id, string clientId)

Get accountArea by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountAreasGet_0Example
    {
        public void main()
        {
            var apiInstance = new AccountAreasApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get accountArea by id
                AccountArea result = apiInstance.AccountAreasGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountAreasApi.AccountAreasGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**AccountArea**](AccountArea.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountareaspost"></a>
# **AccountAreasPost**
> AccountArea AccountAreasPost (AccountArea accountArea, string clientId)

Save AccountArea

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountAreasPostExample
    {
        public void main()
        {
            var apiInstance = new AccountAreasApi();
            var accountArea = new AccountArea(); // AccountArea | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Save AccountArea
                AccountArea result = apiInstance.AccountAreasPost(accountArea, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountAreasApi.AccountAreasPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountArea** | [**AccountArea**](AccountArea.md)|  | 
 **clientId** | **string**|  | 

### Return type

[**AccountArea**](AccountArea.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

