# IO.Swagger.Api.AccountsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**AccountsGet**](AccountsApi.md#accountsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts | Gets list of accounts
[**AccountsGetStatement**](AccountsApi.md#accountsgetstatement) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}/statement | get account statement
[**AccountsGetSummary**](AccountsApi.md#accountsgetsummary) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}/summary | get account summary
[**AccountsGet_0**](AccountsApi.md#accountsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id} | Gets account by id


<a name="accountsget"></a>
# **AccountsGet**
> List<Account> AccountsGet (string clientId, string fiscalYearId)

Gets list of accounts

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountsGetExample
    {
        public void main()
        {
            var apiInstance = new AccountsApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Gets list of accounts
                List&lt;Account&gt; result = apiInstance.AccountsGet(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountsApi.AccountsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Account>**](Account.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountsgetstatement"></a>
# **AccountsGetStatement**
> List<BalancePosting> AccountsGetStatement (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId, bool? selectContraPostings = null)

get account statement

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountsGetStatementExample
    {
        public void main()
        {
            var apiInstance = new AccountsApi();
            var id = 56;  // int? | 
            var dateFrom = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var dateUntil = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 
            var selectContraPostings = true;  // bool? |  (optional) 

            try
            {
                // get account statement
                List&lt;BalancePosting&gt; result = apiInstance.AccountsGetStatement(id, dateFrom, dateUntil, clientId, fiscalYearId, selectContraPostings);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountsApi.AccountsGetStatement: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **dateFrom** | **DateTime?**|  | 
 **dateUntil** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 
 **selectContraPostings** | **bool?**|  | [optional] 

### Return type

[**List<BalancePosting>**](BalancePosting.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountsgetsummary"></a>
# **AccountsGetSummary**
> AccountSummary AccountsGetSummary (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId)

get account summary

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountsGetSummaryExample
    {
        public void main()
        {
            var apiInstance = new AccountsApi();
            var id = 56;  // int? | 
            var dateFrom = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var dateUntil = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get account summary
                AccountSummary result = apiInstance.AccountsGetSummary(id, dateFrom, dateUntil, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountsApi.AccountsGetSummary: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **dateFrom** | **DateTime?**|  | 
 **dateUntil** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**AccountSummary**](AccountSummary.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountsget_0"></a>
# **AccountsGet_0**
> Account AccountsGet_0 (int? id, string clientId, string fiscalYearId)

Gets account by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountsGet_0Example
    {
        public void main()
        {
            var apiInstance = new AccountsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Gets account by id
                Account result = apiInstance.AccountsGet_0(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountsApi.AccountsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Account**](Account.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

