# IO.Swagger.Api.BankAccountApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**BankAccountDelete**](BankAccountApi.md#bankaccountdelete) | **DELETE** /api/v1/clients/{clientId}/bankaccounts/{id} | Delete bankAccount
[**BankAccountGet**](BankAccountApi.md#bankaccountget) | **GET** /api/v1/clients/{clientId}/bankaccounts | Retreives list of bankAccounts
[**BankAccountGet_0**](BankAccountApi.md#bankaccountget_0) | **GET** /api/v1/clients/{clientId}/bankaccounts/{id} | Get bankAccount by id
[**BankAccountGet_1**](BankAccountApi.md#bankaccountget_1) | **GET** /api/v1/clients/{clientId}/bankaccounts/byname/{name} | Get bankAccount by name
[**BankAccountPost**](BankAccountApi.md#bankaccountpost) | **POST** /api/v1/clients/{clientId}/bankaccounts | Save bankAccount


<a name="bankaccountdelete"></a>
# **BankAccountDelete**
> Object BankAccountDelete (int? id, string clientId)

Delete bankAccount

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BankAccountDeleteExample
    {
        public void main()
        {
            var apiInstance = new BankAccountApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete bankAccount
                Object result = apiInstance.BankAccountDelete(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BankAccountApi.BankAccountDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="bankaccountget"></a>
# **BankAccountGet**
> List<BankAccount> BankAccountGet (string clientId)

Retreives list of bankAccounts

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BankAccountGetExample
    {
        public void main()
        {
            var apiInstance = new BankAccountApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of bankAccounts
                List&lt;BankAccount&gt; result = apiInstance.BankAccountGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BankAccountApi.BankAccountGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<BankAccount>**](BankAccount.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="bankaccountget_0"></a>
# **BankAccountGet_0**
> BankAccount BankAccountGet_0 (int? id, string clientId)

Get bankAccount by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BankAccountGet_0Example
    {
        public void main()
        {
            var apiInstance = new BankAccountApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get bankAccount by id
                BankAccount result = apiInstance.BankAccountGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BankAccountApi.BankAccountGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**BankAccount**](BankAccount.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="bankaccountget_1"></a>
# **BankAccountGet_1**
> BankAccount BankAccountGet_1 (string name, string clientId)

Get bankAccount by name

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BankAccountGet_1Example
    {
        public void main()
        {
            var apiInstance = new BankAccountApi();
            var name = name_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get bankAccount by name
                BankAccount result = apiInstance.BankAccountGet_1(name, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BankAccountApi.BankAccountGet_1: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

[**BankAccount**](BankAccount.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="bankaccountpost"></a>
# **BankAccountPost**
> BankAccount BankAccountPost (BankAccount bankAccount, string clientId)

Save bankAccount

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BankAccountPostExample
    {
        public void main()
        {
            var apiInstance = new BankAccountApi();
            var bankAccount = new BankAccount(); // BankAccount | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Save bankAccount
                BankAccount result = apiInstance.BankAccountPost(bankAccount, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BankAccountApi.BankAccountPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bankAccount** | [**BankAccount**](BankAccount.md)|  | 
 **clientId** | **string**|  | 

### Return type

[**BankAccount**](BankAccount.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

