# IO.Swagger.Api.BanksApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**BanksDelete**](BanksApi.md#banksdelete) | **DELETE** /api/v1/clients/{clientId}/banks/{id} | Delete bank
[**BanksGet**](BanksApi.md#banksget) | **GET** /api/v1/clients/{clientId}/banks | Retreives list of banks
[**BanksGetByCode**](BanksApi.md#banksgetbycode) | **GET** /api/v1/clients/{clientId}/banks/bycode/{code} | Get bank by code
[**BanksGet_0**](BanksApi.md#banksget_0) | **GET** /api/v1/clients/{clientId}/banks/{id} | Get bank by id
[**BanksPost**](BanksApi.md#bankspost) | **POST** /api/v1/clients/{clientId}/banks | Save bank


<a name="banksdelete"></a>
# **BanksDelete**
> Object BanksDelete (int? id, string clientId)

Delete bank

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BanksDeleteExample
    {
        public void main()
        {
            var apiInstance = new BanksApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete bank
                Object result = apiInstance.BanksDelete(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BanksApi.BanksDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="banksget"></a>
# **BanksGet**
> List<Bank> BanksGet (string clientId)

Retreives list of banks

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BanksGetExample
    {
        public void main()
        {
            var apiInstance = new BanksApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of banks
                List&lt;Bank&gt; result = apiInstance.BanksGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BanksApi.BanksGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<Bank>**](Bank.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="banksgetbycode"></a>
# **BanksGetByCode**
> Bank BanksGetByCode (string code, string clientId)

Get bank by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BanksGetByCodeExample
    {
        public void main()
        {
            var apiInstance = new BanksApi();
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get bank by code
                Bank result = apiInstance.BanksGetByCode(code, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BanksApi.BanksGetByCode: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

[**Bank**](Bank.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="banksget_0"></a>
# **BanksGet_0**
> Bank BanksGet_0 (int? id, string clientId)

Get bank by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BanksGet_0Example
    {
        public void main()
        {
            var apiInstance = new BanksApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get bank by id
                Bank result = apiInstance.BanksGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BanksApi.BanksGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Bank**](Bank.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="bankspost"></a>
# **BanksPost**
> Bank BanksPost (Bank bank, string clientId)

Save bank

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BanksPostExample
    {
        public void main()
        {
            var apiInstance = new BanksApi();
            var bank = new Bank(); // Bank | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Save bank
                Bank result = apiInstance.BanksPost(bank, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BanksApi.BanksPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bank** | [**Bank**](Bank.md)|  | 
 **clientId** | **string**|  | 

### Return type

[**Bank**](Bank.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

