# IO.Swagger.Api.BudgetApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**BudgetGet**](BudgetApi.md#budgetget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/budgets | Retreives list of buget
[**BudgetGet_0**](BudgetApi.md#budgetget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/budgets/{id} | Get budget by id


<a name="budgetget"></a>
# **BudgetGet**
> List<Budget> BudgetGet (string clientId, string fiscalYearId)

Retreives list of buget

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BudgetGetExample
    {
        public void main()
        {
            var apiInstance = new BudgetApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of buget
                List&lt;Budget&gt; result = apiInstance.BudgetGet(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BudgetApi.BudgetGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Budget>**](Budget.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="budgetget_0"></a>
# **BudgetGet_0**
> Budget BudgetGet_0 (int? id, string clientId, string fiscalYearId)

Get budget by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class BudgetGet_0Example
    {
        public void main()
        {
            var apiInstance = new BudgetApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get budget by id
                Budget result = apiInstance.BudgetGet_0(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling BudgetApi.BudgetGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Budget**](Budget.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

