# IO.Swagger.Api.COATreeViewsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**COATreeViewsDelete**](COATreeViewsApi.md#coatreeviewsdelete) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coaTreeViews/{id} | Delete coaTreeViewTreeView
[**COATreeViewsGet**](COATreeViewsApi.md#coatreeviewsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews | get list of coatreeViews
[**COATreeViewsGetByCOA**](COATreeViewsApi.md#coatreeviewsgetbycoa) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coas/{coaId}/coatreeviews | Get coaTreeView by id within given coa
[**COATreeViewsGet_0**](COATreeViewsApi.md#coatreeviewsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews/{id} | Get coaTreeView by id
[**COATreeViewsGet_1**](COATreeViewsApi.md#coatreeviewsget_1) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews/byCode/{code} | Get coaTreeView by code
[**COATreeViewsPost**](COATreeViewsApi.md#coatreeviewspost) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews |  saves CoaTreeView   COATreeView item type:  - Account &#x3D; 1  - COA Group &#x3D; 2  - Counter &#x3D; 3  - Mirror Account &#x3D; 4  - Account Copy &#x3D; 5  - Result &#x3D; 6  - Commentary Line &#x3D; 7


<a name="coatreeviewsdelete"></a>
# **COATreeViewsDelete**
> Object COATreeViewsDelete (int? id, string clientId, string fiscalYearId)

Delete coaTreeViewTreeView

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COATreeViewsDeleteExample
    {
        public void main()
        {
            var apiInstance = new COATreeViewsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Delete coaTreeViewTreeView
                Object result = apiInstance.COATreeViewsDelete(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COATreeViewsApi.COATreeViewsDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coatreeviewsget"></a>
# **COATreeViewsGet**
> List<COATreeView> COATreeViewsGet (string clientId, string fiscalYearId)

get list of coatreeViews

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COATreeViewsGetExample
    {
        public void main()
        {
            var apiInstance = new COATreeViewsApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get list of coatreeViews
                List&lt;COATreeView&gt; result = apiInstance.COATreeViewsGet(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COATreeViewsApi.COATreeViewsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<COATreeView>**](COATreeView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coatreeviewsgetbycoa"></a>
# **COATreeViewsGetByCOA**
> List<COATreeView> COATreeViewsGetByCOA (int? coaId, string clientId, string fiscalYearId)

Get coaTreeView by id within given coa

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COATreeViewsGetByCOAExample
    {
        public void main()
        {
            var apiInstance = new COATreeViewsApi();
            var coaId = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get coaTreeView by id within given coa
                List&lt;COATreeView&gt; result = apiInstance.COATreeViewsGetByCOA(coaId, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COATreeViewsApi.COATreeViewsGetByCOA: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **coaId** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<COATreeView>**](COATreeView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coatreeviewsget_0"></a>
# **COATreeViewsGet_0**
> COATreeView COATreeViewsGet_0 (int? id, string clientId, string fiscalYearId)

Get coaTreeView by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COATreeViewsGet_0Example
    {
        public void main()
        {
            var apiInstance = new COATreeViewsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get coaTreeView by id
                COATreeView result = apiInstance.COATreeViewsGet_0(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COATreeViewsApi.COATreeViewsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**COATreeView**](COATreeView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coatreeviewsget_1"></a>
# **COATreeViewsGet_1**
> COATreeView COATreeViewsGet_1 (string code, string clientId, string fiscalYearId)

Get coaTreeView by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COATreeViewsGet_1Example
    {
        public void main()
        {
            var apiInstance = new COATreeViewsApi();
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get coaTreeView by code
                COATreeView result = apiInstance.COATreeViewsGet_1(code, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COATreeViewsApi.COATreeViewsGet_1: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**COATreeView**](COATreeView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coatreeviewspost"></a>
# **COATreeViewsPost**
> COATreeView COATreeViewsPost (COATreeView coaTreeView, string clientId, string fiscalYearId, string parentGroupCode = null)

 saves CoaTreeView   COATreeView item type:  - Account = 1  - COA Group = 2  - Counter = 3  - Mirror Account = 4  - Account Copy = 5  - Result = 6  - Commentary Line = 7

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COATreeViewsPostExample
    {
        public void main()
        {
            var apiInstance = new COATreeViewsApi();
            var coaTreeView = new COATreeView(); // COATreeView | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 
            var parentGroupCode = parentGroupCode_example;  // string | parent group (optional) 

            try
            {
                //  saves CoaTreeView   COATreeView item type:  - Account = 1  - COA Group = 2  - Counter = 3  - Mirror Account = 4  - Account Copy = 5  - Result = 6  - Commentary Line = 7
                COATreeView result = apiInstance.COATreeViewsPost(coaTreeView, clientId, fiscalYearId, parentGroupCode);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COATreeViewsApi.COATreeViewsPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **coaTreeView** | [**COATreeView**](COATreeView.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 
 **parentGroupCode** | **string**| parent group | [optional] 

### Return type

[**COATreeView**](COATreeView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

