# IO.Swagger.Api.COAViewsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**COAViewsDelete**](COAViewsApi.md#coaviewsdelete) | **DELETE** /api/v1/clients/{clientId}/coaViews/{id} | Delete coaView
[**COAViewsGet**](COAViewsApi.md#coaviewsget) | **GET** /api/v1/clients/{clientId}/coaviews | get list of coaViews
[**COAViewsGet_0**](COAViewsApi.md#coaviewsget_0) | **GET** /api/v1/clients/{clientId}/coaviews/{id} | Get coaView by id
[**COAViewsPost**](COAViewsApi.md#coaviewspost) | **POST** /api/v1/clients/{clientId}/coaViews | Save coaView


<a name="coaviewsdelete"></a>
# **COAViewsDelete**
> Object COAViewsDelete (int? id, string clientId)

Delete coaView

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COAViewsDeleteExample
    {
        public void main()
        {
            var apiInstance = new COAViewsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete coaView
                Object result = apiInstance.COAViewsDelete(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COAViewsApi.COAViewsDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coaviewsget"></a>
# **COAViewsGet**
> List<COAView> COAViewsGet (string clientId)

get list of coaViews

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COAViewsGetExample
    {
        public void main()
        {
            var apiInstance = new COAViewsApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // get list of coaViews
                List&lt;COAView&gt; result = apiInstance.COAViewsGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COAViewsApi.COAViewsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<COAView>**](COAView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coaviewsget_0"></a>
# **COAViewsGet_0**
> COAView COAViewsGet_0 (int? id, string clientId)

Get coaView by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COAViewsGet_0Example
    {
        public void main()
        {
            var apiInstance = new COAViewsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get coaView by id
                COAView result = apiInstance.COAViewsGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COAViewsApi.COAViewsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**COAView**](COAView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coaviewspost"></a>
# **COAViewsPost**
> COAView COAViewsPost (COAView coaView, string clientId)

Save coaView

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COAViewsPostExample
    {
        public void main()
        {
            var apiInstance = new COAViewsApi();
            var coaView = new COAView(); // COAView | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Save coaView
                COAView result = apiInstance.COAViewsPost(coaView, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COAViewsApi.COAViewsPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **coaView** | [**COAView**](COAView.md)|  | 
 **clientId** | **string**|  | 

### Return type

[**COAView**](COAView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

