# IO.Swagger.Api.COAsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**COAsDelete**](COAsApi.md#coasdelete) | **DELETE** /api/v1/clients/{clientId}/coas/{id} | Delete coa
[**COAsGet**](COAsApi.md#coasget) | **GET** /api/v1/clients/{clientId}/coas | get list of coas
[**COAsGet_0**](COAsApi.md#coasget_0) | **GET** /api/v1/clients/{clientId}/coas/{id} | gets coa by id
[**COAsPost**](COAsApi.md#coaspost) | **POST** /api/v1/clients/{clientId}/coas | Save coa


<a name="coasdelete"></a>
# **COAsDelete**
> Object COAsDelete (int? id, string clientId)

Delete coa

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COAsDeleteExample
    {
        public void main()
        {
            var apiInstance = new COAsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete coa
                Object result = apiInstance.COAsDelete(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COAsApi.COAsDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coasget"></a>
# **COAsGet**
> List<COA> COAsGet (string clientId)

get list of coas

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COAsGetExample
    {
        public void main()
        {
            var apiInstance = new COAsApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // get list of coas
                List&lt;COA&gt; result = apiInstance.COAsGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COAsApi.COAsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<COA>**](COA.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coasget_0"></a>
# **COAsGet_0**
> COA COAsGet_0 (int? id, string clientId)

gets coa by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COAsGet_0Example
    {
        public void main()
        {
            var apiInstance = new COAsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // gets coa by id
                COA result = apiInstance.COAsGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COAsApi.COAsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**COA**](COA.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="coaspost"></a>
# **COAsPost**
> COA COAsPost (COA coa, string clientId)

Save coa

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class COAsPostExample
    {
        public void main()
        {
            var apiInstance = new COAsApi();
            var coa = new COA(); // COA | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Save coa
                COA result = apiInstance.COAsPost(coa, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling COAsApi.COAsPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **coa** | [**COA**](COA.md)|  | 
 **clientId** | **string**|  | 

### Return type

[**COA**](COA.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

