# IO.Swagger.Api.ChartsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ChartsGetFormulaList**](ChartsApi.md#chartsgetformulalist) | **GET** /api/v1/clients/{clientId}/charts/formula/templates | Gets list of MIS formulas trees of client
[**ChartsGetFormulaStatement**](ChartsApi.md#chartsgetformulastatement) | **GET** /api/v1/clients/{clientId}/charts/formula | Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12
[**ChartsGetStatement**](ChartsApi.md#chartsgetstatement) | **GET** /api/v1/clients/{clientId}/charts/statement | Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12
[**ChartsValidateFormula**](ChartsApi.md#chartsvalidateformula) | **GET** /api/v1/clients/{clientId}/charts/formula/validate | Validates given formula for errors


<a name="chartsgetformulalist"></a>
# **ChartsGetFormulaList**
> List<MisFormulaTree> ChartsGetFormulaList (string clientId)

Gets list of MIS formulas trees of client

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ChartsGetFormulaListExample
    {
        public void main()
        {
            var apiInstance = new ChartsApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Gets list of MIS formulas trees of client
                List&lt;MisFormulaTree&gt; result = apiInstance.ChartsGetFormulaList(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ChartsApi.ChartsGetFormulaList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<MisFormulaTree>**](MisFormulaTree.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="chartsgetformulastatement"></a>
# **ChartsGetFormulaStatement**
> FormulaStatement ChartsGetFormulaStatement (string formula, DateTime? date, string periodName, int? periodsCount, string clientId)

Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ChartsGetFormulaStatementExample
    {
        public void main()
        {
            var apiInstance = new ChartsApi();
            var formula = formula_example;  // string | 
            var date = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var periodName = periodName_example;  // string | 
            var periodsCount = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12
                FormulaStatement result = apiInstance.ChartsGetFormulaStatement(formula, date, periodName, periodsCount, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ChartsApi.ChartsGetFormulaStatement: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **formula** | **string**|  | 
 **date** | **DateTime?**|  | 
 **periodName** | **string**|  | 
 **periodsCount** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**FormulaStatement**](FormulaStatement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="chartsgetstatement"></a>
# **ChartsGetStatement**
> Statement ChartsGetStatement (string code, DateTime? date, string periodName, int? periodsCount, string clientId)

Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ChartsGetStatementExample
    {
        public void main()
        {
            var apiInstance = new ChartsApi();
            var code = code_example;  // string | 
            var date = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var periodName = periodName_example;  // string | 
            var periodsCount = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12
                Statement result = apiInstance.ChartsGetStatement(code, date, periodName, periodsCount, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ChartsApi.ChartsGetStatement: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **date** | **DateTime?**|  | 
 **periodName** | **string**|  | 
 **periodsCount** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Statement**](Statement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="chartsvalidateformula"></a>
# **ChartsValidateFormula**
> string ChartsValidateFormula (string formula, string clientId)

Validates given formula for errors

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ChartsValidateFormulaExample
    {
        public void main()
        {
            var apiInstance = new ChartsApi();
            var formula = formula_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Validates given formula for errors
                string result = apiInstance.ChartsValidateFormula(formula, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ChartsApi.ChartsValidateFormula: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **formula** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

