# IO.Swagger.Api.ClientSettingsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ClientSettingsDelete**](ClientSettingsApi.md#clientsettingsdelete) | **DELETE** /api/v1/clients/{clientId}/settings/{name} | Delete settings by name
[**ClientSettingsGet**](ClientSettingsApi.md#clientsettingsget) | **GET** /api/v1/clients/{clientId}/settings | get list of settings names
[**ClientSettingsGet_0**](ClientSettingsApi.md#clientsettingsget_0) | **GET** /api/v1/clients/{clientId}/settings/{name} | get settings by names
[**ClientSettingsPost**](ClientSettingsApi.md#clientsettingspost) | **POST** /api/v1/clients/{clientId}/settings/{name} | save settings by name


<a name="clientsettingsdelete"></a>
# **ClientSettingsDelete**
> Object ClientSettingsDelete (string name, string clientId)

Delete settings by name

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ClientSettingsDeleteExample
    {
        public void main()
        {
            var apiInstance = new ClientSettingsApi();
            var name = name_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete settings by name
                Object result = apiInstance.ClientSettingsDelete(name, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClientSettingsApi.ClientSettingsDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="clientsettingsget"></a>
# **ClientSettingsGet**
> List<string> ClientSettingsGet (string clientId)

get list of settings names

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ClientSettingsGetExample
    {
        public void main()
        {
            var apiInstance = new ClientSettingsApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // get list of settings names
                List&lt;string&gt; result = apiInstance.ClientSettingsGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClientSettingsApi.ClientSettingsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

**List<string>**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="clientsettingsget_0"></a>
# **ClientSettingsGet_0**
> string ClientSettingsGet_0 (string name, string clientId)

get settings by names

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ClientSettingsGet_0Example
    {
        public void main()
        {
            var apiInstance = new ClientSettingsApi();
            var name = name_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // get settings by names
                string result = apiInstance.ClientSettingsGet_0(name, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClientSettingsApi.ClientSettingsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="clientsettingspost"></a>
# **ClientSettingsPost**
> string ClientSettingsPost (Object value, string name, string clientId)

save settings by name

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ClientSettingsPostExample
    {
        public void main()
        {
            var apiInstance = new ClientSettingsApi();
            var value = ;  // Object | 
            var name = name_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // save settings by name
                string result = apiInstance.ClientSettingsPost(value, name, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClientSettingsApi.ClientSettingsPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **value** | **Object**|  | 
 **name** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

