# IO.Swagger.Api.ClientsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ClientsGet**](ClientsApi.md#clientsget) | **GET** /api/v1/clients | Retreives list of client
[**ClientsGet_0**](ClientsApi.md#clientsget_0) | **GET** /api/v1/clients/{id} | Retreives a client with specified unique identifier
[**ClientsPost**](ClientsApi.md#clientspost) | **POST** /api/v1/clients | Save client
[**ClientsUnprotect**](ClientsApi.md#clientsunprotect) | **POST** /api/v1/clients/{id}/unprotect | Unprotects client protected by password


<a name="clientsget"></a>
# **ClientsGet**
> List<ModelClient> ClientsGet ()

Retreives list of client

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ClientsGetExample
    {
        public void main()
        {
            var apiInstance = new ClientsApi();

            try
            {
                // Retreives list of client
                List&lt;ModelClient&gt; result = apiInstance.ClientsGet();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClientsApi.ClientsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**List<ModelClient>**](ModelClient.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="clientsget_0"></a>
# **ClientsGet_0**
> ModelClient ClientsGet_0 (Guid? id)

Retreives a client with specified unique identifier

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ClientsGet_0Example
    {
        public void main()
        {
            var apiInstance = new ClientsApi();
            var id = new Guid?(); // Guid? | The uniue id of the client to retrieve

            try
            {
                // Retreives a client with specified unique identifier
                ModelClient result = apiInstance.ClientsGet_0(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClientsApi.ClientsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)| The uniue id of the client to retrieve | 

### Return type

[**ModelClient**](ModelClient.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="clientspost"></a>
# **ClientsPost**
> ModelClient ClientsPost (ModelClient _client)

Save client

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ClientsPostExample
    {
        public void main()
        {
            var apiInstance = new ClientsApi();
            var _client = new ModelClient(); // ModelClient | 

            try
            {
                // Save client
                ModelClient result = apiInstance.ClientsPost(_client);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClientsApi.ClientsPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **_client** | [**ModelClient**](ModelClient.md)|  | 

### Return type

[**ModelClient**](ModelClient.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="clientsunprotect"></a>
# **ClientsUnprotect**
> Object ClientsUnprotect (Guid? id, string password)

Unprotects client protected by password

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ClientsUnprotectExample
    {
        public void main()
        {
            var apiInstance = new ClientsApi();
            var id = new Guid?(); // Guid? | id of the client to unprotect
            var password = password_example;  // string | password

            try
            {
                // Unprotects client protected by password
                Object result = apiInstance.ClientsUnprotect(id, password);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ClientsApi.ClientsUnprotect: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)| id of the client to unprotect | 
 **password** | **string**| password | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

