# IO.Swagger.Api.CostCentersApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CostCentersGet**](CostCentersApi.md#costcentersget) | **GET** /api/v1/clients/{clientId}/costcenters | gets list of costCenters
[**CostCentersGetByCode**](CostCentersApi.md#costcentersgetbycode) | **GET** /api/v1/clients/{clientId}/costcenters/byCode/{code} | Get costCenter by code
[**CostCentersGet_0**](CostCentersApi.md#costcentersget_0) | **GET** /api/v1/clients/{clientId}/costcenters/{id} | Get costCenter by id
[**CostCentersPost**](CostCentersApi.md#costcenterspost) | **POST** /api/v1/clients/{clientId}/costcenters | Save costCenter


<a name="costcentersget"></a>
# **CostCentersGet**
> List<CostCenter> CostCentersGet (string clientId)

gets list of costCenters

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CostCentersGetExample
    {
        public void main()
        {
            var apiInstance = new CostCentersApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // gets list of costCenters
                List&lt;CostCenter&gt; result = apiInstance.CostCentersGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CostCentersApi.CostCentersGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<CostCenter>**](CostCenter.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="costcentersgetbycode"></a>
# **CostCentersGetByCode**
> CostCenter CostCentersGetByCode (string code, string clientId)

Get costCenter by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CostCentersGetByCodeExample
    {
        public void main()
        {
            var apiInstance = new CostCentersApi();
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get costCenter by code
                CostCenter result = apiInstance.CostCentersGetByCode(code, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CostCentersApi.CostCentersGetByCode: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

[**CostCenter**](CostCenter.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="costcentersget_0"></a>
# **CostCentersGet_0**
> CostCenter CostCentersGet_0 (int? id, string clientId)

Get costCenter by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CostCentersGet_0Example
    {
        public void main()
        {
            var apiInstance = new CostCentersApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get costCenter by id
                CostCenter result = apiInstance.CostCentersGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CostCentersApi.CostCentersGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**CostCenter**](CostCenter.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="costcenterspost"></a>
# **CostCentersPost**
> CostCenter CostCentersPost (CostCenter costCenter, string clientId)

Save costCenter

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CostCentersPostExample
    {
        public void main()
        {
            var apiInstance = new CostCentersApi();
            var costCenter = new CostCenter(); // CostCenter | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Save costCenter
                CostCenter result = apiInstance.CostCentersPost(costCenter, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CostCentersApi.CostCentersPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **costCenter** | [**CostCenter**](CostCenter.md)|  | 
 **clientId** | **string**|  | 

### Return type

[**CostCenter**](CostCenter.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

