# IO.Swagger.Api.CountriesApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CountriesGet**](CountriesApi.md#countriesget) | **GET** /api/v1/clients/{clientId}/countries | Retreives list of countries
[**CountriesGetByCode**](CountriesApi.md#countriesgetbycode) | **GET** /api/v1/clients/{clientId}/countries/bycode/{code} | Get country by code
[**CountriesGet_0**](CountriesApi.md#countriesget_0) | **GET** /api/v1/clients/{clientId}/countries/{id} | Get country by id


<a name="countriesget"></a>
# **CountriesGet**
> List<Country> CountriesGet (string clientId)

Retreives list of countries

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CountriesGetExample
    {
        public void main()
        {
            var apiInstance = new CountriesApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of countries
                List&lt;Country&gt; result = apiInstance.CountriesGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CountriesApi.CountriesGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<Country>**](Country.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="countriesgetbycode"></a>
# **CountriesGetByCode**
> Country CountriesGetByCode (string code, string clientId)

Get country by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CountriesGetByCodeExample
    {
        public void main()
        {
            var apiInstance = new CountriesApi();
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get country by code
                Country result = apiInstance.CountriesGetByCode(code, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CountriesApi.CountriesGetByCode: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

[**Country**](Country.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="countriesget_0"></a>
# **CountriesGet_0**
> Country CountriesGet_0 (int? id, string clientId)

Get country by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CountriesGet_0Example
    {
        public void main()
        {
            var apiInstance = new CountriesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get country by id
                Country result = apiInstance.CountriesGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CountriesApi.CountriesGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Country**](Country.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

