# IO.Swagger.Api.CurrenciesApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CurrenciesGet**](CurrenciesApi.md#currenciesget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies | Retreives list of currencies
[**CurrenciesGetByCode**](CurrenciesApi.md#currenciesgetbycode) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/bycode/{code} | Get country by code
[**CurrenciesGet_0**](CurrenciesApi.md#currenciesget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/bydate/{date} | Retreives list of currencies
[**CurrenciesGet_1**](CurrenciesApi.md#currenciesget_1) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/{id} | Get country by id


<a name="currenciesget"></a>
# **CurrenciesGet**
> List<Currency> CurrenciesGet (string clientId, string fiscalYearId)

Retreives list of currencies

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CurrenciesGetExample
    {
        public void main()
        {
            var apiInstance = new CurrenciesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of currencies
                List&lt;Currency&gt; result = apiInstance.CurrenciesGet(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CurrenciesApi.CurrenciesGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Currency>**](Currency.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="currenciesgetbycode"></a>
# **CurrenciesGetByCode**
> Currency CurrenciesGetByCode (string code, string clientId, string fiscalYearId)

Get country by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CurrenciesGetByCodeExample
    {
        public void main()
        {
            var apiInstance = new CurrenciesApi();
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get country by code
                Currency result = apiInstance.CurrenciesGetByCode(code, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CurrenciesApi.CurrenciesGetByCode: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Currency**](Currency.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="currenciesget_0"></a>
# **CurrenciesGet_0**
> List<Currency> CurrenciesGet_0 (DateTime? date, string clientId, string fiscalYearId)

Retreives list of currencies

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CurrenciesGet_0Example
    {
        public void main()
        {
            var apiInstance = new CurrenciesApi();
            var date = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of currencies
                List&lt;Currency&gt; result = apiInstance.CurrenciesGet_0(date, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CurrenciesApi.CurrenciesGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **date** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Currency>**](Currency.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="currenciesget_1"></a>
# **CurrenciesGet_1**
> Currency CurrenciesGet_1 (int? id, string clientId, string fiscalYearId)

Get country by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CurrenciesGet_1Example
    {
        public void main()
        {
            var apiInstance = new CurrenciesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get country by id
                Currency result = apiInstance.CurrenciesGet_1(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CurrenciesApi.CurrenciesGet_1: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Currency**](Currency.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

