# IO.Swagger.Api.CustomSettingsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**CustomSettingsDelete**](CustomSettingsApi.md#customsettingsdelete) | **DELETE** /api/v1/customsettings/{name} | Delete settings by name
[**CustomSettingsGet**](CustomSettingsApi.md#customsettingsget) | **GET** /api/v1/customsettings/{name} | Retreives custom settings by name
[**CustomSettingsGet_0**](CustomSettingsApi.md#customsettingsget_0) | **GET** /api/v1/customsettings | Retreives custom settings list
[**CustomSettingsPost**](CustomSettingsApi.md#customsettingspost) | **POST** /api/v1/customsettings/{name} | Save custom settings


<a name="customsettingsdelete"></a>
# **CustomSettingsDelete**
> Object CustomSettingsDelete (string name)

Delete settings by name

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CustomSettingsDeleteExample
    {
        public void main()
        {
            var apiInstance = new CustomSettingsApi();
            var name = name_example;  // string | 

            try
            {
                // Delete settings by name
                Object result = apiInstance.CustomSettingsDelete(name);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CustomSettingsApi.CustomSettingsDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="customsettingsget"></a>
# **CustomSettingsGet**
> Object CustomSettingsGet (string name)

Retreives custom settings by name

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CustomSettingsGetExample
    {
        public void main()
        {
            var apiInstance = new CustomSettingsApi();
            var name = name_example;  // string | 

            try
            {
                // Retreives custom settings by name
                Object result = apiInstance.CustomSettingsGet(name);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CustomSettingsApi.CustomSettingsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="customsettingsget_0"></a>
# **CustomSettingsGet_0**
> Object CustomSettingsGet_0 ()

Retreives custom settings list

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CustomSettingsGet_0Example
    {
        public void main()
        {
            var apiInstance = new CustomSettingsApi();

            try
            {
                // Retreives custom settings list
                Object result = apiInstance.CustomSettingsGet_0();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CustomSettingsApi.CustomSettingsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="customsettingspost"></a>
# **CustomSettingsPost**
> Object CustomSettingsPost (Object settings, string name)

Save custom settings

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CustomSettingsPostExample
    {
        public void main()
        {
            var apiInstance = new CustomSettingsApi();
            var settings = ;  // Object | 
            var name = name_example;  // string | 

            try
            {
                // Save custom settings
                Object result = apiInstance.CustomSettingsPost(settings, name);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling CustomSettingsApi.CustomSettingsPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **settings** | **Object**|  | 
 **name** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

