# IO.Swagger.Api.DepreciationsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**DepreciationsGet**](DepreciationsApi.md#depreciationsget) | **GET** /api/v1/clients/{clientId}/depreciations | gets list of depreciations
[**DepreciationsGet_0**](DepreciationsApi.md#depreciationsget_0) | **GET** /api/v1/clients/{clientId}/depreciations/{id} | Get depreciation by id


<a name="depreciationsget"></a>
# **DepreciationsGet**
> List<Depreciation> DepreciationsGet (string clientId)

gets list of depreciations

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DepreciationsGetExample
    {
        public void main()
        {
            var apiInstance = new DepreciationsApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // gets list of depreciations
                List&lt;Depreciation&gt; result = apiInstance.DepreciationsGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DepreciationsApi.DepreciationsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<Depreciation>**](Depreciation.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="depreciationsget_0"></a>
# **DepreciationsGet_0**
> Depreciation DepreciationsGet_0 (int? id, string clientId)

Get depreciation by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DepreciationsGet_0Example
    {
        public void main()
        {
            var apiInstance = new DepreciationsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get depreciation by id
                Depreciation result = apiInstance.DepreciationsGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DepreciationsApi.DepreciationsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Depreciation**](Depreciation.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

