# IO.Swagger.Api.FiscalYearApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**FiscalYearDelete**](FiscalYearApi.md#fiscalyeardelete) | **DELETE** /api/v1/clients/{clientId}/fiscalyears/{id} | delete fiscal year by id
[**FiscalYearGet**](FiscalYearApi.md#fiscalyearget) | **GET** /api/v1/clients/{clientId}/fiscalyears | Retreives list of fiscal years
[**FiscalYearGet_0**](FiscalYearApi.md#fiscalyearget_0) | **GET** /api/v1/clients/{clientId}/fiscalyears/{id} | get fiscal year by id
[**FiscalYearPost**](FiscalYearApi.md#fiscalyearpost) | **POST** /api/v1/clients/{clientId}/fiscalyears | saves fiscal year


<a name="fiscalyeardelete"></a>
# **FiscalYearDelete**
> Object FiscalYearDelete (int? id, string clientId)

delete fiscal year by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class FiscalYearDeleteExample
    {
        public void main()
        {
            var apiInstance = new FiscalYearApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // delete fiscal year by id
                Object result = apiInstance.FiscalYearDelete(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FiscalYearApi.FiscalYearDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="fiscalyearget"></a>
# **FiscalYearGet**
> List<FiscalYear> FiscalYearGet (string clientId)

Retreives list of fiscal years

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class FiscalYearGetExample
    {
        public void main()
        {
            var apiInstance = new FiscalYearApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of fiscal years
                List&lt;FiscalYear&gt; result = apiInstance.FiscalYearGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FiscalYearApi.FiscalYearGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<FiscalYear>**](FiscalYear.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="fiscalyearget_0"></a>
# **FiscalYearGet_0**
> FiscalYear FiscalYearGet_0 (int? id, string clientId)

get fiscal year by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class FiscalYearGet_0Example
    {
        public void main()
        {
            var apiInstance = new FiscalYearApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // get fiscal year by id
                FiscalYear result = apiInstance.FiscalYearGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FiscalYearApi.FiscalYearGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**FiscalYear**](FiscalYear.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="fiscalyearpost"></a>
# **FiscalYearPost**
> FiscalYear FiscalYearPost (FiscalYear fiscalYear, string clientId)

saves fiscal year

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class FiscalYearPostExample
    {
        public void main()
        {
            var apiInstance = new FiscalYearApi();
            var fiscalYear = new FiscalYear(); // FiscalYear | 
            var clientId = clientId_example;  // string | 

            try
            {
                // saves fiscal year
                FiscalYear result = apiInstance.FiscalYearPost(fiscalYear, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling FiscalYearApi.FiscalYearPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fiscalYear** | [**FiscalYear**](FiscalYear.md)|  | 
 **clientId** | **string**|  | 

### Return type

[**FiscalYear**](FiscalYear.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

