# IO.Swagger.Api.InterestsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**InterestsGet**](InterestsApi.md#interestsget) | **GET** /api/v1/clients/{clientId}/interests | get list of interests
[**InterestsGet_0**](InterestsApi.md#interestsget_0) | **GET** /api/v1/clients/{clientId}/interests/{id} | Get interest by id


<a name="interestsget"></a>
# **InterestsGet**
> List<Interest> InterestsGet (string clientId)

get list of interests

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InterestsGetExample
    {
        public void main()
        {
            var apiInstance = new InterestsApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // get list of interests
                List&lt;Interest&gt; result = apiInstance.InterestsGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling InterestsApi.InterestsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<Interest>**](Interest.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="interestsget_0"></a>
# **InterestsGet_0**
> Interest InterestsGet_0 (int? id, string clientId)

Get interest by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class InterestsGet_0Example
    {
        public void main()
        {
            var apiInstance = new InterestsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get interest by id
                Interest result = apiInstance.InterestsGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling InterestsApi.InterestsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Interest**](Interest.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

