# IO.Swagger.Api.LanguagesApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**LanguagesGet**](LanguagesApi.md#languagesget) | **GET** /api/v1/clients/{clientId}/languages | Retreives list of languages
[**LanguagesGetByCode**](LanguagesApi.md#languagesgetbycode) | **GET** /api/v1/clients/{clientId}/languages/bycode/{code} | Get language by code
[**LanguagesGet_0**](LanguagesApi.md#languagesget_0) | **GET** /api/v1/clients/{clientId}/languages/{id} | Get language by id


<a name="languagesget"></a>
# **LanguagesGet**
> List<Language> LanguagesGet (string clientId)

Retreives list of languages

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class LanguagesGetExample
    {
        public void main()
        {
            var apiInstance = new LanguagesApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of languages
                List&lt;Language&gt; result = apiInstance.LanguagesGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling LanguagesApi.LanguagesGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<Language>**](Language.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="languagesgetbycode"></a>
# **LanguagesGetByCode**
> Language LanguagesGetByCode (string code, string clientId)

Get language by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class LanguagesGetByCodeExample
    {
        public void main()
        {
            var apiInstance = new LanguagesApi();
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get language by code
                Language result = apiInstance.LanguagesGetByCode(code, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling LanguagesApi.LanguagesGetByCode: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

[**Language**](Language.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="languagesget_0"></a>
# **LanguagesGet_0**
> Language LanguagesGet_0 (int? id, string clientId)

Get language by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class LanguagesGet_0Example
    {
        public void main()
        {
            var apiInstance = new LanguagesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get language by id
                Language result = apiInstance.LanguagesGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling LanguagesApi.LanguagesGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Language**](Language.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

