# IO.Swagger.Api.NumRangesApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**NumRangesGet**](NumRangesApi.md#numrangesget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/numranges | get list of numRanges
[**NumRangesGetByCode**](NumRangesApi.md#numrangesgetbycode) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/numranges/bycode/{code} | Get numRange by code
[**NumRangesGet_0**](NumRangesApi.md#numrangesget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/numranges/{id} | Get numRange by id


<a name="numrangesget"></a>
# **NumRangesGet**
> List<NumRange> NumRangesGet (string clientId, string fiscalYearId)

get list of numRanges

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NumRangesGetExample
    {
        public void main()
        {
            var apiInstance = new NumRangesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get list of numRanges
                List&lt;NumRange&gt; result = apiInstance.NumRangesGet(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling NumRangesApi.NumRangesGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<NumRange>**](NumRange.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="numrangesgetbycode"></a>
# **NumRangesGetByCode**
> NumRange NumRangesGetByCode (string code, string clientId, string fiscalYearId)

Get numRange by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NumRangesGetByCodeExample
    {
        public void main()
        {
            var apiInstance = new NumRangesApi();
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get numRange by code
                NumRange result = apiInstance.NumRangesGetByCode(code, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling NumRangesApi.NumRangesGetByCode: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**NumRange**](NumRange.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="numrangesget_0"></a>
# **NumRangesGet_0**
> NumRange NumRangesGet_0 (int? id, string clientId, string fiscalYearId)

Get numRange by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NumRangesGet_0Example
    {
        public void main()
        {
            var apiInstance = new NumRangesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get numRange by id
                NumRange result = apiInstance.NumRangesGet_0(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling NumRangesApi.NumRangesGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**NumRange**](NumRange.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

