# IO.Swagger.Api.PartiesApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**PartiesDelete**](PartiesApi.md#partiesdelete) | **DELETE** /api/v1/clients/{clientId}/parties/{id} | Delete party by id
[**PartiesDeleteCreditor**](PartiesApi.md#partiesdeletecreditor) | **DELETE** /api/v1/clients/{clientId}/parties/{id}/creditor | Delete creditor by party id
[**PartiesDeleteDebtor**](PartiesApi.md#partiesdeletedebtor) | **DELETE** /api/v1/clients/{clientId}/parties/{id}/debtor | Delete debtor by party id
[**PartiesGet**](PartiesApi.md#partiesget) | **GET** /api/v1/clients/{clientId}/parties | Retreives list of parties
[**PartiesGetByFreeNumber**](PartiesApi.md#partiesgetbyfreenumber) | **GET** /api/v1/clients/{clientId}/parties/byfreenumber/{freePartyNum} | Get party by freePartyNum
[**PartiesGetByNumber**](PartiesApi.md#partiesgetbynumber) | **GET** /api/v1/clients/{clientId}/parties/bynumber/{partyNum} | Get party by partyNum
[**PartiesGet_0**](PartiesApi.md#partiesget_0) | **GET** /api/v1/clients/{clientId}/parties/{id} | Get party by id
[**PartiesPost**](PartiesApi.md#partiespost) | **POST** /api/v1/clients/{clientId}/parties | Save party
[**PartiesPost_0**](PartiesApi.md#partiespost_0) | **POST** /api/v1/clients/{clientId}/parties/{id}/creditor | Assign creditor to party creditor
[**PartiesPost_1**](PartiesApi.md#partiespost_1) | **POST** /api/v1/clients/{clientId}/parties/{id}/debtor | Assign debtor to party


<a name="partiesdelete"></a>
# **PartiesDelete**
> Object PartiesDelete (int? id, string clientId)

Delete party by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesDeleteExample
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete party by id
                Object result = apiInstance.PartiesDelete(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partiesdeletecreditor"></a>
# **PartiesDeleteCreditor**
> Object PartiesDeleteCreditor (int? id, string clientId)

Delete creditor by party id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesDeleteCreditorExample
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete creditor by party id
                Object result = apiInstance.PartiesDeleteCreditor(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesDeleteCreditor: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partiesdeletedebtor"></a>
# **PartiesDeleteDebtor**
> Object PartiesDeleteDebtor (int? id, string clientId)

Delete debtor by party id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesDeleteDebtorExample
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete debtor by party id
                Object result = apiInstance.PartiesDeleteDebtor(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesDeleteDebtor: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partiesget"></a>
# **PartiesGet**
> List<Party> PartiesGet (string clientId)

Retreives list of parties

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesGetExample
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of parties
                List&lt;Party&gt; result = apiInstance.PartiesGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<Party>**](Party.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partiesgetbyfreenumber"></a>
# **PartiesGetByFreeNumber**
> Party PartiesGetByFreeNumber (string freePartyNum, string clientId)

Get party by freePartyNum

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesGetByFreeNumberExample
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var freePartyNum = freePartyNum_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get party by freePartyNum
                Party result = apiInstance.PartiesGetByFreeNumber(freePartyNum, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesGetByFreeNumber: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **freePartyNum** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

[**Party**](Party.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partiesgetbynumber"></a>
# **PartiesGetByNumber**
> Party PartiesGetByNumber (int? partyNum, string clientId)

Get party by partyNum

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesGetByNumberExample
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var partyNum = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get party by partyNum
                Party result = apiInstance.PartiesGetByNumber(partyNum, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesGetByNumber: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **partyNum** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Party**](Party.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partiesget_0"></a>
# **PartiesGet_0**
> Party PartiesGet_0 (int? id, string clientId)

Get party by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesGet_0Example
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get party by id
                Party result = apiInstance.PartiesGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Party**](Party.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partiespost"></a>
# **PartiesPost**
> Party PartiesPost (Party party, string clientId)

Save party

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesPostExample
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var party = new Party(); // Party | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Save party
                Party result = apiInstance.PartiesPost(party, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **party** | [**Party**](Party.md)|  | 
 **clientId** | **string**|  | 

### Return type

[**Party**](Party.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partiespost_0"></a>
# **PartiesPost_0**
> Creditor PartiesPost_0 (Creditor creditor, int? id, string clientId)

Assign creditor to party creditor

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesPost_0Example
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var creditor = new Creditor(); // Creditor | 
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Assign creditor to party creditor
                Creditor result = apiInstance.PartiesPost_0(creditor, id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesPost_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **creditor** | [**Creditor**](Creditor.md)|  | 
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Creditor**](Creditor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partiespost_1"></a>
# **PartiesPost_1**
> Debtor PartiesPost_1 (Debtor debtor, int? id, string clientId)

Assign debtor to party

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartiesPost_1Example
    {
        public void main()
        {
            var apiInstance = new PartiesApi();
            var debtor = new Debtor(); // Debtor | 
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Assign debtor to party
                Debtor result = apiInstance.PartiesPost_1(debtor, id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartiesApi.PartiesPost_1: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **debtor** | [**Debtor**](Debtor.md)|  | 
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Debtor**](Debtor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

