# IO.Swagger.Api.PartnersApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**PartnersGet**](PartnersApi.md#partnersget) | **GET** /api/v1/clients/{clientId}/partners | get list of partners
[**PartnersGet_0**](PartnersApi.md#partnersget_0) | **GET** /api/v1/clients/{clientId}/partners/{id} | Get partner by id


<a name="partnersget"></a>
# **PartnersGet**
> List<Partner> PartnersGet (string clientId)

get list of partners

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartnersGetExample
    {
        public void main()
        {
            var apiInstance = new PartnersApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // get list of partners
                List&lt;Partner&gt; result = apiInstance.PartnersGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartnersApi.PartnersGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<Partner>**](Partner.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="partnersget_0"></a>
# **PartnersGet_0**
> Partner PartnersGet_0 (int? id, string clientId)

Get partner by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PartnersGet_0Example
    {
        public void main()
        {
            var apiInstance = new PartnersApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get partner by id
                Partner result = apiInstance.PartnersGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PartnersApi.PartnersGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**Partner**](Partner.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

