# IO.Swagger.Api.PayTermApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**PayTermDelete**](PayTermApi.md#paytermdelete) | **DELETE** /api/v1/clients/{clientId}/payTerms/{id} | Delete payTerm
[**PayTermGet**](PayTermApi.md#paytermget) | **GET** /api/v1/clients/{clientId}/payterms | Retreives list of payterms
[**PayTermGetByCode**](PayTermApi.md#paytermgetbycode) | **GET** /api/v1/clients/{clientId}/payterms/bycode/{code} | Get payTerm by code
[**PayTermGet_0**](PayTermApi.md#paytermget_0) | **GET** /api/v1/clients/{clientId}/payterms/{id} | Get payTerm by id
[**PayTermPost**](PayTermApi.md#paytermpost) | **POST** /api/v1/clients/{clientId}/payTerms | Save payTerm


<a name="paytermdelete"></a>
# **PayTermDelete**
> Object PayTermDelete (int? id, string clientId)

Delete payTerm

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayTermDeleteExample
    {
        public void main()
        {
            var apiInstance = new PayTermApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Delete payTerm
                Object result = apiInstance.PayTermDelete(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayTermApi.PayTermDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="paytermget"></a>
# **PayTermGet**
> List<PayTerm> PayTermGet (string clientId)

Retreives list of payterms

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayTermGetExample
    {
        public void main()
        {
            var apiInstance = new PayTermApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of payterms
                List&lt;PayTerm&gt; result = apiInstance.PayTermGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayTermApi.PayTermGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<PayTerm>**](PayTerm.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="paytermgetbycode"></a>
# **PayTermGetByCode**
> PayTerm PayTermGetByCode (string code, string clientId)

Get payTerm by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayTermGetByCodeExample
    {
        public void main()
        {
            var apiInstance = new PayTermApi();
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get payTerm by code
                PayTerm result = apiInstance.PayTermGetByCode(code, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayTermApi.PayTermGetByCode: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

[**PayTerm**](PayTerm.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="paytermget_0"></a>
# **PayTermGet_0**
> PayTerm PayTermGet_0 (int? id, string clientId)

Get payTerm by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayTermGet_0Example
    {
        public void main()
        {
            var apiInstance = new PayTermApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get payTerm by id
                PayTerm result = apiInstance.PayTermGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayTermApi.PayTermGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**PayTerm**](PayTerm.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="paytermpost"></a>
# **PayTermPost**
> PayTerm PayTermPost (PayTerm payTerm, string clientId)

Save payTerm

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayTermPostExample
    {
        public void main()
        {
            var apiInstance = new PayTermApi();
            var payTerm = new PayTerm(); // PayTerm | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Save payTerm
                PayTerm result = apiInstance.PayTermPost(payTerm, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayTermApi.PayTermPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **payTerm** | [**PayTerm**](PayTerm.md)|  | 
 **clientId** | **string**|  | 

### Return type

[**PayTerm**](PayTerm.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

