# IO.Swagger.Api.PayTypeApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**PayTypeGet**](PayTypeApi.md#paytypeget) | **GET** /api/v1/clients/{clientId}/paytypes | Retreives list of payTypes
[**PayTypeGetByCode**](PayTypeApi.md#paytypegetbycode) | **GET** /api/v1/clients/{clientId}/paytypes/byname/{name} | Get payType by name
[**PayTypeGet_0**](PayTypeApi.md#paytypeget_0) | **GET** /api/v1/clients/{clientId}/paytypes/{id} | Get payType by id


<a name="paytypeget"></a>
# **PayTypeGet**
> List<PayType> PayTypeGet (string clientId)

Retreives list of payTypes

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayTypeGetExample
    {
        public void main()
        {
            var apiInstance = new PayTypeApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of payTypes
                List&lt;PayType&gt; result = apiInstance.PayTypeGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayTypeApi.PayTypeGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<PayType>**](PayType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="paytypegetbycode"></a>
# **PayTypeGetByCode**
> PayType PayTypeGetByCode (string name, string clientId)

Get payType by name

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayTypeGetByCodeExample
    {
        public void main()
        {
            var apiInstance = new PayTypeApi();
            var name = name_example;  // string | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get payType by name
                PayType result = apiInstance.PayTypeGetByCode(name, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayTypeApi.PayTypeGetByCode: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **string**|  | 
 **clientId** | **string**|  | 

### Return type

[**PayType**](PayType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="paytypeget_0"></a>
# **PayTypeGet_0**
> PayType PayTypeGet_0 (int? id, string clientId)

Get payType by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayTypeGet_0Example
    {
        public void main()
        {
            var apiInstance = new PayTypeApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // Get payType by id
                PayType result = apiInstance.PayTypeGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayTypeApi.PayTypeGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**PayType**](PayType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

