# IO.Swagger.Api.PayablesApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**PayablesDelete**](PayablesApi.md#payablesdelete) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/{id} | Delete payables invoice by id
[**PayablesDeleteManualPayment**](PayablesApi.md#payablesdeletemanualpayment) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/manualpayments/{id} | delete manualPayment by id
[**PayablesGet**](PayablesApi.md#payablesget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices | Retreives list of payables invoices
[**PayablesGetAll**](PayablesApi.md#payablesgetall) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/all | Retreives list of payables invoices
[**PayablesGetAllPartyInvoices**](PayablesApi.md#payablesgetallpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{id}/invoices/all | Retreives list of party all payables invoices
[**PayablesGetByFreeInvoiceNum**](PayablesApi.md#payablesgetbyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/byfreeinvoicenum/{freeInvoiceNum} | Get payables invoice by freeInvoiceNum, return error if there is more than one invoice with this number
[**PayablesGetByFreeInvoicesNum**](PayablesApi.md#payablesgetbyfreeinvoicesnum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/byfreeinvoicenum/{freeInvoiceNum}/all | Get list of payables invoices by freeInvoiceNum
[**PayablesGetByInvoiceNum**](PayablesApi.md#payablesgetbyinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/byinvoicenum/{invoiceNum} | Get payables invoice by invoiceNum
[**PayablesGetInvoicesByPeriod**](PayablesApi.md#payablesgetinvoicesbyperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/byperiod | Retreives list of payables invoices by period
[**PayablesGetManualPayment**](PayablesApi.md#payablesgetmanualpayment) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/manualpayments/{id} | get manualPayment by id
[**PayablesGetManualPayments**](PayablesApi.md#payablesgetmanualpayments) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/manualpayments | Retreives list of Manual Payments
[**PayablesGetOpen**](PayablesApi.md#payablesgetopen) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/open | Retreives list of payables invoices
[**PayablesGetOpenInvoicesByPeriod**](PayablesApi.md#payablesgetopeninvoicesbyperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/open/byperiod | Retreives list of payables invoices by period
[**PayablesGetOpenPartyInvoices**](PayablesApi.md#payablesgetopenpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{id}/invoices/open | Retreives list of party open payables invoices
[**PayablesGetPartyInvoiceByFreeInvoiceNum**](PayablesApi.md#payablesgetpartyinvoicebyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{partyID}/invoices/byfreeinvoicenum/{freeInvoiceNum} | Get payables invoice by party ID and freeInvoiceNum, return error if there is more than one invoice with this number
[**PayablesGetPartyInvoices**](PayablesApi.md#payablesgetpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{id}/invoices | Retreives list of party payables invoices
[**PayablesGetPartyInvoicesByFreeInvoiceNum**](PayablesApi.md#payablesgetpartyinvoicesbyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/parties/{partyID}/invoices/byfreeinvoicenum/{freeInvoiceNum}/all | Get list of payables invoices by partyFID freeInvoiceNum
[**PayablesGetPendingDocuments**](PayablesApi.md#payablesgetpendingdocuments) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/documents/pending | get not procssed documents from dms
[**PayablesGet_0**](PayablesApi.md#payablesget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/{id} | Get payables invoice by id
[**PayablesNew**](PayablesApi.md#payablesnew) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/new | creates new invoice
[**PayablesPayInvoice**](PayablesApi.md#payablespayinvoice) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/{id}/pay | pay invoice by id
[**PayablesPost**](PayablesApi.md#payablespost) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices | Save payables invouce
[**PayablesPostFromQrBill**](PayablesApi.md#payablespostfromqrbill) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/invoices/qrbill | Creates payables invoice out of QrBill
[**PayablesPostManualPayment**](PayablesApi.md#payablespostmanualpayment) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/manualpayments | saves manualPayment
[**PayablesUpload**](PayablesApi.md#payablesupload) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/payables/documents | create invoice from qrBill and save document to DMS


<a name="payablesdelete"></a>
# **PayablesDelete**
> Object PayablesDelete (Guid? id, string clientId, string fiscalYearId)

Delete payables invoice by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesDeleteExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Delete payables invoice by id
                Object result = apiInstance.PayablesDelete(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesdeletemanualpayment"></a>
# **PayablesDeleteManualPayment**
> Object PayablesDeleteManualPayment (Guid? id, string clientId, string fiscalYearId)

delete manualPayment by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesDeleteManualPaymentExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // delete manualPayment by id
                Object result = apiInstance.PayablesDeleteManualPayment(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesDeleteManualPayment: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesget"></a>
# **PayablesGet**
> List<Invoice> PayablesGet (bool? onlyOpen, string clientId, string fiscalYearId)

Retreives list of payables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var onlyOpen = true;  // bool? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of payables invoices
                List&lt;Invoice&gt; result = apiInstance.PayablesGet(onlyOpen, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **onlyOpen** | **bool?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetall"></a>
# **PayablesGetAll**
> List<Invoice> PayablesGetAll (string clientId, string fiscalYearId)

Retreives list of payables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetAllExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of payables invoices
                List&lt;Invoice&gt; result = apiInstance.PayablesGetAll(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetAll: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetallpartyinvoices"></a>
# **PayablesGetAllPartyInvoices**
> List<Invoice> PayablesGetAllPartyInvoices (int? id, string clientId, string fiscalYearId)

Retreives list of party all payables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetAllPartyInvoicesExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of party all payables invoices
                List&lt;Invoice&gt; result = apiInstance.PayablesGetAllPartyInvoices(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetAllPartyInvoices: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetbyfreeinvoicenum"></a>
# **PayablesGetByFreeInvoiceNum**
> Invoice PayablesGetByFreeInvoiceNum (string freeInvoiceNum, string clientId, string fiscalYearId)

Get payables invoice by freeInvoiceNum, return error if there is more than one invoice with this number

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetByFreeInvoiceNumExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var freeInvoiceNum = freeInvoiceNum_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get payables invoice by freeInvoiceNum, return error if there is more than one invoice with this number
                Invoice result = apiInstance.PayablesGetByFreeInvoiceNum(freeInvoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetByFreeInvoiceNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **freeInvoiceNum** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetbyfreeinvoicesnum"></a>
# **PayablesGetByFreeInvoicesNum**
> List<Invoice> PayablesGetByFreeInvoicesNum (string freeInvoiceNum, string clientId, string fiscalYearId)

Get list of payables invoices by freeInvoiceNum

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetByFreeInvoicesNumExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var freeInvoiceNum = freeInvoiceNum_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get list of payables invoices by freeInvoiceNum
                List&lt;Invoice&gt; result = apiInstance.PayablesGetByFreeInvoicesNum(freeInvoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetByFreeInvoicesNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **freeInvoiceNum** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetbyinvoicenum"></a>
# **PayablesGetByInvoiceNum**
> Invoice PayablesGetByInvoiceNum (int? invoiceNum, string clientId, string fiscalYearId)

Get payables invoice by invoiceNum

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetByInvoiceNumExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var invoiceNum = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get payables invoice by invoiceNum
                Invoice result = apiInstance.PayablesGetByInvoiceNum(invoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetByInvoiceNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **invoiceNum** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetinvoicesbyperiod"></a>
# **PayablesGetInvoicesByPeriod**
> List<Invoice> PayablesGetInvoicesByPeriod (DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId)

Retreives list of payables invoices by period

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetInvoicesByPeriodExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var dateFrom = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var dateUntil = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of payables invoices by period
                List&lt;Invoice&gt; result = apiInstance.PayablesGetInvoicesByPeriod(dateFrom, dateUntil, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetInvoicesByPeriod: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dateFrom** | **DateTime?**|  | 
 **dateUntil** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetmanualpayment"></a>
# **PayablesGetManualPayment**
> Payment PayablesGetManualPayment (Guid? id, string clientId, string fiscalYearId)

get manualPayment by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetManualPaymentExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get manualPayment by id
                Payment result = apiInstance.PayablesGetManualPayment(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetManualPayment: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Payment**](Payment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetmanualpayments"></a>
# **PayablesGetManualPayments**
> List<Payment> PayablesGetManualPayments (string clientId, string fiscalYearId)

Retreives list of Manual Payments

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetManualPaymentsExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of Manual Payments
                List&lt;Payment&gt; result = apiInstance.PayablesGetManualPayments(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetManualPayments: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Payment>**](Payment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetopen"></a>
# **PayablesGetOpen**
> List<Invoice> PayablesGetOpen (string clientId, string fiscalYearId)

Retreives list of payables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetOpenExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of payables invoices
                List&lt;Invoice&gt; result = apiInstance.PayablesGetOpen(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetOpen: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetopeninvoicesbyperiod"></a>
# **PayablesGetOpenInvoicesByPeriod**
> List<Invoice> PayablesGetOpenInvoicesByPeriod (DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId)

Retreives list of payables invoices by period

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetOpenInvoicesByPeriodExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var dateFrom = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var dateUntil = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of payables invoices by period
                List&lt;Invoice&gt; result = apiInstance.PayablesGetOpenInvoicesByPeriod(dateFrom, dateUntil, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetOpenInvoicesByPeriod: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dateFrom** | **DateTime?**|  | 
 **dateUntil** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetopenpartyinvoices"></a>
# **PayablesGetOpenPartyInvoices**
> List<Invoice> PayablesGetOpenPartyInvoices (int? id, string clientId, string fiscalYearId)

Retreives list of party open payables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetOpenPartyInvoicesExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of party open payables invoices
                List&lt;Invoice&gt; result = apiInstance.PayablesGetOpenPartyInvoices(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetOpenPartyInvoices: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetpartyinvoicebyfreeinvoicenum"></a>
# **PayablesGetPartyInvoiceByFreeInvoiceNum**
> Invoice PayablesGetPartyInvoiceByFreeInvoiceNum (int? partyID, string freeInvoiceNum, string clientId, string fiscalYearId)

Get payables invoice by party ID and freeInvoiceNum, return error if there is more than one invoice with this number

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetPartyInvoiceByFreeInvoiceNumExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var partyID = 56;  // int? | 
            var freeInvoiceNum = freeInvoiceNum_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get payables invoice by party ID and freeInvoiceNum, return error if there is more than one invoice with this number
                Invoice result = apiInstance.PayablesGetPartyInvoiceByFreeInvoiceNum(partyID, freeInvoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetPartyInvoiceByFreeInvoiceNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **partyID** | **int?**|  | 
 **freeInvoiceNum** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetpartyinvoices"></a>
# **PayablesGetPartyInvoices**
> List<Invoice> PayablesGetPartyInvoices (int? id, bool? onlyOpen, string clientId, string fiscalYearId)

Retreives list of party payables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetPartyInvoicesExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var id = 56;  // int? | 
            var onlyOpen = true;  // bool? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of party payables invoices
                List&lt;Invoice&gt; result = apiInstance.PayablesGetPartyInvoices(id, onlyOpen, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetPartyInvoices: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **onlyOpen** | **bool?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetpartyinvoicesbyfreeinvoicenum"></a>
# **PayablesGetPartyInvoicesByFreeInvoiceNum**
> List<Invoice> PayablesGetPartyInvoicesByFreeInvoiceNum (int? partyID, string freeInvoiceNum, string clientId, string fiscalYearId)

Get list of payables invoices by partyFID freeInvoiceNum

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetPartyInvoicesByFreeInvoiceNumExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var partyID = 56;  // int? | 
            var freeInvoiceNum = freeInvoiceNum_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get list of payables invoices by partyFID freeInvoiceNum
                List&lt;Invoice&gt; result = apiInstance.PayablesGetPartyInvoicesByFreeInvoiceNum(partyID, freeInvoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetPartyInvoicesByFreeInvoiceNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **partyID** | **int?**|  | 
 **freeInvoiceNum** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesgetpendingdocuments"></a>
# **PayablesGetPendingDocuments**
> List<Document> PayablesGetPendingDocuments (string clientId, string fiscalYearId)

get not procssed documents from dms

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGetPendingDocumentsExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get not procssed documents from dms
                List&lt;Document&gt; result = apiInstance.PayablesGetPendingDocuments(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGetPendingDocuments: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Document>**](Document.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesget_0"></a>
# **PayablesGet_0**
> Invoice PayablesGet_0 (Guid? id, string clientId, string fiscalYearId)

Get payables invoice by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesGet_0Example
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get payables invoice by id
                Invoice result = apiInstance.PayablesGet_0(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesnew"></a>
# **PayablesNew**
> Invoice PayablesNew (string clientId, string fiscalYearId)

creates new invoice

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesNewExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // creates new invoice
                Invoice result = apiInstance.PayablesNew(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesNew: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablespayinvoice"></a>
# **PayablesPayInvoice**
> Payment PayablesPayInvoice (Guid? id, DateTime? date, string clientId, string fiscalYearId)

pay invoice by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesPayInvoiceExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var id = new Guid?(); // Guid? | 
            var date = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // pay invoice by id
                Payment result = apiInstance.PayablesPayInvoice(id, date, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesPayInvoice: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **date** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Payment**](Payment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablespost"></a>
# **PayablesPost**
> Invoice PayablesPost (Invoice invoice, string clientId, string fiscalYearId)

Save payables invouce

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesPostExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var invoice = new Invoice(); // Invoice | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Save payables invouce
                Invoice result = apiInstance.PayablesPost(invoice, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **invoice** | [**Invoice**](Invoice.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablespostfromqrbill"></a>
# **PayablesPostFromQrBill**
> Invoice PayablesPostFromQrBill (QrBill qrBill, string clientId, string fiscalYearId)

Creates payables invoice out of QrBill

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesPostFromQrBillExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var qrBill = new QrBill(); // QrBill | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Creates payables invoice out of QrBill
                Invoice result = apiInstance.PayablesPostFromQrBill(qrBill, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesPostFromQrBill: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **qrBill** | [**QrBill**](QrBill.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablespostmanualpayment"></a>
# **PayablesPostManualPayment**
> Payment PayablesPostManualPayment (Payment payment, string clientId, string fiscalYearId)

saves manualPayment

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesPostManualPaymentExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var payment = new Payment(); // Payment | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // saves manualPayment
                Payment result = apiInstance.PayablesPostManualPayment(payment, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesPostManualPayment: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **payment** | [**Payment**](Payment.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Payment**](Payment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payablesupload"></a>
# **PayablesUpload**
> Object PayablesUpload (string clientId, string fiscalYearId)

create invoice from qrBill and save document to DMS

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayablesUploadExample
    {
        public void main()
        {
            var apiInstance = new PayablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // create invoice from qrBill and save document to DMS
                Object result = apiInstance.PayablesUpload(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling PayablesApi.PayablesUpload: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

