# IO.Swagger.Api.ReceivablesApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ReceivablesDelete**](ReceivablesApi.md#receivablesdelete) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/{id} | Delete receivables invoice by id
[**ReceivablesDeleteManualPayment**](ReceivablesApi.md#receivablesdeletemanualpayment) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/manualpayments/{id} | delete manualPayment by id
[**ReceivablesGet**](ReceivablesApi.md#receivablesget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices | Retreives list of receivables invoices
[**ReceivablesGetAll**](ReceivablesApi.md#receivablesgetall) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/all | Retreives list of receivables invoices
[**ReceivablesGetAllPartyInvoices**](ReceivablesApi.md#receivablesgetallpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{id}/invoices/all | Retreives list of party all receivables invoices
[**ReceivablesGetByFreeInvoiceNum**](ReceivablesApi.md#receivablesgetbyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/byfreeinvoicenum/{freeInvoiceNum} | Get receivables invoice by freeInvoiceNum, return error if there is more than one invoice with this number
[**ReceivablesGetByFreeInvoicesNum**](ReceivablesApi.md#receivablesgetbyfreeinvoicesnum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/byfreeinvoicenum/{freeInvoiceNum}/all | Get list of receivables invoices by freeInvoiceNum
[**ReceivablesGetByInvoiceNum**](ReceivablesApi.md#receivablesgetbyinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/byinvoicenum/{invoiceNum} | Get receivables invoice by invoiceNum
[**ReceivablesGetInvoicesByPeriod**](ReceivablesApi.md#receivablesgetinvoicesbyperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/byperiod | Retreives list of receivables invoices by period
[**ReceivablesGetManualPayment**](ReceivablesApi.md#receivablesgetmanualpayment) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/manualpayments/{id} | get manualPayment by id
[**ReceivablesGetManualPayments**](ReceivablesApi.md#receivablesgetmanualpayments) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/manualpayments | Retreives list of Manual Payments
[**ReceivablesGetOpen**](ReceivablesApi.md#receivablesgetopen) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/open | Retreives list of receivables invoices
[**ReceivablesGetOpenInvoicesByPeriod**](ReceivablesApi.md#receivablesgetopeninvoicesbyperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/open/byperiod | Retreives list of receivables invoices by period
[**ReceivablesGetOpenPartyInvoices**](ReceivablesApi.md#receivablesgetopenpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{id}/invoices/open | Retreives list of party open receivables invoices
[**ReceivablesGetPartyInvoiceByFreeInvoiceNum**](ReceivablesApi.md#receivablesgetpartyinvoicebyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{partyID}/invoices/byfreeinvoicenum/{freeInvoiceNum} | Get receivables invoice by party ID and freeInvoiceNum, return error if there is more than one invoice with this number
[**ReceivablesGetPartyInvoices**](ReceivablesApi.md#receivablesgetpartyinvoices) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{id}/invoices | Retreives list of party receivables invoices
[**ReceivablesGetPartyInvoicesByFreeInvoiceNum**](ReceivablesApi.md#receivablesgetpartyinvoicesbyfreeinvoicenum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/parties/{partyID}/invoices/byfreeinvoicenum/{freeInvoiceNum}/all | Get list of receivables invoices by partyFID freeInvoiceNum
[**ReceivablesGet_0**](ReceivablesApi.md#receivablesget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/{id} | Get receivables invoice by id
[**ReceivablesNew**](ReceivablesApi.md#receivablesnew) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/new | creates new invoice
[**ReceivablesPayInvoice**](ReceivablesApi.md#receivablespayinvoice) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices/{id}/pay | pay invoice by id
[**ReceivablesPost**](ReceivablesApi.md#receivablespost) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/invoices | Save receivables invouce
[**ReceivablesPostManualPayment**](ReceivablesApi.md#receivablespostmanualpayment) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/receivables/manualpayments | saves manualPayment


<a name="receivablesdelete"></a>
# **ReceivablesDelete**
> Object ReceivablesDelete (Guid? id, string clientId, string fiscalYearId)

Delete receivables invoice by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesDeleteExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Delete receivables invoice by id
                Object result = apiInstance.ReceivablesDelete(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesdeletemanualpayment"></a>
# **ReceivablesDeleteManualPayment**
> Object ReceivablesDeleteManualPayment (Guid? id, string clientId, string fiscalYearId)

delete manualPayment by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesDeleteManualPaymentExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // delete manualPayment by id
                Object result = apiInstance.ReceivablesDeleteManualPayment(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesDeleteManualPayment: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesget"></a>
# **ReceivablesGet**
> List<Invoice> ReceivablesGet (bool? onlyOpen, string clientId, string fiscalYearId)

Retreives list of receivables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var onlyOpen = true;  // bool? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of receivables invoices
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGet(onlyOpen, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **onlyOpen** | **bool?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetall"></a>
# **ReceivablesGetAll**
> List<Invoice> ReceivablesGetAll (string clientId, string fiscalYearId)

Retreives list of receivables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetAllExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of receivables invoices
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGetAll(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetAll: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetallpartyinvoices"></a>
# **ReceivablesGetAllPartyInvoices**
> List<Invoice> ReceivablesGetAllPartyInvoices (int? id, string clientId, string fiscalYearId)

Retreives list of party all receivables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetAllPartyInvoicesExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of party all receivables invoices
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGetAllPartyInvoices(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetAllPartyInvoices: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetbyfreeinvoicenum"></a>
# **ReceivablesGetByFreeInvoiceNum**
> Invoice ReceivablesGetByFreeInvoiceNum (string freeInvoiceNum, string clientId, string fiscalYearId)

Get receivables invoice by freeInvoiceNum, return error if there is more than one invoice with this number

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetByFreeInvoiceNumExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var freeInvoiceNum = freeInvoiceNum_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get receivables invoice by freeInvoiceNum, return error if there is more than one invoice with this number
                Invoice result = apiInstance.ReceivablesGetByFreeInvoiceNum(freeInvoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetByFreeInvoiceNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **freeInvoiceNum** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetbyfreeinvoicesnum"></a>
# **ReceivablesGetByFreeInvoicesNum**
> List<Invoice> ReceivablesGetByFreeInvoicesNum (string freeInvoiceNum, string clientId, string fiscalYearId)

Get list of receivables invoices by freeInvoiceNum

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetByFreeInvoicesNumExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var freeInvoiceNum = freeInvoiceNum_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get list of receivables invoices by freeInvoiceNum
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGetByFreeInvoicesNum(freeInvoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetByFreeInvoicesNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **freeInvoiceNum** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetbyinvoicenum"></a>
# **ReceivablesGetByInvoiceNum**
> Invoice ReceivablesGetByInvoiceNum (int? invoiceNum, string clientId, string fiscalYearId)

Get receivables invoice by invoiceNum

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetByInvoiceNumExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var invoiceNum = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get receivables invoice by invoiceNum
                Invoice result = apiInstance.ReceivablesGetByInvoiceNum(invoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetByInvoiceNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **invoiceNum** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetinvoicesbyperiod"></a>
# **ReceivablesGetInvoicesByPeriod**
> List<Invoice> ReceivablesGetInvoicesByPeriod (DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId)

Retreives list of receivables invoices by period

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetInvoicesByPeriodExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var dateFrom = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var dateUntil = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of receivables invoices by period
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGetInvoicesByPeriod(dateFrom, dateUntil, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetInvoicesByPeriod: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dateFrom** | **DateTime?**|  | 
 **dateUntil** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetmanualpayment"></a>
# **ReceivablesGetManualPayment**
> Payment ReceivablesGetManualPayment (Guid? id, string clientId, string fiscalYearId)

get manualPayment by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetManualPaymentExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get manualPayment by id
                Payment result = apiInstance.ReceivablesGetManualPayment(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetManualPayment: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Payment**](Payment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetmanualpayments"></a>
# **ReceivablesGetManualPayments**
> List<Payment> ReceivablesGetManualPayments (string clientId, string fiscalYearId)

Retreives list of Manual Payments

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetManualPaymentsExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of Manual Payments
                List&lt;Payment&gt; result = apiInstance.ReceivablesGetManualPayments(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetManualPayments: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Payment>**](Payment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetopen"></a>
# **ReceivablesGetOpen**
> List<Invoice> ReceivablesGetOpen (string clientId, string fiscalYearId)

Retreives list of receivables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetOpenExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of receivables invoices
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGetOpen(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetOpen: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetopeninvoicesbyperiod"></a>
# **ReceivablesGetOpenInvoicesByPeriod**
> List<Invoice> ReceivablesGetOpenInvoicesByPeriod (DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId)

Retreives list of receivables invoices by period

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetOpenInvoicesByPeriodExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var dateFrom = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var dateUntil = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of receivables invoices by period
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGetOpenInvoicesByPeriod(dateFrom, dateUntil, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetOpenInvoicesByPeriod: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **dateFrom** | **DateTime?**|  | 
 **dateUntil** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetopenpartyinvoices"></a>
# **ReceivablesGetOpenPartyInvoices**
> List<Invoice> ReceivablesGetOpenPartyInvoices (int? id, string clientId, string fiscalYearId)

Retreives list of party open receivables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetOpenPartyInvoicesExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of party open receivables invoices
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGetOpenPartyInvoices(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetOpenPartyInvoices: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetpartyinvoicebyfreeinvoicenum"></a>
# **ReceivablesGetPartyInvoiceByFreeInvoiceNum**
> Invoice ReceivablesGetPartyInvoiceByFreeInvoiceNum (int? partyID, string freeInvoiceNum, string clientId, string fiscalYearId)

Get receivables invoice by party ID and freeInvoiceNum, return error if there is more than one invoice with this number

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetPartyInvoiceByFreeInvoiceNumExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var partyID = 56;  // int? | 
            var freeInvoiceNum = freeInvoiceNum_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get receivables invoice by party ID and freeInvoiceNum, return error if there is more than one invoice with this number
                Invoice result = apiInstance.ReceivablesGetPartyInvoiceByFreeInvoiceNum(partyID, freeInvoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetPartyInvoiceByFreeInvoiceNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **partyID** | **int?**|  | 
 **freeInvoiceNum** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetpartyinvoices"></a>
# **ReceivablesGetPartyInvoices**
> List<Invoice> ReceivablesGetPartyInvoices (int? id, bool? onlyOpen, string clientId, string fiscalYearId)

Retreives list of party receivables invoices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetPartyInvoicesExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var id = 56;  // int? | 
            var onlyOpen = true;  // bool? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Retreives list of party receivables invoices
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGetPartyInvoices(id, onlyOpen, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetPartyInvoices: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **onlyOpen** | **bool?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesgetpartyinvoicesbyfreeinvoicenum"></a>
# **ReceivablesGetPartyInvoicesByFreeInvoiceNum**
> List<Invoice> ReceivablesGetPartyInvoicesByFreeInvoiceNum (int? partyID, string freeInvoiceNum, string clientId, string fiscalYearId)

Get list of receivables invoices by partyFID freeInvoiceNum

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGetPartyInvoicesByFreeInvoiceNumExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var partyID = 56;  // int? | 
            var freeInvoiceNum = freeInvoiceNum_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get list of receivables invoices by partyFID freeInvoiceNum
                List&lt;Invoice&gt; result = apiInstance.ReceivablesGetPartyInvoicesByFreeInvoiceNum(partyID, freeInvoiceNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGetPartyInvoicesByFreeInvoiceNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **partyID** | **int?**|  | 
 **freeInvoiceNum** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Invoice>**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesget_0"></a>
# **ReceivablesGet_0**
> Invoice ReceivablesGet_0 (Guid? id, string clientId, string fiscalYearId)

Get receivables invoice by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesGet_0Example
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get receivables invoice by id
                Invoice result = apiInstance.ReceivablesGet_0(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablesnew"></a>
# **ReceivablesNew**
> Invoice ReceivablesNew (string clientId, string fiscalYearId)

creates new invoice

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesNewExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // creates new invoice
                Invoice result = apiInstance.ReceivablesNew(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesNew: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablespayinvoice"></a>
# **ReceivablesPayInvoice**
> Payment ReceivablesPayInvoice (Guid? id, DateTime? date, string clientId, string fiscalYearId)

pay invoice by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesPayInvoiceExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var id = new Guid?(); // Guid? | 
            var date = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // pay invoice by id
                Payment result = apiInstance.ReceivablesPayInvoice(id, date, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesPayInvoice: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **date** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Payment**](Payment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablespost"></a>
# **ReceivablesPost**
> Invoice ReceivablesPost (Invoice invoice, string clientId, string fiscalYearId)

Save receivables invouce

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesPostExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var invoice = new Invoice(); // Invoice | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Save receivables invouce
                Invoice result = apiInstance.ReceivablesPost(invoice, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **invoice** | [**Invoice**](Invoice.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Invoice**](Invoice.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="receivablespostmanualpayment"></a>
# **ReceivablesPostManualPayment**
> Payment ReceivablesPostManualPayment (Payment payment, string clientId, string fiscalYearId)

saves manualPayment

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReceivablesPostManualPaymentExample
    {
        public void main()
        {
            var apiInstance = new ReceivablesApi();
            var payment = new Payment(); // Payment | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // saves manualPayment
                Payment result = apiInstance.ReceivablesPostManualPayment(payment, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReceivablesApi.ReceivablesPostManualPayment: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **payment** | [**Payment**](Payment.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Payment**](Payment.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

