# IO.Swagger.Api.RepLanguageApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**RepLanguageGet**](RepLanguageApi.md#replanguageget) | **GET** /api/v1/clients/{clientId}/replanguages | Retreives list of report languages
[**RepLanguageGet_0**](RepLanguageApi.md#replanguageget_0) | **GET** /api/v1/clients/{clientId}/replanguages/{id} | get report language by id


<a name="replanguageget"></a>
# **RepLanguageGet**
> List<RepLanguage> RepLanguageGet (string clientId)

Retreives list of report languages

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class RepLanguageGetExample
    {
        public void main()
        {
            var apiInstance = new RepLanguageApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of report languages
                List&lt;RepLanguage&gt; result = apiInstance.RepLanguageGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling RepLanguageApi.RepLanguageGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<RepLanguage>**](RepLanguage.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="replanguageget_0"></a>
# **RepLanguageGet_0**
> RepLanguage RepLanguageGet_0 (int? id, string clientId)

get report language by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class RepLanguageGet_0Example
    {
        public void main()
        {
            var apiInstance = new RepLanguageApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // get report language by id
                RepLanguage result = apiInstance.RepLanguageGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling RepLanguageApi.RepLanguageGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**RepLanguage**](RepLanguage.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

