# IO.Swagger.Api.ReportJobApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ReportJobGet**](ReportJobApi.md#reportjobget) | **GET** /api/v1/clients/{clientId}/reportjobs | Retreives list of report jobs
[**ReportJobGet_0**](ReportJobApi.md#reportjobget_0) | **GET** /api/v1/clients/{clientId}/reportjobs/{id} | get report job by id


<a name="reportjobget"></a>
# **ReportJobGet**
> List<ReportJob> ReportJobGet (string clientId)

Retreives list of report jobs

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReportJobGetExample
    {
        public void main()
        {
            var apiInstance = new ReportJobApi();
            var clientId = clientId_example;  // string | 

            try
            {
                // Retreives list of report jobs
                List&lt;ReportJob&gt; result = apiInstance.ReportJobGet(clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportJobApi.ReportJobGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 

### Return type

[**List<ReportJob>**](ReportJob.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="reportjobget_0"></a>
# **ReportJobGet_0**
> ReportJob ReportJobGet_0 (int? id, string clientId)

get report job by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReportJobGet_0Example
    {
        public void main()
        {
            var apiInstance = new ReportJobApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 

            try
            {
                // get report job by id
                ReportJob result = apiInstance.ReportJobGet_0(id, clientId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportJobApi.ReportJobGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 

### Return type

[**ReportJob**](ReportJob.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

