# IO.Swagger.Api.ReportsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**ReportsDownload**](ReportsApi.md#reportsdownload) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/download | download report
[**ReportsDownloadWithFilter**](ReportsApi.md#reportsdownloadwithfilter) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/downloadwithfilter | Post report filter and apply it to report
[**ReportsGet**](ReportsApi.md#reportsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports | get list of reports
[**ReportsGetReportFilter**](ReportsApi.md#reportsgetreportfilter) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/reportfilter | gets report filter
[**ReportsGet_0**](ReportsApi.md#reportsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id} | get list of reports
[**ReportsPostReportFilter**](ReportsApi.md#reportspostreportfilter) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/reportfilter | gets report filter
[**ReportsPreview**](ReportsApi.md#reportspreview) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/reports/{id}/preview | preview report


<a name="reportsdownload"></a>
# **ReportsDownload**
> Object ReportsDownload (Guid? id, string clientId, string fiscalYearId)

download report

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReportsDownloadExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // download report
                Object result = apiInstance.ReportsDownload(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.ReportsDownload: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="reportsdownloadwithfilter"></a>
# **ReportsDownloadWithFilter**
> Object ReportsDownloadWithFilter (Object reportFilter, Guid? id, string clientId, string fiscalYearId, bool? saveFilter = null)

Post report filter and apply it to report

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReportsDownloadWithFilterExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var reportFilter = ;  // Object | report filter (depend on report type)
            var id = new Guid?(); // Guid? | report Id
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 
            var saveFilter = true;  // bool? | wether to save filter (optional) 

            try
            {
                // Post report filter and apply it to report
                Object result = apiInstance.ReportsDownloadWithFilter(reportFilter, id, clientId, fiscalYearId, saveFilter);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.ReportsDownloadWithFilter: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **reportFilter** | **Object**| report filter (depend on report type) | 
 **id** | [**Guid?**](Guid?.md)| report Id | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 
 **saveFilter** | **bool?**| wether to save filter | [optional] 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="reportsget"></a>
# **ReportsGet**
> List<Report> ReportsGet (string clientId, string fiscalYearId)

get list of reports

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReportsGetExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get list of reports
                List&lt;Report&gt; result = apiInstance.ReportsGet(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.ReportsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Report>**](Report.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="reportsgetreportfilter"></a>
# **ReportsGetReportFilter**
> ReportFilter ReportsGetReportFilter (Guid? id, string clientId, string fiscalYearId)

gets report filter

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReportsGetReportFilterExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // gets report filter
                ReportFilter result = apiInstance.ReportsGetReportFilter(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.ReportsGetReportFilter: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**ReportFilter**](ReportFilter.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="reportsget_0"></a>
# **ReportsGet_0**
> Report ReportsGet_0 (Guid? id, string clientId, string fiscalYearId)

get list of reports

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReportsGet_0Example
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get list of reports
                Report result = apiInstance.ReportsGet_0(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.ReportsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Report**](Report.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="reportspostreportfilter"></a>
# **ReportsPostReportFilter**
> ReportFilter ReportsPostReportFilter (Object reportFilter, Guid? id, string clientId, string fiscalYearId)

gets report filter

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReportsPostReportFilterExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var reportFilter = ;  // Object | 
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // gets report filter
                ReportFilter result = apiInstance.ReportsPostReportFilter(reportFilter, id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.ReportsPostReportFilter: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **reportFilter** | **Object**|  | 
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**ReportFilter**](ReportFilter.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="reportspreview"></a>
# **ReportsPreview**
> Object ReportsPreview (Guid? id, string clientId, string fiscalYearId)

preview report

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ReportsPreviewExample
    {
        public void main()
        {
            var apiInstance = new ReportsApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // preview report
                Object result = apiInstance.ReportsPreview(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ReportsApi.ReportsPreview: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

