# IO.Swagger.Api.TransactionsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**TransactionsCreatePosting**](TransactionsApi.md#transactionscreateposting) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/posting | create posting based on optinal parameters
[**TransactionsDelete**](TransactionsApi.md#transactionsdelete) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id} | delete transaction
[**TransactionsDeleteDocument**](TransactionsApi.md#transactionsdeletedocument) | **DELETE** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id}/document | delete document
[**TransactionsDownloadDocument**](TransactionsApi.md#transactionsdownloaddocument) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id}/document | download document
[**TransactionsGet**](TransactionsApi.md#transactionsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id} | get transaction by id
[**TransactionsGetByDocNum**](TransactionsApi.md#transactionsgetbydocnum) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/bydocnum/{docNum} | get transaction by docNum
[**TransactionsGetPendingDocuments**](TransactionsApi.md#transactionsgetpendingdocuments) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/documents/pending | get not procssed documents from dms
[**TransactionsGetVatPosting**](TransactionsApi.md#transactionsgetvatposting) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPosting | create posting with calculated vat amounts
[**TransactionsGet_0**](TransactionsApi.md#transactionsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions | get all transactions within fiscal year
[**TransactionsLinkDocument**](TransactionsApi.md#transactionslinkdocument) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/{id}/document | link document
[**TransactionsNew**](TransactionsApi.md#transactionsnew) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/new/{transactionType} | creates new transaction of given type
[**TransactionsPost**](TransactionsApi.md#transactionspost) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions | saves transaction
[**TransactionsUpload**](TransactionsApi.md#transactionsupload) | **POST** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/transactions/documents | save  document to DMS as unrecognized transaction


<a name="transactionscreateposting"></a>
# **TransactionsCreatePosting**
> Posting TransactionsCreatePosting (string clientId, string fiscalYearId, DateTime? date = null, string accountCode = null, double? amount = null, double? fcAmount = null, double? exchangeRate = null, string vatCode = null, bool? isInclusive = null)

create posting based on optinal parameters

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsCreatePostingExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 
            var date = 2013-10-20T19:20:30+01:00;  // DateTime? |  (optional) 
            var accountCode = accountCode_example;  // string |  (optional) 
            var amount = 1.2;  // double? |  (optional) 
            var fcAmount = 1.2;  // double? |  (optional) 
            var exchangeRate = 1.2;  // double? |  (optional) 
            var vatCode = vatCode_example;  // string |  (optional) 
            var isInclusive = true;  // bool? |  (optional) 

            try
            {
                // create posting based on optinal parameters
                Posting result = apiInstance.TransactionsCreatePosting(clientId, fiscalYearId, date, accountCode, amount, fcAmount, exchangeRate, vatCode, isInclusive);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsCreatePosting: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 
 **date** | **DateTime?**|  | [optional] 
 **accountCode** | **string**|  | [optional] 
 **amount** | **double?**|  | [optional] 
 **fcAmount** | **double?**|  | [optional] 
 **exchangeRate** | **double?**|  | [optional] 
 **vatCode** | **string**|  | [optional] 
 **isInclusive** | **bool?**|  | [optional] 

### Return type

[**Posting**](Posting.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsdelete"></a>
# **TransactionsDelete**
> Object TransactionsDelete (Guid? id, string clientId, string fiscalYearId, bool? deleteDoc = null)

delete transaction

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsDeleteExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 
            var deleteDoc = true;  // bool? | when not set and transaction has linked document return error (optional) 

            try
            {
                // delete transaction
                Object result = apiInstance.TransactionsDelete(id, clientId, fiscalYearId, deleteDoc);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 
 **deleteDoc** | **bool?**| when not set and transaction has linked document return error | [optional] 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsdeletedocument"></a>
# **TransactionsDeleteDocument**
> Object TransactionsDeleteDocument (Guid? id, string clientId, string fiscalYearId)

delete document

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsDeleteDocumentExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // delete document
                Object result = apiInstance.TransactionsDeleteDocument(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsDeleteDocument: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsdownloaddocument"></a>
# **TransactionsDownloadDocument**
> Object TransactionsDownloadDocument (Guid? id, string clientId, string fiscalYearId)

download document

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsDownloadDocumentExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // download document
                Object result = apiInstance.TransactionsDownloadDocument(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsDownloadDocument: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsget"></a>
# **TransactionsGet**
> Transaction TransactionsGet (Guid? id, string clientId, string fiscalYearId)

get transaction by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsGetExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get transaction by id
                Transaction result = apiInstance.TransactionsGet(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Transaction**](Transaction.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsgetbydocnum"></a>
# **TransactionsGetByDocNum**
> Transaction TransactionsGetByDocNum (int? docNum, string clientId, string fiscalYearId)

get transaction by docNum

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsGetByDocNumExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var docNum = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get transaction by docNum
                Transaction result = apiInstance.TransactionsGetByDocNum(docNum, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsGetByDocNum: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **docNum** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Transaction**](Transaction.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsgetpendingdocuments"></a>
# **TransactionsGetPendingDocuments**
> List<Document> TransactionsGetPendingDocuments (string clientId, string fiscalYearId)

get not procssed documents from dms

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsGetPendingDocumentsExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get not procssed documents from dms
                List&lt;Document&gt; result = apiInstance.TransactionsGetPendingDocuments(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsGetPendingDocuments: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Document>**](Document.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsgetvatposting"></a>
# **TransactionsGetVatPosting**
> Posting TransactionsGetVatPosting (string vatCode, double? grossAmount, double? grossFcAmount, string clientId, string fiscalYearId, bool? isInclusive = null)

create posting with calculated vat amounts

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsGetVatPostingExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var vatCode = vatCode_example;  // string | 
            var grossAmount = 1.2;  // double? | 
            var grossFcAmount = 1.2;  // double? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 
            var isInclusive = true;  // bool? |  (optional) 

            try
            {
                // create posting with calculated vat amounts
                Posting result = apiInstance.TransactionsGetVatPosting(vatCode, grossAmount, grossFcAmount, clientId, fiscalYearId, isInclusive);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsGetVatPosting: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **vatCode** | **string**|  | 
 **grossAmount** | **double?**|  | 
 **grossFcAmount** | **double?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 
 **isInclusive** | **bool?**|  | [optional] 

### Return type

[**Posting**](Posting.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsget_0"></a>
# **TransactionsGet_0**
> List<Transaction> TransactionsGet_0 (string clientId, string fiscalYearId)

get all transactions within fiscal year

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsGet_0Example
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // get all transactions within fiscal year
                List&lt;Transaction&gt; result = apiInstance.TransactionsGet_0(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<Transaction>**](Transaction.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionslinkdocument"></a>
# **TransactionsLinkDocument**
> Object TransactionsLinkDocument (Guid? id, string clientId, string fiscalYearId)

link document

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsLinkDocumentExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var id = new Guid?(); // Guid? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // link document
                Object result = apiInstance.TransactionsLinkDocument(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsLinkDocument: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | [**Guid?**](Guid?.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsnew"></a>
# **TransactionsNew**
> Transaction TransactionsNew (int? transactionType, string clientId, string fiscalYearId)

creates new transaction of given type

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsNewExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var transactionType = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // creates new transaction of given type
                Transaction result = apiInstance.TransactionsNew(transactionType, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsNew: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **transactionType** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Transaction**](Transaction.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionspost"></a>
# **TransactionsPost**
> Transaction TransactionsPost (Transaction transaction, string clientId, string fiscalYearId)

saves transaction

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsPostExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var transaction = new Transaction(); // Transaction | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // saves transaction
                Transaction result = apiInstance.TransactionsPost(transaction, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsPost: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **transaction** | [**Transaction**](Transaction.md)|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**Transaction**](Transaction.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="transactionsupload"></a>
# **TransactionsUpload**
> Object TransactionsUpload (string clientId, string fiscalYearId)

save  document to DMS as unrecognized transaction

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TransactionsUploadExample
    {
        public void main()
        {
            var apiInstance = new TransactionsApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // save  document to DMS as unrecognized transaction
                Object result = apiInstance.TransactionsUpload(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TransactionsApi.TransactionsUpload: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

