# IO.Swagger.Api.UserAccountApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**UserAccountChangePassword**](UserAccountApi.md#useraccountchangepassword) | **POST** /api/v1/useraccount/changepassword | Change user password
[**UserAccountGet**](UserAccountApi.md#useraccountget) | **GET** /api/v1/useraccounts | Retreives list of user accounts
[**UserAccountGetLocalization**](UserAccountApi.md#useraccountgetlocalization) | **GET** /api/v1/useraccount/localization | Get current user localization
[**UserAccountLogout**](UserAccountApi.md#useraccountlogout) | **GET** /api/v1/useraccount/logout | Disconnects from topal server
[**UserAccountProfile**](UserAccountApi.md#useraccountprofile) | **GET** /api/v1/useraccount/profile | Get user profile data
[**UserAccountSaveLocalization**](UserAccountApi.md#useraccountsavelocalization) | **POST** /api/v1/useraccount/localization/{localization} | Change user localization
[**UserAccountSaveProfile**](UserAccountApi.md#useraccountsaveprofile) | **POST** /api/v1/useraccount/profile | Save user profile data


<a name="useraccountchangepassword"></a>
# **UserAccountChangePassword**
> Object UserAccountChangePassword (ChangePassword changePassword)

Change user password

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UserAccountChangePasswordExample
    {
        public void main()
        {
            var apiInstance = new UserAccountApi();
            var changePassword = new ChangePassword(); // ChangePassword | 

            try
            {
                // Change user password
                Object result = apiInstance.UserAccountChangePassword(changePassword);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling UserAccountApi.UserAccountChangePassword: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **changePassword** | [**ChangePassword**](ChangePassword.md)|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="useraccountget"></a>
# **UserAccountGet**
> List<UserAccount> UserAccountGet ()

Retreives list of user accounts

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UserAccountGetExample
    {
        public void main()
        {
            var apiInstance = new UserAccountApi();

            try
            {
                // Retreives list of user accounts
                List&lt;UserAccount&gt; result = apiInstance.UserAccountGet();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling UserAccountApi.UserAccountGet: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**List<UserAccount>**](UserAccount.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="useraccountgetlocalization"></a>
# **UserAccountGetLocalization**
> string UserAccountGetLocalization ()

Get current user localization

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UserAccountGetLocalizationExample
    {
        public void main()
        {
            var apiInstance = new UserAccountApi();

            try
            {
                // Get current user localization
                string result = apiInstance.UserAccountGetLocalization();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling UserAccountApi.UserAccountGetLocalization: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="useraccountlogout"></a>
# **UserAccountLogout**
> Object UserAccountLogout ()

Disconnects from topal server

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UserAccountLogoutExample
    {
        public void main()
        {
            var apiInstance = new UserAccountApi();

            try
            {
                // Disconnects from topal server
                Object result = apiInstance.UserAccountLogout();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling UserAccountApi.UserAccountLogout: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="useraccountprofile"></a>
# **UserAccountProfile**
> UserAccount UserAccountProfile ()

Get user profile data

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UserAccountProfileExample
    {
        public void main()
        {
            var apiInstance = new UserAccountApi();

            try
            {
                // Get user profile data
                UserAccount result = apiInstance.UserAccountProfile();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling UserAccountApi.UserAccountProfile: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**UserAccount**](UserAccount.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="useraccountsavelocalization"></a>
# **UserAccountSaveLocalization**
> string UserAccountSaveLocalization (string localization)

Change user localization

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UserAccountSaveLocalizationExample
    {
        public void main()
        {
            var apiInstance = new UserAccountApi();
            var localization = localization_example;  // string | 

            try
            {
                // Change user localization
                string result = apiInstance.UserAccountSaveLocalization(localization);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling UserAccountApi.UserAccountSaveLocalization: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **localization** | **string**|  | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="useraccountsaveprofile"></a>
# **UserAccountSaveProfile**
> Object UserAccountSaveProfile (UserAccount userProfile)

Save user profile data

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UserAccountSaveProfileExample
    {
        public void main()
        {
            var apiInstance = new UserAccountApi();
            var userProfile = new UserAccount(); // UserAccount | 

            try
            {
                // Save user profile data
                Object result = apiInstance.UserAccountSaveProfile(userProfile);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling UserAccountApi.UserAccountSaveProfile: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userProfile** | [**UserAccount**](UserAccount.md)|  | 

### Return type

**Object**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

