# IO.Swagger.Api.VATsApi

All URIs are relative to *https://websolution.topal.ch*

Method | HTTP request | Description
------------- | ------------- | -------------
[**VATsGet**](VATsApi.md#vatsget) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats | Get list of VATs (depricated: use vats/bydate instead )
[**VATsGetByCode**](VATsApi.md#vatsgetbycode) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/bycode/{code} | Get VAT by code
[**VATsGetByCode_0**](VATsApi.md#vatsgetbycode_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats/bycode/{code} | Get VAT by code
[**VATsGetByVatPeriod**](VATsApi.md#vatsgetbyvatperiod) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats | Get list of VATs by vatPeriodId
[**VATsGet_0**](VATsApi.md#vatsget_0) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/bydate | Get list of VATs of period of given date
[**VATsGet_1**](VATsApi.md#vatsget_1) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/{id} | Get VAT by id
[**VATsGet_2**](VATsApi.md#vatsget_2) | **GET** /api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats/{id} | Get VAT by id


<a name="vatsget"></a>
# **VATsGet**
> List<VAT> VATsGet (string clientId, string fiscalYearId)

Get list of VATs (depricated: use vats/bydate instead )

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VATsGetExample
    {
        public void main()
        {
            var apiInstance = new VATsApi();
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get list of VATs (depricated: use vats/bydate instead )
                List&lt;VAT&gt; result = apiInstance.VATsGet(clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VATsApi.VATsGet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<VAT>**](VAT.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vatsgetbycode"></a>
# **VATsGetByCode**
> VAT VATsGetByCode (string code, string clientId, string fiscalYearId)

Get VAT by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VATsGetByCodeExample
    {
        public void main()
        {
            var apiInstance = new VATsApi();
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get VAT by code
                VAT result = apiInstance.VATsGetByCode(code, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VATsApi.VATsGetByCode: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**VAT**](VAT.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vatsgetbycode_0"></a>
# **VATsGetByCode_0**
> VAT VATsGetByCode_0 (int? vatPeriodId, string code, string clientId, string fiscalYearId)

Get VAT by code

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VATsGetByCode_0Example
    {
        public void main()
        {
            var apiInstance = new VATsApi();
            var vatPeriodId = 56;  // int? | 
            var code = code_example;  // string | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get VAT by code
                VAT result = apiInstance.VATsGetByCode_0(vatPeriodId, code, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VATsApi.VATsGetByCode_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **vatPeriodId** | **int?**|  | 
 **code** | **string**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**VAT**](VAT.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vatsgetbyvatperiod"></a>
# **VATsGetByVatPeriod**
> List<VAT> VATsGetByVatPeriod (int? vatPeriodId, string clientId, string fiscalYearId)

Get list of VATs by vatPeriodId

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VATsGetByVatPeriodExample
    {
        public void main()
        {
            var apiInstance = new VATsApi();
            var vatPeriodId = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get list of VATs by vatPeriodId
                List&lt;VAT&gt; result = apiInstance.VATsGetByVatPeriod(vatPeriodId, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VATsApi.VATsGetByVatPeriod: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **vatPeriodId** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<VAT>**](VAT.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vatsget_0"></a>
# **VATsGet_0**
> List<VAT> VATsGet_0 (DateTime? date, string clientId, string fiscalYearId)

Get list of VATs of period of given date

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VATsGet_0Example
    {
        public void main()
        {
            var apiInstance = new VATsApi();
            var date = 2013-10-20T19:20:30+01:00;  // DateTime? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get list of VATs of period of given date
                List&lt;VAT&gt; result = apiInstance.VATsGet_0(date, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VATsApi.VATsGet_0: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **date** | **DateTime?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**List<VAT>**](VAT.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vatsget_1"></a>
# **VATsGet_1**
> VAT VATsGet_1 (int? id, string clientId, string fiscalYearId)

Get VAT by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VATsGet_1Example
    {
        public void main()
        {
            var apiInstance = new VATsApi();
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get VAT by id
                VAT result = apiInstance.VATsGet_1(id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VATsApi.VATsGet_1: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**VAT**](VAT.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="vatsget_2"></a>
# **VATsGet_2**
> VAT VATsGet_2 (int? vatPeriodId, int? id, string clientId, string fiscalYearId)

Get VAT by id

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class VATsGet_2Example
    {
        public void main()
        {
            var apiInstance = new VATsApi();
            var vatPeriodId = 56;  // int? | 
            var id = 56;  // int? | 
            var clientId = clientId_example;  // string | 
            var fiscalYearId = fiscalYearId_example;  // string | 

            try
            {
                // Get VAT by id
                VAT result = apiInstance.VATsGet_2(vatPeriodId, id, clientId, fiscalYearId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling VATsApi.VATsGet_2: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **vatPeriodId** | **int?**|  | 
 **id** | **int?**|  | 
 **clientId** | **string**|  | 
 **fiscalYearId** | **string**|  | 

### Return type

[**VAT**](VAT.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json, text/json, application/xml, text/xml

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

