/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IAccountsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Gets list of accounts
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;Account&gt;</returns>
        List<Account> AccountsGet (string clientId, string fiscalYearId);

        /// <summary>
        /// Gets list of accounts
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;Account&gt;</returns>
        ApiResponse<List<Account>> AccountsGetWithHttpInfo (string clientId, string fiscalYearId);
        /// <summary>
        /// get account statement
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="selectContraPostings"> (optional)</param>
        /// <returns>List&lt;BalancePosting&gt;</returns>
        List<BalancePosting> AccountsGetStatement (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId, bool? selectContraPostings = null);

        /// <summary>
        /// get account statement
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="selectContraPostings"> (optional)</param>
        /// <returns>ApiResponse of List&lt;BalancePosting&gt;</returns>
        ApiResponse<List<BalancePosting>> AccountsGetStatementWithHttpInfo (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId, bool? selectContraPostings = null);
        /// <summary>
        /// get account summary
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>AccountSummary</returns>
        AccountSummary AccountsGetSummary (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId);

        /// <summary>
        /// get account summary
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of AccountSummary</returns>
        ApiResponse<AccountSummary> AccountsGetSummaryWithHttpInfo (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId);
        /// <summary>
        /// Gets account by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Account</returns>
        Account AccountsGet_0 (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Gets account by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of Account</returns>
        ApiResponse<Account> AccountsGet_0WithHttpInfo (int? id, string clientId, string fiscalYearId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Gets list of accounts
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;Account&gt;</returns>
        System.Threading.Tasks.Task<List<Account>> AccountsGetAsync (string clientId, string fiscalYearId);

        /// <summary>
        /// Gets list of accounts
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;Account&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Account>>> AccountsGetAsyncWithHttpInfo (string clientId, string fiscalYearId);
        /// <summary>
        /// get account statement
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="selectContraPostings"> (optional)</param>
        /// <returns>Task of List&lt;BalancePosting&gt;</returns>
        System.Threading.Tasks.Task<List<BalancePosting>> AccountsGetStatementAsync (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId, bool? selectContraPostings = null);

        /// <summary>
        /// get account statement
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="selectContraPostings"> (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;BalancePosting&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<BalancePosting>>> AccountsGetStatementAsyncWithHttpInfo (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId, bool? selectContraPostings = null);
        /// <summary>
        /// get account summary
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of AccountSummary</returns>
        System.Threading.Tasks.Task<AccountSummary> AccountsGetSummaryAsync (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId);

        /// <summary>
        /// get account summary
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (AccountSummary)</returns>
        System.Threading.Tasks.Task<ApiResponse<AccountSummary>> AccountsGetSummaryAsyncWithHttpInfo (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId);
        /// <summary>
        /// Gets account by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of Account</returns>
        System.Threading.Tasks.Task<Account> AccountsGet_0Async (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Gets account by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (Account)</returns>
        System.Threading.Tasks.Task<ApiResponse<Account>> AccountsGet_0AsyncWithHttpInfo (int? id, string clientId, string fiscalYearId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class AccountsApi : IAccountsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="AccountsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public AccountsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="AccountsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public AccountsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Gets list of accounts 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;Account&gt;</returns>
        public List<Account> AccountsGet (string clientId, string fiscalYearId)
        {
             ApiResponse<List<Account>> localVarResponse = AccountsGetWithHttpInfo(clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Gets list of accounts 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;Account&gt;</returns>
        public ApiResponse< List<Account> > AccountsGetWithHttpInfo (string clientId, string fiscalYearId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling AccountsApi->AccountsGet");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling AccountsApi->AccountsGet");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Account>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Account>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Account>)));
        }

        /// <summary>
        /// Gets list of accounts 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;Account&gt;</returns>
        public async System.Threading.Tasks.Task<List<Account>> AccountsGetAsync (string clientId, string fiscalYearId)
        {
             ApiResponse<List<Account>> localVarResponse = await AccountsGetAsyncWithHttpInfo(clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Gets list of accounts 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;Account&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Account>>> AccountsGetAsyncWithHttpInfo (string clientId, string fiscalYearId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling AccountsApi->AccountsGet");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling AccountsApi->AccountsGet");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Account>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Account>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Account>)));
        }

        /// <summary>
        /// get account statement 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="selectContraPostings"> (optional)</param>
        /// <returns>List&lt;BalancePosting&gt;</returns>
        public List<BalancePosting> AccountsGetStatement (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId, bool? selectContraPostings = null)
        {
             ApiResponse<List<BalancePosting>> localVarResponse = AccountsGetStatementWithHttpInfo(id, dateFrom, dateUntil, clientId, fiscalYearId, selectContraPostings);
             return localVarResponse.Data;
        }

        /// <summary>
        /// get account statement 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="selectContraPostings"> (optional)</param>
        /// <returns>ApiResponse of List&lt;BalancePosting&gt;</returns>
        public ApiResponse< List<BalancePosting> > AccountsGetStatementWithHttpInfo (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId, bool? selectContraPostings = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AccountsApi->AccountsGetStatement");
            // verify the required parameter 'dateFrom' is set
            if (dateFrom == null)
                throw new ApiException(400, "Missing required parameter 'dateFrom' when calling AccountsApi->AccountsGetStatement");
            // verify the required parameter 'dateUntil' is set
            if (dateUntil == null)
                throw new ApiException(400, "Missing required parameter 'dateUntil' when calling AccountsApi->AccountsGetStatement");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling AccountsApi->AccountsGetStatement");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling AccountsApi->AccountsGetStatement");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}/statement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter
            if (dateFrom != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dateFrom", dateFrom)); // query parameter
            if (dateUntil != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dateUntil", dateUntil)); // query parameter
            if (selectContraPostings != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "selectContraPostings", selectContraPostings)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountsGetStatement", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<BalancePosting>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<BalancePosting>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<BalancePosting>)));
        }

        /// <summary>
        /// get account statement 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="selectContraPostings"> (optional)</param>
        /// <returns>Task of List&lt;BalancePosting&gt;</returns>
        public async System.Threading.Tasks.Task<List<BalancePosting>> AccountsGetStatementAsync (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId, bool? selectContraPostings = null)
        {
             ApiResponse<List<BalancePosting>> localVarResponse = await AccountsGetStatementAsyncWithHttpInfo(id, dateFrom, dateUntil, clientId, fiscalYearId, selectContraPostings);
             return localVarResponse.Data;

        }

        /// <summary>
        /// get account statement 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="selectContraPostings"> (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;BalancePosting&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<BalancePosting>>> AccountsGetStatementAsyncWithHttpInfo (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId, bool? selectContraPostings = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AccountsApi->AccountsGetStatement");
            // verify the required parameter 'dateFrom' is set
            if (dateFrom == null)
                throw new ApiException(400, "Missing required parameter 'dateFrom' when calling AccountsApi->AccountsGetStatement");
            // verify the required parameter 'dateUntil' is set
            if (dateUntil == null)
                throw new ApiException(400, "Missing required parameter 'dateUntil' when calling AccountsApi->AccountsGetStatement");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling AccountsApi->AccountsGetStatement");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling AccountsApi->AccountsGetStatement");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}/statement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter
            if (dateFrom != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dateFrom", dateFrom)); // query parameter
            if (dateUntil != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dateUntil", dateUntil)); // query parameter
            if (selectContraPostings != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "selectContraPostings", selectContraPostings)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountsGetStatement", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<BalancePosting>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<BalancePosting>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<BalancePosting>)));
        }

        /// <summary>
        /// get account summary 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>AccountSummary</returns>
        public AccountSummary AccountsGetSummary (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId)
        {
             ApiResponse<AccountSummary> localVarResponse = AccountsGetSummaryWithHttpInfo(id, dateFrom, dateUntil, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// get account summary 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of AccountSummary</returns>
        public ApiResponse< AccountSummary > AccountsGetSummaryWithHttpInfo (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AccountsApi->AccountsGetSummary");
            // verify the required parameter 'dateFrom' is set
            if (dateFrom == null)
                throw new ApiException(400, "Missing required parameter 'dateFrom' when calling AccountsApi->AccountsGetSummary");
            // verify the required parameter 'dateUntil' is set
            if (dateUntil == null)
                throw new ApiException(400, "Missing required parameter 'dateUntil' when calling AccountsApi->AccountsGetSummary");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling AccountsApi->AccountsGetSummary");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling AccountsApi->AccountsGetSummary");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}/summary";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter
            if (dateFrom != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dateFrom", dateFrom)); // query parameter
            if (dateUntil != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dateUntil", dateUntil)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountsGetSummary", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AccountSummary>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AccountSummary) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(AccountSummary)));
        }

        /// <summary>
        /// get account summary 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of AccountSummary</returns>
        public async System.Threading.Tasks.Task<AccountSummary> AccountsGetSummaryAsync (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId)
        {
             ApiResponse<AccountSummary> localVarResponse = await AccountsGetSummaryAsyncWithHttpInfo(id, dateFrom, dateUntil, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// get account summary 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="dateFrom"></param>
        /// <param name="dateUntil"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (AccountSummary)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<AccountSummary>> AccountsGetSummaryAsyncWithHttpInfo (int? id, DateTime? dateFrom, DateTime? dateUntil, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AccountsApi->AccountsGetSummary");
            // verify the required parameter 'dateFrom' is set
            if (dateFrom == null)
                throw new ApiException(400, "Missing required parameter 'dateFrom' when calling AccountsApi->AccountsGetSummary");
            // verify the required parameter 'dateUntil' is set
            if (dateUntil == null)
                throw new ApiException(400, "Missing required parameter 'dateUntil' when calling AccountsApi->AccountsGetSummary");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling AccountsApi->AccountsGetSummary");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling AccountsApi->AccountsGetSummary");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}/summary";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter
            if (dateFrom != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dateFrom", dateFrom)); // query parameter
            if (dateUntil != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dateUntil", dateUntil)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountsGetSummary", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AccountSummary>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AccountSummary) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(AccountSummary)));
        }

        /// <summary>
        /// Gets account by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Account</returns>
        public Account AccountsGet_0 (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<Account> localVarResponse = AccountsGet_0WithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Gets account by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of Account</returns>
        public ApiResponse< Account > AccountsGet_0WithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AccountsApi->AccountsGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling AccountsApi->AccountsGet_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling AccountsApi->AccountsGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountsGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Account>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Account) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Account)));
        }

        /// <summary>
        /// Gets account by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of Account</returns>
        public async System.Threading.Tasks.Task<Account> AccountsGet_0Async (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<Account> localVarResponse = await AccountsGet_0AsyncWithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Gets account by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (Account)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Account>> AccountsGet_0AsyncWithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling AccountsApi->AccountsGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling AccountsApi->AccountsGet_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling AccountsApi->AccountsGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/accounts/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AccountsGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Account>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Account) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Account)));
        }

    }
}
