/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface ICOATreeViewsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Delete coaTreeViewTreeView
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Object</returns>
        Object COATreeViewsDelete (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Delete coaTreeViewTreeView
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of Object</returns>
        ApiResponse<Object> COATreeViewsDeleteWithHttpInfo (int? id, string clientId, string fiscalYearId);
        /// <summary>
        /// get list of coatreeViews
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;COATreeView&gt;</returns>
        List<COATreeView> COATreeViewsGet (string clientId, string fiscalYearId);

        /// <summary>
        /// get list of coatreeViews
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;COATreeView&gt;</returns>
        ApiResponse<List<COATreeView>> COATreeViewsGetWithHttpInfo (string clientId, string fiscalYearId);
        /// <summary>
        /// Get coaTreeView by id within given coa
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;COATreeView&gt;</returns>
        List<COATreeView> COATreeViewsGetByCOA (int? coaId, string clientId, string fiscalYearId);

        /// <summary>
        /// Get coaTreeView by id within given coa
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;COATreeView&gt;</returns>
        ApiResponse<List<COATreeView>> COATreeViewsGetByCOAWithHttpInfo (int? coaId, string clientId, string fiscalYearId);
        /// <summary>
        /// Get coaTreeView by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>COATreeView</returns>
        COATreeView COATreeViewsGet_0 (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Get coaTreeView by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of COATreeView</returns>
        ApiResponse<COATreeView> COATreeViewsGet_0WithHttpInfo (int? id, string clientId, string fiscalYearId);
        /// <summary>
        /// Get coaTreeView by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>COATreeView</returns>
        COATreeView COATreeViewsGet_1 (string code, string clientId, string fiscalYearId);

        /// <summary>
        /// Get coaTreeView by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of COATreeView</returns>
        ApiResponse<COATreeView> COATreeViewsGet_1WithHttpInfo (string code, string clientId, string fiscalYearId);
        /// <summary>
        ///  saves CoaTreeView   COATreeView item type:  - Account &#x3D; 1  - COA Group &#x3D; 2  - Counter &#x3D; 3  - Mirror Account &#x3D; 4  - Account Copy &#x3D; 5  - Result &#x3D; 6  - Commentary Line &#x3D; 7
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaTreeView"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="parentGroupCode">parent group (optional)</param>
        /// <returns>COATreeView</returns>
        COATreeView COATreeViewsPost (COATreeView coaTreeView, string clientId, string fiscalYearId, string parentGroupCode = null);

        /// <summary>
        ///  saves CoaTreeView   COATreeView item type:  - Account &#x3D; 1  - COA Group &#x3D; 2  - Counter &#x3D; 3  - Mirror Account &#x3D; 4  - Account Copy &#x3D; 5  - Result &#x3D; 6  - Commentary Line &#x3D; 7
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaTreeView"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="parentGroupCode">parent group (optional)</param>
        /// <returns>ApiResponse of COATreeView</returns>
        ApiResponse<COATreeView> COATreeViewsPostWithHttpInfo (COATreeView coaTreeView, string clientId, string fiscalYearId, string parentGroupCode = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Delete coaTreeViewTreeView
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of Object</returns>
        System.Threading.Tasks.Task<Object> COATreeViewsDeleteAsync (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Delete coaTreeViewTreeView
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (Object)</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> COATreeViewsDeleteAsyncWithHttpInfo (int? id, string clientId, string fiscalYearId);
        /// <summary>
        /// get list of coatreeViews
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;COATreeView&gt;</returns>
        System.Threading.Tasks.Task<List<COATreeView>> COATreeViewsGetAsync (string clientId, string fiscalYearId);

        /// <summary>
        /// get list of coatreeViews
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;COATreeView&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<COATreeView>>> COATreeViewsGetAsyncWithHttpInfo (string clientId, string fiscalYearId);
        /// <summary>
        /// Get coaTreeView by id within given coa
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;COATreeView&gt;</returns>
        System.Threading.Tasks.Task<List<COATreeView>> COATreeViewsGetByCOAAsync (int? coaId, string clientId, string fiscalYearId);

        /// <summary>
        /// Get coaTreeView by id within given coa
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;COATreeView&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<COATreeView>>> COATreeViewsGetByCOAAsyncWithHttpInfo (int? coaId, string clientId, string fiscalYearId);
        /// <summary>
        /// Get coaTreeView by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of COATreeView</returns>
        System.Threading.Tasks.Task<COATreeView> COATreeViewsGet_0Async (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Get coaTreeView by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (COATreeView)</returns>
        System.Threading.Tasks.Task<ApiResponse<COATreeView>> COATreeViewsGet_0AsyncWithHttpInfo (int? id, string clientId, string fiscalYearId);
        /// <summary>
        /// Get coaTreeView by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of COATreeView</returns>
        System.Threading.Tasks.Task<COATreeView> COATreeViewsGet_1Async (string code, string clientId, string fiscalYearId);

        /// <summary>
        /// Get coaTreeView by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (COATreeView)</returns>
        System.Threading.Tasks.Task<ApiResponse<COATreeView>> COATreeViewsGet_1AsyncWithHttpInfo (string code, string clientId, string fiscalYearId);
        /// <summary>
        ///  saves CoaTreeView   COATreeView item type:  - Account &#x3D; 1  - COA Group &#x3D; 2  - Counter &#x3D; 3  - Mirror Account &#x3D; 4  - Account Copy &#x3D; 5  - Result &#x3D; 6  - Commentary Line &#x3D; 7
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaTreeView"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="parentGroupCode">parent group (optional)</param>
        /// <returns>Task of COATreeView</returns>
        System.Threading.Tasks.Task<COATreeView> COATreeViewsPostAsync (COATreeView coaTreeView, string clientId, string fiscalYearId, string parentGroupCode = null);

        /// <summary>
        ///  saves CoaTreeView   COATreeView item type:  - Account &#x3D; 1  - COA Group &#x3D; 2  - Counter &#x3D; 3  - Mirror Account &#x3D; 4  - Account Copy &#x3D; 5  - Result &#x3D; 6  - Commentary Line &#x3D; 7
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaTreeView"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="parentGroupCode">parent group (optional)</param>
        /// <returns>Task of ApiResponse (COATreeView)</returns>
        System.Threading.Tasks.Task<ApiResponse<COATreeView>> COATreeViewsPostAsyncWithHttpInfo (COATreeView coaTreeView, string clientId, string fiscalYearId, string parentGroupCode = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class COATreeViewsApi : ICOATreeViewsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="COATreeViewsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public COATreeViewsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="COATreeViewsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public COATreeViewsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Delete coaTreeViewTreeView 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Object</returns>
        public Object COATreeViewsDelete (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<Object> localVarResponse = COATreeViewsDeleteWithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Delete coaTreeViewTreeView 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of Object</returns>
        public ApiResponse< Object > COATreeViewsDeleteWithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling COATreeViewsApi->COATreeViewsDelete");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsDelete");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsDelete");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coaTreeViews/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// Delete coaTreeViewTreeView 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of Object</returns>
        public async System.Threading.Tasks.Task<Object> COATreeViewsDeleteAsync (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<Object> localVarResponse = await COATreeViewsDeleteAsyncWithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Delete coaTreeViewTreeView 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (Object)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> COATreeViewsDeleteAsyncWithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling COATreeViewsApi->COATreeViewsDelete");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsDelete");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsDelete");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coaTreeViews/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// get list of coatreeViews 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;COATreeView&gt;</returns>
        public List<COATreeView> COATreeViewsGet (string clientId, string fiscalYearId)
        {
             ApiResponse<List<COATreeView>> localVarResponse = COATreeViewsGetWithHttpInfo(clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// get list of coatreeViews 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;COATreeView&gt;</returns>
        public ApiResponse< List<COATreeView> > COATreeViewsGetWithHttpInfo (string clientId, string fiscalYearId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsGet");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsGet");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<COATreeView>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<COATreeView>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<COATreeView>)));
        }

        /// <summary>
        /// get list of coatreeViews 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;COATreeView&gt;</returns>
        public async System.Threading.Tasks.Task<List<COATreeView>> COATreeViewsGetAsync (string clientId, string fiscalYearId)
        {
             ApiResponse<List<COATreeView>> localVarResponse = await COATreeViewsGetAsyncWithHttpInfo(clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// get list of coatreeViews 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;COATreeView&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<COATreeView>>> COATreeViewsGetAsyncWithHttpInfo (string clientId, string fiscalYearId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsGet");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsGet");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<COATreeView>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<COATreeView>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<COATreeView>)));
        }

        /// <summary>
        /// Get coaTreeView by id within given coa 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;COATreeView&gt;</returns>
        public List<COATreeView> COATreeViewsGetByCOA (int? coaId, string clientId, string fiscalYearId)
        {
             ApiResponse<List<COATreeView>> localVarResponse = COATreeViewsGetByCOAWithHttpInfo(coaId, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get coaTreeView by id within given coa 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;COATreeView&gt;</returns>
        public ApiResponse< List<COATreeView> > COATreeViewsGetByCOAWithHttpInfo (int? coaId, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'coaId' is set
            if (coaId == null)
                throw new ApiException(400, "Missing required parameter 'coaId' when calling COATreeViewsApi->COATreeViewsGetByCOA");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsGetByCOA");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsGetByCOA");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coas/{coaId}/coatreeviews";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (coaId != null) localVarPathParams.Add("coaId", this.Configuration.ApiClient.ParameterToString(coaId)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsGetByCOA", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<COATreeView>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<COATreeView>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<COATreeView>)));
        }

        /// <summary>
        /// Get coaTreeView by id within given coa 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;COATreeView&gt;</returns>
        public async System.Threading.Tasks.Task<List<COATreeView>> COATreeViewsGetByCOAAsync (int? coaId, string clientId, string fiscalYearId)
        {
             ApiResponse<List<COATreeView>> localVarResponse = await COATreeViewsGetByCOAAsyncWithHttpInfo(coaId, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get coaTreeView by id within given coa 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;COATreeView&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<COATreeView>>> COATreeViewsGetByCOAAsyncWithHttpInfo (int? coaId, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'coaId' is set
            if (coaId == null)
                throw new ApiException(400, "Missing required parameter 'coaId' when calling COATreeViewsApi->COATreeViewsGetByCOA");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsGetByCOA");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsGetByCOA");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coas/{coaId}/coatreeviews";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (coaId != null) localVarPathParams.Add("coaId", this.Configuration.ApiClient.ParameterToString(coaId)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsGetByCOA", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<COATreeView>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<COATreeView>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<COATreeView>)));
        }

        /// <summary>
        /// Get coaTreeView by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>COATreeView</returns>
        public COATreeView COATreeViewsGet_0 (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<COATreeView> localVarResponse = COATreeViewsGet_0WithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get coaTreeView by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of COATreeView</returns>
        public ApiResponse< COATreeView > COATreeViewsGet_0WithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling COATreeViewsApi->COATreeViewsGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsGet_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<COATreeView>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (COATreeView) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(COATreeView)));
        }

        /// <summary>
        /// Get coaTreeView by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of COATreeView</returns>
        public async System.Threading.Tasks.Task<COATreeView> COATreeViewsGet_0Async (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<COATreeView> localVarResponse = await COATreeViewsGet_0AsyncWithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get coaTreeView by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (COATreeView)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<COATreeView>> COATreeViewsGet_0AsyncWithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling COATreeViewsApi->COATreeViewsGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsGet_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<COATreeView>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (COATreeView) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(COATreeView)));
        }

        /// <summary>
        /// Get coaTreeView by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>COATreeView</returns>
        public COATreeView COATreeViewsGet_1 (string code, string clientId, string fiscalYearId)
        {
             ApiResponse<COATreeView> localVarResponse = COATreeViewsGet_1WithHttpInfo(code, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get coaTreeView by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of COATreeView</returns>
        public ApiResponse< COATreeView > COATreeViewsGet_1WithHttpInfo (string code, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling COATreeViewsApi->COATreeViewsGet_1");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsGet_1");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsGet_1");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews/byCode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsGet_1", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<COATreeView>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (COATreeView) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(COATreeView)));
        }

        /// <summary>
        /// Get coaTreeView by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of COATreeView</returns>
        public async System.Threading.Tasks.Task<COATreeView> COATreeViewsGet_1Async (string code, string clientId, string fiscalYearId)
        {
             ApiResponse<COATreeView> localVarResponse = await COATreeViewsGet_1AsyncWithHttpInfo(code, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get coaTreeView by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (COATreeView)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<COATreeView>> COATreeViewsGet_1AsyncWithHttpInfo (string code, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling COATreeViewsApi->COATreeViewsGet_1");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsGet_1");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsGet_1");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews/byCode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsGet_1", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<COATreeView>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (COATreeView) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(COATreeView)));
        }

        /// <summary>
        ///  saves CoaTreeView   COATreeView item type:  - Account &#x3D; 1  - COA Group &#x3D; 2  - Counter &#x3D; 3  - Mirror Account &#x3D; 4  - Account Copy &#x3D; 5  - Result &#x3D; 6  - Commentary Line &#x3D; 7 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaTreeView"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="parentGroupCode">parent group (optional)</param>
        /// <returns>COATreeView</returns>
        public COATreeView COATreeViewsPost (COATreeView coaTreeView, string clientId, string fiscalYearId, string parentGroupCode = null)
        {
             ApiResponse<COATreeView> localVarResponse = COATreeViewsPostWithHttpInfo(coaTreeView, clientId, fiscalYearId, parentGroupCode);
             return localVarResponse.Data;
        }

        /// <summary>
        ///  saves CoaTreeView   COATreeView item type:  - Account &#x3D; 1  - COA Group &#x3D; 2  - Counter &#x3D; 3  - Mirror Account &#x3D; 4  - Account Copy &#x3D; 5  - Result &#x3D; 6  - Commentary Line &#x3D; 7 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaTreeView"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="parentGroupCode">parent group (optional)</param>
        /// <returns>ApiResponse of COATreeView</returns>
        public ApiResponse< COATreeView > COATreeViewsPostWithHttpInfo (COATreeView coaTreeView, string clientId, string fiscalYearId, string parentGroupCode = null)
        {
            // verify the required parameter 'coaTreeView' is set
            if (coaTreeView == null)
                throw new ApiException(400, "Missing required parameter 'coaTreeView' when calling COATreeViewsApi->COATreeViewsPost");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsPost");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsPost");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter
            if (parentGroupCode != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "parentGroupCode", parentGroupCode)); // query parameter
            if (coaTreeView != null && coaTreeView.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(coaTreeView); // http body (model) parameter
            }
            else
            {
                localVarPostBody = coaTreeView; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<COATreeView>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (COATreeView) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(COATreeView)));
        }

        /// <summary>
        ///  saves CoaTreeView   COATreeView item type:  - Account &#x3D; 1  - COA Group &#x3D; 2  - Counter &#x3D; 3  - Mirror Account &#x3D; 4  - Account Copy &#x3D; 5  - Result &#x3D; 6  - Commentary Line &#x3D; 7 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaTreeView"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="parentGroupCode">parent group (optional)</param>
        /// <returns>Task of COATreeView</returns>
        public async System.Threading.Tasks.Task<COATreeView> COATreeViewsPostAsync (COATreeView coaTreeView, string clientId, string fiscalYearId, string parentGroupCode = null)
        {
             ApiResponse<COATreeView> localVarResponse = await COATreeViewsPostAsyncWithHttpInfo(coaTreeView, clientId, fiscalYearId, parentGroupCode);
             return localVarResponse.Data;

        }

        /// <summary>
        ///  saves CoaTreeView   COATreeView item type:  - Account &#x3D; 1  - COA Group &#x3D; 2  - Counter &#x3D; 3  - Mirror Account &#x3D; 4  - Account Copy &#x3D; 5  - Result &#x3D; 6  - Commentary Line &#x3D; 7 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="coaTreeView"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <param name="parentGroupCode">parent group (optional)</param>
        /// <returns>Task of ApiResponse (COATreeView)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<COATreeView>> COATreeViewsPostAsyncWithHttpInfo (COATreeView coaTreeView, string clientId, string fiscalYearId, string parentGroupCode = null)
        {
            // verify the required parameter 'coaTreeView' is set
            if (coaTreeView == null)
                throw new ApiException(400, "Missing required parameter 'coaTreeView' when calling COATreeViewsApi->COATreeViewsPost");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling COATreeViewsApi->COATreeViewsPost");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling COATreeViewsApi->COATreeViewsPost");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/coatreeviews";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter
            if (parentGroupCode != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "parentGroupCode", parentGroupCode)); // query parameter
            if (coaTreeView != null && coaTreeView.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(coaTreeView); // http body (model) parameter
            }
            else
            {
                localVarPostBody = coaTreeView; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("COATreeViewsPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<COATreeView>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (COATreeView) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(COATreeView)));
        }

    }
}
