/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IChartsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Gets list of MIS formulas trees of client
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>List&lt;MisFormulaTree&gt;</returns>
        List<MisFormulaTree> ChartsGetFormulaList (string clientId);

        /// <summary>
        /// Gets list of MIS formulas trees of client
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of List&lt;MisFormulaTree&gt;</returns>
        ApiResponse<List<MisFormulaTree>> ChartsGetFormulaListWithHttpInfo (string clientId);
        /// <summary>
        /// Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>FormulaStatement</returns>
        FormulaStatement ChartsGetFormulaStatement (string formula, DateTime? date, string periodName, int? periodsCount, string clientId);

        /// <summary>
        /// Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of FormulaStatement</returns>
        ApiResponse<FormulaStatement> ChartsGetFormulaStatementWithHttpInfo (string formula, DateTime? date, string periodName, int? periodsCount, string clientId);
        /// <summary>
        /// Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Statement</returns>
        Statement ChartsGetStatement (string code, DateTime? date, string periodName, int? periodsCount, string clientId);

        /// <summary>
        /// Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Statement</returns>
        ApiResponse<Statement> ChartsGetStatementWithHttpInfo (string code, DateTime? date, string periodName, int? periodsCount, string clientId);
        /// <summary>
        /// Validates given formula for errors
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="clientId"></param>
        /// <returns>string</returns>
        string ChartsValidateFormula (string formula, string clientId);

        /// <summary>
        /// Validates given formula for errors
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> ChartsValidateFormulaWithHttpInfo (string formula, string clientId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Gets list of MIS formulas trees of client
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of List&lt;MisFormulaTree&gt;</returns>
        System.Threading.Tasks.Task<List<MisFormulaTree>> ChartsGetFormulaListAsync (string clientId);

        /// <summary>
        /// Gets list of MIS formulas trees of client
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (List&lt;MisFormulaTree&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<MisFormulaTree>>> ChartsGetFormulaListAsyncWithHttpInfo (string clientId);
        /// <summary>
        /// Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of FormulaStatement</returns>
        System.Threading.Tasks.Task<FormulaStatement> ChartsGetFormulaStatementAsync (string formula, DateTime? date, string periodName, int? periodsCount, string clientId);

        /// <summary>
        /// Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (FormulaStatement)</returns>
        System.Threading.Tasks.Task<ApiResponse<FormulaStatement>> ChartsGetFormulaStatementAsyncWithHttpInfo (string formula, DateTime? date, string periodName, int? periodsCount, string clientId);
        /// <summary>
        /// Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Statement</returns>
        System.Threading.Tasks.Task<Statement> ChartsGetStatementAsync (string code, DateTime? date, string periodName, int? periodsCount, string clientId);

        /// <summary>
        /// Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Statement)</returns>
        System.Threading.Tasks.Task<ApiResponse<Statement>> ChartsGetStatementAsyncWithHttpInfo (string code, DateTime? date, string periodName, int? periodsCount, string clientId);
        /// <summary>
        /// Validates given formula for errors
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> ChartsValidateFormulaAsync (string formula, string clientId);

        /// <summary>
        /// Validates given formula for errors
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> ChartsValidateFormulaAsyncWithHttpInfo (string formula, string clientId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ChartsApi : IChartsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ChartsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ChartsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ChartsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ChartsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Gets list of MIS formulas trees of client 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>List&lt;MisFormulaTree&gt;</returns>
        public List<MisFormulaTree> ChartsGetFormulaList (string clientId)
        {
             ApiResponse<List<MisFormulaTree>> localVarResponse = ChartsGetFormulaListWithHttpInfo(clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Gets list of MIS formulas trees of client 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of List&lt;MisFormulaTree&gt;</returns>
        public ApiResponse< List<MisFormulaTree> > ChartsGetFormulaListWithHttpInfo (string clientId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling ChartsApi->ChartsGetFormulaList");

            var localVarPath = "/api/v1/clients/{clientId}/charts/formula/templates";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ChartsGetFormulaList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<MisFormulaTree>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<MisFormulaTree>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<MisFormulaTree>)));
        }

        /// <summary>
        /// Gets list of MIS formulas trees of client 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of List&lt;MisFormulaTree&gt;</returns>
        public async System.Threading.Tasks.Task<List<MisFormulaTree>> ChartsGetFormulaListAsync (string clientId)
        {
             ApiResponse<List<MisFormulaTree>> localVarResponse = await ChartsGetFormulaListAsyncWithHttpInfo(clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Gets list of MIS formulas trees of client 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (List&lt;MisFormulaTree&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<MisFormulaTree>>> ChartsGetFormulaListAsyncWithHttpInfo (string clientId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling ChartsApi->ChartsGetFormulaList");

            var localVarPath = "/api/v1/clients/{clientId}/charts/formula/templates";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ChartsGetFormulaList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<MisFormulaTree>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<MisFormulaTree>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<MisFormulaTree>)));
        }

        /// <summary>
        /// Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>FormulaStatement</returns>
        public FormulaStatement ChartsGetFormulaStatement (string formula, DateTime? date, string periodName, int? periodsCount, string clientId)
        {
             ApiResponse<FormulaStatement> localVarResponse = ChartsGetFormulaStatementWithHttpInfo(formula, date, periodName, periodsCount, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of FormulaStatement</returns>
        public ApiResponse< FormulaStatement > ChartsGetFormulaStatementWithHttpInfo (string formula, DateTime? date, string periodName, int? periodsCount, string clientId)
        {
            // verify the required parameter 'formula' is set
            if (formula == null)
                throw new ApiException(400, "Missing required parameter 'formula' when calling ChartsApi->ChartsGetFormulaStatement");
            // verify the required parameter 'date' is set
            if (date == null)
                throw new ApiException(400, "Missing required parameter 'date' when calling ChartsApi->ChartsGetFormulaStatement");
            // verify the required parameter 'periodName' is set
            if (periodName == null)
                throw new ApiException(400, "Missing required parameter 'periodName' when calling ChartsApi->ChartsGetFormulaStatement");
            // verify the required parameter 'periodsCount' is set
            if (periodsCount == null)
                throw new ApiException(400, "Missing required parameter 'periodsCount' when calling ChartsApi->ChartsGetFormulaStatement");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling ChartsApi->ChartsGetFormulaStatement");

            var localVarPath = "/api/v1/clients/{clientId}/charts/formula";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (formula != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "formula", formula)); // query parameter
            if (date != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "date", date)); // query parameter
            if (periodName != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "periodName", periodName)); // query parameter
            if (periodsCount != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "periodsCount", periodsCount)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ChartsGetFormulaStatement", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<FormulaStatement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FormulaStatement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(FormulaStatement)));
        }

        /// <summary>
        /// Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of FormulaStatement</returns>
        public async System.Threading.Tasks.Task<FormulaStatement> ChartsGetFormulaStatementAsync (string formula, DateTime? date, string periodName, int? periodsCount, string clientId)
        {
             ApiResponse<FormulaStatement> localVarResponse = await ChartsGetFormulaStatementAsyncWithHttpInfo(formula, date, periodName, periodsCount, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Gets period values of given formula  periods: year, quarter, month, day  maximum periods count - 12 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (FormulaStatement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<FormulaStatement>> ChartsGetFormulaStatementAsyncWithHttpInfo (string formula, DateTime? date, string periodName, int? periodsCount, string clientId)
        {
            // verify the required parameter 'formula' is set
            if (formula == null)
                throw new ApiException(400, "Missing required parameter 'formula' when calling ChartsApi->ChartsGetFormulaStatement");
            // verify the required parameter 'date' is set
            if (date == null)
                throw new ApiException(400, "Missing required parameter 'date' when calling ChartsApi->ChartsGetFormulaStatement");
            // verify the required parameter 'periodName' is set
            if (periodName == null)
                throw new ApiException(400, "Missing required parameter 'periodName' when calling ChartsApi->ChartsGetFormulaStatement");
            // verify the required parameter 'periodsCount' is set
            if (periodsCount == null)
                throw new ApiException(400, "Missing required parameter 'periodsCount' when calling ChartsApi->ChartsGetFormulaStatement");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling ChartsApi->ChartsGetFormulaStatement");

            var localVarPath = "/api/v1/clients/{clientId}/charts/formula";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (formula != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "formula", formula)); // query parameter
            if (date != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "date", date)); // query parameter
            if (periodName != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "periodName", periodName)); // query parameter
            if (periodsCount != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "periodsCount", periodsCount)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ChartsGetFormulaStatement", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<FormulaStatement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FormulaStatement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(FormulaStatement)));
        }

        /// <summary>
        /// Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Statement</returns>
        public Statement ChartsGetStatement (string code, DateTime? date, string periodName, int? periodsCount, string clientId)
        {
             ApiResponse<Statement> localVarResponse = ChartsGetStatementWithHttpInfo(code, date, periodName, periodsCount, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Statement</returns>
        public ApiResponse< Statement > ChartsGetStatementWithHttpInfo (string code, DateTime? date, string periodName, int? periodsCount, string clientId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling ChartsApi->ChartsGetStatement");
            // verify the required parameter 'date' is set
            if (date == null)
                throw new ApiException(400, "Missing required parameter 'date' when calling ChartsApi->ChartsGetStatement");
            // verify the required parameter 'periodName' is set
            if (periodName == null)
                throw new ApiException(400, "Missing required parameter 'periodName' when calling ChartsApi->ChartsGetStatement");
            // verify the required parameter 'periodsCount' is set
            if (periodsCount == null)
                throw new ApiException(400, "Missing required parameter 'periodsCount' when calling ChartsApi->ChartsGetStatement");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling ChartsApi->ChartsGetStatement");

            var localVarPath = "/api/v1/clients/{clientId}/charts/statement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (code != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "code", code)); // query parameter
            if (date != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "date", date)); // query parameter
            if (periodName != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "periodName", periodName)); // query parameter
            if (periodsCount != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "periodsCount", periodsCount)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ChartsGetStatement", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Statement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Statement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Statement)));
        }

        /// <summary>
        /// Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Statement</returns>
        public async System.Threading.Tasks.Task<Statement> ChartsGetStatementAsync (string code, DateTime? date, string periodName, int? periodsCount, string clientId)
        {
             ApiResponse<Statement> localVarResponse = await ChartsGetStatementAsyncWithHttpInfo(code, date, periodName, periodsCount, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Gets list of COA balances within given period  periods: year, quarter, month, day  maximum periods count - 12 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="date"></param>
        /// <param name="periodName"></param>
        /// <param name="periodsCount"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Statement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Statement>> ChartsGetStatementAsyncWithHttpInfo (string code, DateTime? date, string periodName, int? periodsCount, string clientId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling ChartsApi->ChartsGetStatement");
            // verify the required parameter 'date' is set
            if (date == null)
                throw new ApiException(400, "Missing required parameter 'date' when calling ChartsApi->ChartsGetStatement");
            // verify the required parameter 'periodName' is set
            if (periodName == null)
                throw new ApiException(400, "Missing required parameter 'periodName' when calling ChartsApi->ChartsGetStatement");
            // verify the required parameter 'periodsCount' is set
            if (periodsCount == null)
                throw new ApiException(400, "Missing required parameter 'periodsCount' when calling ChartsApi->ChartsGetStatement");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling ChartsApi->ChartsGetStatement");

            var localVarPath = "/api/v1/clients/{clientId}/charts/statement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (code != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "code", code)); // query parameter
            if (date != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "date", date)); // query parameter
            if (periodName != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "periodName", periodName)); // query parameter
            if (periodsCount != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "periodsCount", periodsCount)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ChartsGetStatement", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Statement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Statement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Statement)));
        }

        /// <summary>
        /// Validates given formula for errors 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="clientId"></param>
        /// <returns>string</returns>
        public string ChartsValidateFormula (string formula, string clientId)
        {
             ApiResponse<string> localVarResponse = ChartsValidateFormulaWithHttpInfo(formula, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Validates given formula for errors 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > ChartsValidateFormulaWithHttpInfo (string formula, string clientId)
        {
            // verify the required parameter 'formula' is set
            if (formula == null)
                throw new ApiException(400, "Missing required parameter 'formula' when calling ChartsApi->ChartsValidateFormula");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling ChartsApi->ChartsValidateFormula");

            var localVarPath = "/api/v1/clients/{clientId}/charts/formula/validate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (formula != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "formula", formula)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ChartsValidateFormula", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
        }

        /// <summary>
        /// Validates given formula for errors 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> ChartsValidateFormulaAsync (string formula, string clientId)
        {
             ApiResponse<string> localVarResponse = await ChartsValidateFormulaAsyncWithHttpInfo(formula, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Validates given formula for errors 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="formula"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> ChartsValidateFormulaAsyncWithHttpInfo (string formula, string clientId)
        {
            // verify the required parameter 'formula' is set
            if (formula == null)
                throw new ApiException(400, "Missing required parameter 'formula' when calling ChartsApi->ChartsValidateFormula");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling ChartsApi->ChartsValidateFormula");

            var localVarPath = "/api/v1/clients/{clientId}/charts/formula/validate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (formula != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "formula", formula)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ChartsValidateFormula", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
        }

    }
}
