/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface ICostCentersApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// gets list of costCenters
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>List&lt;CostCenter&gt;</returns>
        List<CostCenter> CostCentersGet (string clientId);

        /// <summary>
        /// gets list of costCenters
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of List&lt;CostCenter&gt;</returns>
        ApiResponse<List<CostCenter>> CostCentersGetWithHttpInfo (string clientId);
        /// <summary>
        /// Get costCenter by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <returns>CostCenter</returns>
        CostCenter CostCentersGetByCode (string code, string clientId);

        /// <summary>
        /// Get costCenter by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of CostCenter</returns>
        ApiResponse<CostCenter> CostCentersGetByCodeWithHttpInfo (string code, string clientId);
        /// <summary>
        /// Get costCenter by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>CostCenter</returns>
        CostCenter CostCentersGet_0 (int? id, string clientId);

        /// <summary>
        /// Get costCenter by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of CostCenter</returns>
        ApiResponse<CostCenter> CostCentersGet_0WithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Save costCenter
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="costCenter"></param>
        /// <param name="clientId"></param>
        /// <returns>CostCenter</returns>
        CostCenter CostCentersPost (CostCenter costCenter, string clientId);

        /// <summary>
        /// Save costCenter
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="costCenter"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of CostCenter</returns>
        ApiResponse<CostCenter> CostCentersPostWithHttpInfo (CostCenter costCenter, string clientId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// gets list of costCenters
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of List&lt;CostCenter&gt;</returns>
        System.Threading.Tasks.Task<List<CostCenter>> CostCentersGetAsync (string clientId);

        /// <summary>
        /// gets list of costCenters
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (List&lt;CostCenter&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<CostCenter>>> CostCentersGetAsyncWithHttpInfo (string clientId);
        /// <summary>
        /// Get costCenter by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of CostCenter</returns>
        System.Threading.Tasks.Task<CostCenter> CostCentersGetByCodeAsync (string code, string clientId);

        /// <summary>
        /// Get costCenter by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (CostCenter)</returns>
        System.Threading.Tasks.Task<ApiResponse<CostCenter>> CostCentersGetByCodeAsyncWithHttpInfo (string code, string clientId);
        /// <summary>
        /// Get costCenter by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of CostCenter</returns>
        System.Threading.Tasks.Task<CostCenter> CostCentersGet_0Async (int? id, string clientId);

        /// <summary>
        /// Get costCenter by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (CostCenter)</returns>
        System.Threading.Tasks.Task<ApiResponse<CostCenter>> CostCentersGet_0AsyncWithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Save costCenter
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="costCenter"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of CostCenter</returns>
        System.Threading.Tasks.Task<CostCenter> CostCentersPostAsync (CostCenter costCenter, string clientId);

        /// <summary>
        /// Save costCenter
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="costCenter"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (CostCenter)</returns>
        System.Threading.Tasks.Task<ApiResponse<CostCenter>> CostCentersPostAsyncWithHttpInfo (CostCenter costCenter, string clientId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class CostCentersApi : ICostCentersApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="CostCentersApi"/> class.
        /// </summary>
        /// <returns></returns>
        public CostCentersApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="CostCentersApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public CostCentersApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// gets list of costCenters 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>List&lt;CostCenter&gt;</returns>
        public List<CostCenter> CostCentersGet (string clientId)
        {
             ApiResponse<List<CostCenter>> localVarResponse = CostCentersGetWithHttpInfo(clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// gets list of costCenters 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of List&lt;CostCenter&gt;</returns>
        public ApiResponse< List<CostCenter> > CostCentersGetWithHttpInfo (string clientId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CostCentersApi->CostCentersGet");

            var localVarPath = "/api/v1/clients/{clientId}/costcenters";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CostCentersGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<CostCenter>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<CostCenter>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<CostCenter>)));
        }

        /// <summary>
        /// gets list of costCenters 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of List&lt;CostCenter&gt;</returns>
        public async System.Threading.Tasks.Task<List<CostCenter>> CostCentersGetAsync (string clientId)
        {
             ApiResponse<List<CostCenter>> localVarResponse = await CostCentersGetAsyncWithHttpInfo(clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// gets list of costCenters 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (List&lt;CostCenter&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<CostCenter>>> CostCentersGetAsyncWithHttpInfo (string clientId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CostCentersApi->CostCentersGet");

            var localVarPath = "/api/v1/clients/{clientId}/costcenters";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CostCentersGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<CostCenter>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<CostCenter>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<CostCenter>)));
        }

        /// <summary>
        /// Get costCenter by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <returns>CostCenter</returns>
        public CostCenter CostCentersGetByCode (string code, string clientId)
        {
             ApiResponse<CostCenter> localVarResponse = CostCentersGetByCodeWithHttpInfo(code, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get costCenter by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of CostCenter</returns>
        public ApiResponse< CostCenter > CostCentersGetByCodeWithHttpInfo (string code, string clientId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling CostCentersApi->CostCentersGetByCode");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CostCentersApi->CostCentersGetByCode");

            var localVarPath = "/api/v1/clients/{clientId}/costcenters/byCode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CostCentersGetByCode", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CostCenter>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CostCenter) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CostCenter)));
        }

        /// <summary>
        /// Get costCenter by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of CostCenter</returns>
        public async System.Threading.Tasks.Task<CostCenter> CostCentersGetByCodeAsync (string code, string clientId)
        {
             ApiResponse<CostCenter> localVarResponse = await CostCentersGetByCodeAsyncWithHttpInfo(code, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get costCenter by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (CostCenter)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CostCenter>> CostCentersGetByCodeAsyncWithHttpInfo (string code, string clientId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling CostCentersApi->CostCentersGetByCode");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CostCentersApi->CostCentersGetByCode");

            var localVarPath = "/api/v1/clients/{clientId}/costcenters/byCode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CostCentersGetByCode", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CostCenter>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CostCenter) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CostCenter)));
        }

        /// <summary>
        /// Get costCenter by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>CostCenter</returns>
        public CostCenter CostCentersGet_0 (int? id, string clientId)
        {
             ApiResponse<CostCenter> localVarResponse = CostCentersGet_0WithHttpInfo(id, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get costCenter by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of CostCenter</returns>
        public ApiResponse< CostCenter > CostCentersGet_0WithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling CostCentersApi->CostCentersGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CostCentersApi->CostCentersGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/costcenters/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CostCentersGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CostCenter>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CostCenter) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CostCenter)));
        }

        /// <summary>
        /// Get costCenter by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of CostCenter</returns>
        public async System.Threading.Tasks.Task<CostCenter> CostCentersGet_0Async (int? id, string clientId)
        {
             ApiResponse<CostCenter> localVarResponse = await CostCentersGet_0AsyncWithHttpInfo(id, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get costCenter by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (CostCenter)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CostCenter>> CostCentersGet_0AsyncWithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling CostCentersApi->CostCentersGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CostCentersApi->CostCentersGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/costcenters/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CostCentersGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CostCenter>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CostCenter) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CostCenter)));
        }

        /// <summary>
        /// Save costCenter 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="costCenter"></param>
        /// <param name="clientId"></param>
        /// <returns>CostCenter</returns>
        public CostCenter CostCentersPost (CostCenter costCenter, string clientId)
        {
             ApiResponse<CostCenter> localVarResponse = CostCentersPostWithHttpInfo(costCenter, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Save costCenter 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="costCenter"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of CostCenter</returns>
        public ApiResponse< CostCenter > CostCentersPostWithHttpInfo (CostCenter costCenter, string clientId)
        {
            // verify the required parameter 'costCenter' is set
            if (costCenter == null)
                throw new ApiException(400, "Missing required parameter 'costCenter' when calling CostCentersApi->CostCentersPost");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CostCentersApi->CostCentersPost");

            var localVarPath = "/api/v1/clients/{clientId}/costcenters";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (costCenter != null && costCenter.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(costCenter); // http body (model) parameter
            }
            else
            {
                localVarPostBody = costCenter; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CostCentersPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CostCenter>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CostCenter) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CostCenter)));
        }

        /// <summary>
        /// Save costCenter 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="costCenter"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of CostCenter</returns>
        public async System.Threading.Tasks.Task<CostCenter> CostCentersPostAsync (CostCenter costCenter, string clientId)
        {
             ApiResponse<CostCenter> localVarResponse = await CostCentersPostAsyncWithHttpInfo(costCenter, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Save costCenter 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="costCenter"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (CostCenter)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<CostCenter>> CostCentersPostAsyncWithHttpInfo (CostCenter costCenter, string clientId)
        {
            // verify the required parameter 'costCenter' is set
            if (costCenter == null)
                throw new ApiException(400, "Missing required parameter 'costCenter' when calling CostCentersApi->CostCentersPost");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CostCentersApi->CostCentersPost");

            var localVarPath = "/api/v1/clients/{clientId}/costcenters";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (costCenter != null && costCenter.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(costCenter); // http body (model) parameter
            }
            else
            {
                localVarPostBody = costCenter; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CostCentersPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<CostCenter>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (CostCenter) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(CostCenter)));
        }

    }
}
