/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface ICurrenciesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Retreives list of currencies
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;Currency&gt;</returns>
        List<Currency> CurrenciesGet (string clientId, string fiscalYearId);

        /// <summary>
        /// Retreives list of currencies
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;Currency&gt;</returns>
        ApiResponse<List<Currency>> CurrenciesGetWithHttpInfo (string clientId, string fiscalYearId);
        /// <summary>
        /// Get country by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Currency</returns>
        Currency CurrenciesGetByCode (string code, string clientId, string fiscalYearId);

        /// <summary>
        /// Get country by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of Currency</returns>
        ApiResponse<Currency> CurrenciesGetByCodeWithHttpInfo (string code, string clientId, string fiscalYearId);
        /// <summary>
        /// Retreives list of currencies
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;Currency&gt;</returns>
        List<Currency> CurrenciesGet_0 (DateTime? date, string clientId, string fiscalYearId);

        /// <summary>
        /// Retreives list of currencies
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;Currency&gt;</returns>
        ApiResponse<List<Currency>> CurrenciesGet_0WithHttpInfo (DateTime? date, string clientId, string fiscalYearId);
        /// <summary>
        /// Get country by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Currency</returns>
        Currency CurrenciesGet_1 (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Get country by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of Currency</returns>
        ApiResponse<Currency> CurrenciesGet_1WithHttpInfo (int? id, string clientId, string fiscalYearId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Retreives list of currencies
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;Currency&gt;</returns>
        System.Threading.Tasks.Task<List<Currency>> CurrenciesGetAsync (string clientId, string fiscalYearId);

        /// <summary>
        /// Retreives list of currencies
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;Currency&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Currency>>> CurrenciesGetAsyncWithHttpInfo (string clientId, string fiscalYearId);
        /// <summary>
        /// Get country by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of Currency</returns>
        System.Threading.Tasks.Task<Currency> CurrenciesGetByCodeAsync (string code, string clientId, string fiscalYearId);

        /// <summary>
        /// Get country by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (Currency)</returns>
        System.Threading.Tasks.Task<ApiResponse<Currency>> CurrenciesGetByCodeAsyncWithHttpInfo (string code, string clientId, string fiscalYearId);
        /// <summary>
        /// Retreives list of currencies
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;Currency&gt;</returns>
        System.Threading.Tasks.Task<List<Currency>> CurrenciesGet_0Async (DateTime? date, string clientId, string fiscalYearId);

        /// <summary>
        /// Retreives list of currencies
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;Currency&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Currency>>> CurrenciesGet_0AsyncWithHttpInfo (DateTime? date, string clientId, string fiscalYearId);
        /// <summary>
        /// Get country by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of Currency</returns>
        System.Threading.Tasks.Task<Currency> CurrenciesGet_1Async (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Get country by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (Currency)</returns>
        System.Threading.Tasks.Task<ApiResponse<Currency>> CurrenciesGet_1AsyncWithHttpInfo (int? id, string clientId, string fiscalYearId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class CurrenciesApi : ICurrenciesApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="CurrenciesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public CurrenciesApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="CurrenciesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public CurrenciesApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Retreives list of currencies 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;Currency&gt;</returns>
        public List<Currency> CurrenciesGet (string clientId, string fiscalYearId)
        {
             ApiResponse<List<Currency>> localVarResponse = CurrenciesGetWithHttpInfo(clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retreives list of currencies 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;Currency&gt;</returns>
        public ApiResponse< List<Currency> > CurrenciesGetWithHttpInfo (string clientId, string fiscalYearId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CurrenciesApi->CurrenciesGet");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling CurrenciesApi->CurrenciesGet");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CurrenciesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Currency>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Currency>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Currency>)));
        }

        /// <summary>
        /// Retreives list of currencies 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;Currency&gt;</returns>
        public async System.Threading.Tasks.Task<List<Currency>> CurrenciesGetAsync (string clientId, string fiscalYearId)
        {
             ApiResponse<List<Currency>> localVarResponse = await CurrenciesGetAsyncWithHttpInfo(clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retreives list of currencies 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;Currency&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Currency>>> CurrenciesGetAsyncWithHttpInfo (string clientId, string fiscalYearId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CurrenciesApi->CurrenciesGet");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling CurrenciesApi->CurrenciesGet");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CurrenciesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Currency>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Currency>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Currency>)));
        }

        /// <summary>
        /// Get country by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Currency</returns>
        public Currency CurrenciesGetByCode (string code, string clientId, string fiscalYearId)
        {
             ApiResponse<Currency> localVarResponse = CurrenciesGetByCodeWithHttpInfo(code, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get country by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of Currency</returns>
        public ApiResponse< Currency > CurrenciesGetByCodeWithHttpInfo (string code, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling CurrenciesApi->CurrenciesGetByCode");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CurrenciesApi->CurrenciesGetByCode");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling CurrenciesApi->CurrenciesGetByCode");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/bycode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CurrenciesGetByCode", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Currency>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Currency) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Currency)));
        }

        /// <summary>
        /// Get country by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of Currency</returns>
        public async System.Threading.Tasks.Task<Currency> CurrenciesGetByCodeAsync (string code, string clientId, string fiscalYearId)
        {
             ApiResponse<Currency> localVarResponse = await CurrenciesGetByCodeAsyncWithHttpInfo(code, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get country by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (Currency)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Currency>> CurrenciesGetByCodeAsyncWithHttpInfo (string code, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling CurrenciesApi->CurrenciesGetByCode");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CurrenciesApi->CurrenciesGetByCode");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling CurrenciesApi->CurrenciesGetByCode");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/bycode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CurrenciesGetByCode", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Currency>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Currency) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Currency)));
        }

        /// <summary>
        /// Retreives list of currencies 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;Currency&gt;</returns>
        public List<Currency> CurrenciesGet_0 (DateTime? date, string clientId, string fiscalYearId)
        {
             ApiResponse<List<Currency>> localVarResponse = CurrenciesGet_0WithHttpInfo(date, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retreives list of currencies 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;Currency&gt;</returns>
        public ApiResponse< List<Currency> > CurrenciesGet_0WithHttpInfo (DateTime? date, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'date' is set
            if (date == null)
                throw new ApiException(400, "Missing required parameter 'date' when calling CurrenciesApi->CurrenciesGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CurrenciesApi->CurrenciesGet_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling CurrenciesApi->CurrenciesGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/bydate/{date}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (date != null) localVarPathParams.Add("date", this.Configuration.ApiClient.ParameterToString(date)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CurrenciesGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Currency>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Currency>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Currency>)));
        }

        /// <summary>
        /// Retreives list of currencies 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;Currency&gt;</returns>
        public async System.Threading.Tasks.Task<List<Currency>> CurrenciesGet_0Async (DateTime? date, string clientId, string fiscalYearId)
        {
             ApiResponse<List<Currency>> localVarResponse = await CurrenciesGet_0AsyncWithHttpInfo(date, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retreives list of currencies 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;Currency&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Currency>>> CurrenciesGet_0AsyncWithHttpInfo (DateTime? date, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'date' is set
            if (date == null)
                throw new ApiException(400, "Missing required parameter 'date' when calling CurrenciesApi->CurrenciesGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CurrenciesApi->CurrenciesGet_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling CurrenciesApi->CurrenciesGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/bydate/{date}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (date != null) localVarPathParams.Add("date", this.Configuration.ApiClient.ParameterToString(date)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CurrenciesGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Currency>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Currency>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Currency>)));
        }

        /// <summary>
        /// Get country by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Currency</returns>
        public Currency CurrenciesGet_1 (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<Currency> localVarResponse = CurrenciesGet_1WithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get country by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of Currency</returns>
        public ApiResponse< Currency > CurrenciesGet_1WithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling CurrenciesApi->CurrenciesGet_1");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CurrenciesApi->CurrenciesGet_1");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling CurrenciesApi->CurrenciesGet_1");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CurrenciesGet_1", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Currency>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Currency) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Currency)));
        }

        /// <summary>
        /// Get country by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of Currency</returns>
        public async System.Threading.Tasks.Task<Currency> CurrenciesGet_1Async (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<Currency> localVarResponse = await CurrenciesGet_1AsyncWithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get country by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (Currency)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Currency>> CurrenciesGet_1AsyncWithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling CurrenciesApi->CurrenciesGet_1");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling CurrenciesApi->CurrenciesGet_1");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling CurrenciesApi->CurrenciesGet_1");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/currencies/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("CurrenciesGet_1", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Currency>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Currency) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Currency)));
        }

    }
}
