/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IPartiesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Delete party by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Object</returns>
        Object PartiesDelete (int? id, string clientId);

        /// <summary>
        /// Delete party by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Object</returns>
        ApiResponse<Object> PartiesDeleteWithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Delete creditor by party id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Object</returns>
        Object PartiesDeleteCreditor (int? id, string clientId);

        /// <summary>
        /// Delete creditor by party id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Object</returns>
        ApiResponse<Object> PartiesDeleteCreditorWithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Delete debtor by party id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Object</returns>
        Object PartiesDeleteDebtor (int? id, string clientId);

        /// <summary>
        /// Delete debtor by party id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Object</returns>
        ApiResponse<Object> PartiesDeleteDebtorWithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Retreives list of parties
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>List&lt;Party&gt;</returns>
        List<Party> PartiesGet (string clientId);

        /// <summary>
        /// Retreives list of parties
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of List&lt;Party&gt;</returns>
        ApiResponse<List<Party>> PartiesGetWithHttpInfo (string clientId);
        /// <summary>
        /// Get party by freePartyNum
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="freePartyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Party</returns>
        Party PartiesGetByFreeNumber (string freePartyNum, string clientId);

        /// <summary>
        /// Get party by freePartyNum
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="freePartyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Party</returns>
        ApiResponse<Party> PartiesGetByFreeNumberWithHttpInfo (string freePartyNum, string clientId);
        /// <summary>
        /// Get party by partyNum
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="partyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Party</returns>
        Party PartiesGetByNumber (int? partyNum, string clientId);

        /// <summary>
        /// Get party by partyNum
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="partyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Party</returns>
        ApiResponse<Party> PartiesGetByNumberWithHttpInfo (int? partyNum, string clientId);
        /// <summary>
        /// Get party by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Party</returns>
        Party PartiesGet_0 (int? id, string clientId);

        /// <summary>
        /// Get party by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Party</returns>
        ApiResponse<Party> PartiesGet_0WithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Save party
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="party"></param>
        /// <param name="clientId"></param>
        /// <returns>Party</returns>
        Party PartiesPost (Party party, string clientId);

        /// <summary>
        /// Save party
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="party"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Party</returns>
        ApiResponse<Party> PartiesPostWithHttpInfo (Party party, string clientId);
        /// <summary>
        /// Assign creditor to party creditor
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="creditor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Creditor</returns>
        Creditor PartiesPost_0 (Creditor creditor, int? id, string clientId);

        /// <summary>
        /// Assign creditor to party creditor
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="creditor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Creditor</returns>
        ApiResponse<Creditor> PartiesPost_0WithHttpInfo (Creditor creditor, int? id, string clientId);
        /// <summary>
        /// Assign debtor to party
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="debtor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Debtor</returns>
        Debtor PartiesPost_1 (Debtor debtor, int? id, string clientId);

        /// <summary>
        /// Assign debtor to party
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="debtor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Debtor</returns>
        ApiResponse<Debtor> PartiesPost_1WithHttpInfo (Debtor debtor, int? id, string clientId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Delete party by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Object</returns>
        System.Threading.Tasks.Task<Object> PartiesDeleteAsync (int? id, string clientId);

        /// <summary>
        /// Delete party by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Object)</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PartiesDeleteAsyncWithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Delete creditor by party id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Object</returns>
        System.Threading.Tasks.Task<Object> PartiesDeleteCreditorAsync (int? id, string clientId);

        /// <summary>
        /// Delete creditor by party id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Object)</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PartiesDeleteCreditorAsyncWithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Delete debtor by party id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Object</returns>
        System.Threading.Tasks.Task<Object> PartiesDeleteDebtorAsync (int? id, string clientId);

        /// <summary>
        /// Delete debtor by party id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Object)</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PartiesDeleteDebtorAsyncWithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Retreives list of parties
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of List&lt;Party&gt;</returns>
        System.Threading.Tasks.Task<List<Party>> PartiesGetAsync (string clientId);

        /// <summary>
        /// Retreives list of parties
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (List&lt;Party&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<Party>>> PartiesGetAsyncWithHttpInfo (string clientId);
        /// <summary>
        /// Get party by freePartyNum
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="freePartyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Party</returns>
        System.Threading.Tasks.Task<Party> PartiesGetByFreeNumberAsync (string freePartyNum, string clientId);

        /// <summary>
        /// Get party by freePartyNum
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="freePartyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Party)</returns>
        System.Threading.Tasks.Task<ApiResponse<Party>> PartiesGetByFreeNumberAsyncWithHttpInfo (string freePartyNum, string clientId);
        /// <summary>
        /// Get party by partyNum
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="partyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Party</returns>
        System.Threading.Tasks.Task<Party> PartiesGetByNumberAsync (int? partyNum, string clientId);

        /// <summary>
        /// Get party by partyNum
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="partyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Party)</returns>
        System.Threading.Tasks.Task<ApiResponse<Party>> PartiesGetByNumberAsyncWithHttpInfo (int? partyNum, string clientId);
        /// <summary>
        /// Get party by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Party</returns>
        System.Threading.Tasks.Task<Party> PartiesGet_0Async (int? id, string clientId);

        /// <summary>
        /// Get party by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Party)</returns>
        System.Threading.Tasks.Task<ApiResponse<Party>> PartiesGet_0AsyncWithHttpInfo (int? id, string clientId);
        /// <summary>
        /// Save party
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="party"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Party</returns>
        System.Threading.Tasks.Task<Party> PartiesPostAsync (Party party, string clientId);

        /// <summary>
        /// Save party
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="party"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Party)</returns>
        System.Threading.Tasks.Task<ApiResponse<Party>> PartiesPostAsyncWithHttpInfo (Party party, string clientId);
        /// <summary>
        /// Assign creditor to party creditor
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="creditor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Creditor</returns>
        System.Threading.Tasks.Task<Creditor> PartiesPost_0Async (Creditor creditor, int? id, string clientId);

        /// <summary>
        /// Assign creditor to party creditor
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="creditor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Creditor)</returns>
        System.Threading.Tasks.Task<ApiResponse<Creditor>> PartiesPost_0AsyncWithHttpInfo (Creditor creditor, int? id, string clientId);
        /// <summary>
        /// Assign debtor to party
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="debtor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Debtor</returns>
        System.Threading.Tasks.Task<Debtor> PartiesPost_1Async (Debtor debtor, int? id, string clientId);

        /// <summary>
        /// Assign debtor to party
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="debtor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Debtor)</returns>
        System.Threading.Tasks.Task<ApiResponse<Debtor>> PartiesPost_1AsyncWithHttpInfo (Debtor debtor, int? id, string clientId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class PartiesApi : IPartiesApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="PartiesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public PartiesApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PartiesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public PartiesApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Delete party by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Object</returns>
        public Object PartiesDelete (int? id, string clientId)
        {
             ApiResponse<Object> localVarResponse = PartiesDeleteWithHttpInfo(id, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Delete party by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Object</returns>
        public ApiResponse< Object > PartiesDeleteWithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesDelete");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesDelete");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// Delete party by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Object</returns>
        public async System.Threading.Tasks.Task<Object> PartiesDeleteAsync (int? id, string clientId)
        {
             ApiResponse<Object> localVarResponse = await PartiesDeleteAsyncWithHttpInfo(id, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Delete party by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Object)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PartiesDeleteAsyncWithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesDelete");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesDelete");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// Delete creditor by party id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Object</returns>
        public Object PartiesDeleteCreditor (int? id, string clientId)
        {
             ApiResponse<Object> localVarResponse = PartiesDeleteCreditorWithHttpInfo(id, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Delete creditor by party id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Object</returns>
        public ApiResponse< Object > PartiesDeleteCreditorWithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesDeleteCreditor");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesDeleteCreditor");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}/creditor";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesDeleteCreditor", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// Delete creditor by party id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Object</returns>
        public async System.Threading.Tasks.Task<Object> PartiesDeleteCreditorAsync (int? id, string clientId)
        {
             ApiResponse<Object> localVarResponse = await PartiesDeleteCreditorAsyncWithHttpInfo(id, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Delete creditor by party id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Object)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PartiesDeleteCreditorAsyncWithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesDeleteCreditor");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesDeleteCreditor");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}/creditor";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesDeleteCreditor", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// Delete debtor by party id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Object</returns>
        public Object PartiesDeleteDebtor (int? id, string clientId)
        {
             ApiResponse<Object> localVarResponse = PartiesDeleteDebtorWithHttpInfo(id, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Delete debtor by party id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Object</returns>
        public ApiResponse< Object > PartiesDeleteDebtorWithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesDeleteDebtor");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesDeleteDebtor");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}/debtor";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesDeleteDebtor", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// Delete debtor by party id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Object</returns>
        public async System.Threading.Tasks.Task<Object> PartiesDeleteDebtorAsync (int? id, string clientId)
        {
             ApiResponse<Object> localVarResponse = await PartiesDeleteDebtorAsyncWithHttpInfo(id, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Delete debtor by party id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Object)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PartiesDeleteDebtorAsyncWithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesDeleteDebtor");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesDeleteDebtor");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}/debtor";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesDeleteDebtor", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Object) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Object)));
        }

        /// <summary>
        /// Retreives list of parties 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>List&lt;Party&gt;</returns>
        public List<Party> PartiesGet (string clientId)
        {
             ApiResponse<List<Party>> localVarResponse = PartiesGetWithHttpInfo(clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retreives list of parties 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of List&lt;Party&gt;</returns>
        public ApiResponse< List<Party> > PartiesGetWithHttpInfo (string clientId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesGet");

            var localVarPath = "/api/v1/clients/{clientId}/parties";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Party>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Party>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Party>)));
        }

        /// <summary>
        /// Retreives list of parties 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of List&lt;Party&gt;</returns>
        public async System.Threading.Tasks.Task<List<Party>> PartiesGetAsync (string clientId)
        {
             ApiResponse<List<Party>> localVarResponse = await PartiesGetAsyncWithHttpInfo(clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retreives list of parties 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (List&lt;Party&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<Party>>> PartiesGetAsyncWithHttpInfo (string clientId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesGet");

            var localVarPath = "/api/v1/clients/{clientId}/parties";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<Party>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<Party>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<Party>)));
        }

        /// <summary>
        /// Get party by freePartyNum 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="freePartyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Party</returns>
        public Party PartiesGetByFreeNumber (string freePartyNum, string clientId)
        {
             ApiResponse<Party> localVarResponse = PartiesGetByFreeNumberWithHttpInfo(freePartyNum, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get party by freePartyNum 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="freePartyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Party</returns>
        public ApiResponse< Party > PartiesGetByFreeNumberWithHttpInfo (string freePartyNum, string clientId)
        {
            // verify the required parameter 'freePartyNum' is set
            if (freePartyNum == null)
                throw new ApiException(400, "Missing required parameter 'freePartyNum' when calling PartiesApi->PartiesGetByFreeNumber");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesGetByFreeNumber");

            var localVarPath = "/api/v1/clients/{clientId}/parties/byfreenumber/{freePartyNum}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (freePartyNum != null) localVarPathParams.Add("freePartyNum", this.Configuration.ApiClient.ParameterToString(freePartyNum)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesGetByFreeNumber", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Party>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Party) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Party)));
        }

        /// <summary>
        /// Get party by freePartyNum 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="freePartyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Party</returns>
        public async System.Threading.Tasks.Task<Party> PartiesGetByFreeNumberAsync (string freePartyNum, string clientId)
        {
             ApiResponse<Party> localVarResponse = await PartiesGetByFreeNumberAsyncWithHttpInfo(freePartyNum, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get party by freePartyNum 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="freePartyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Party)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Party>> PartiesGetByFreeNumberAsyncWithHttpInfo (string freePartyNum, string clientId)
        {
            // verify the required parameter 'freePartyNum' is set
            if (freePartyNum == null)
                throw new ApiException(400, "Missing required parameter 'freePartyNum' when calling PartiesApi->PartiesGetByFreeNumber");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesGetByFreeNumber");

            var localVarPath = "/api/v1/clients/{clientId}/parties/byfreenumber/{freePartyNum}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (freePartyNum != null) localVarPathParams.Add("freePartyNum", this.Configuration.ApiClient.ParameterToString(freePartyNum)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesGetByFreeNumber", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Party>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Party) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Party)));
        }

        /// <summary>
        /// Get party by partyNum 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="partyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Party</returns>
        public Party PartiesGetByNumber (int? partyNum, string clientId)
        {
             ApiResponse<Party> localVarResponse = PartiesGetByNumberWithHttpInfo(partyNum, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get party by partyNum 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="partyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Party</returns>
        public ApiResponse< Party > PartiesGetByNumberWithHttpInfo (int? partyNum, string clientId)
        {
            // verify the required parameter 'partyNum' is set
            if (partyNum == null)
                throw new ApiException(400, "Missing required parameter 'partyNum' when calling PartiesApi->PartiesGetByNumber");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesGetByNumber");

            var localVarPath = "/api/v1/clients/{clientId}/parties/bynumber/{partyNum}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (partyNum != null) localVarPathParams.Add("partyNum", this.Configuration.ApiClient.ParameterToString(partyNum)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesGetByNumber", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Party>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Party) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Party)));
        }

        /// <summary>
        /// Get party by partyNum 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="partyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Party</returns>
        public async System.Threading.Tasks.Task<Party> PartiesGetByNumberAsync (int? partyNum, string clientId)
        {
             ApiResponse<Party> localVarResponse = await PartiesGetByNumberAsyncWithHttpInfo(partyNum, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get party by partyNum 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="partyNum"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Party)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Party>> PartiesGetByNumberAsyncWithHttpInfo (int? partyNum, string clientId)
        {
            // verify the required parameter 'partyNum' is set
            if (partyNum == null)
                throw new ApiException(400, "Missing required parameter 'partyNum' when calling PartiesApi->PartiesGetByNumber");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesGetByNumber");

            var localVarPath = "/api/v1/clients/{clientId}/parties/bynumber/{partyNum}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (partyNum != null) localVarPathParams.Add("partyNum", this.Configuration.ApiClient.ParameterToString(partyNum)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesGetByNumber", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Party>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Party) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Party)));
        }

        /// <summary>
        /// Get party by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Party</returns>
        public Party PartiesGet_0 (int? id, string clientId)
        {
             ApiResponse<Party> localVarResponse = PartiesGet_0WithHttpInfo(id, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get party by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Party</returns>
        public ApiResponse< Party > PartiesGet_0WithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Party>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Party) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Party)));
        }

        /// <summary>
        /// Get party by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Party</returns>
        public async System.Threading.Tasks.Task<Party> PartiesGet_0Async (int? id, string clientId)
        {
             ApiResponse<Party> localVarResponse = await PartiesGet_0AsyncWithHttpInfo(id, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get party by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Party)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Party>> PartiesGet_0AsyncWithHttpInfo (int? id, string clientId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Party>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Party) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Party)));
        }

        /// <summary>
        /// Save party 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="party"></param>
        /// <param name="clientId"></param>
        /// <returns>Party</returns>
        public Party PartiesPost (Party party, string clientId)
        {
             ApiResponse<Party> localVarResponse = PartiesPostWithHttpInfo(party, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Save party 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="party"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Party</returns>
        public ApiResponse< Party > PartiesPostWithHttpInfo (Party party, string clientId)
        {
            // verify the required parameter 'party' is set
            if (party == null)
                throw new ApiException(400, "Missing required parameter 'party' when calling PartiesApi->PartiesPost");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesPost");

            var localVarPath = "/api/v1/clients/{clientId}/parties";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (party != null && party.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(party); // http body (model) parameter
            }
            else
            {
                localVarPostBody = party; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Party>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Party) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Party)));
        }

        /// <summary>
        /// Save party 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="party"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Party</returns>
        public async System.Threading.Tasks.Task<Party> PartiesPostAsync (Party party, string clientId)
        {
             ApiResponse<Party> localVarResponse = await PartiesPostAsyncWithHttpInfo(party, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Save party 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="party"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Party)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Party>> PartiesPostAsyncWithHttpInfo (Party party, string clientId)
        {
            // verify the required parameter 'party' is set
            if (party == null)
                throw new ApiException(400, "Missing required parameter 'party' when calling PartiesApi->PartiesPost");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesPost");

            var localVarPath = "/api/v1/clients/{clientId}/parties";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (party != null && party.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(party); // http body (model) parameter
            }
            else
            {
                localVarPostBody = party; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesPost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Party>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Party) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Party)));
        }

        /// <summary>
        /// Assign creditor to party creditor 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="creditor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Creditor</returns>
        public Creditor PartiesPost_0 (Creditor creditor, int? id, string clientId)
        {
             ApiResponse<Creditor> localVarResponse = PartiesPost_0WithHttpInfo(creditor, id, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Assign creditor to party creditor 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="creditor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Creditor</returns>
        public ApiResponse< Creditor > PartiesPost_0WithHttpInfo (Creditor creditor, int? id, string clientId)
        {
            // verify the required parameter 'creditor' is set
            if (creditor == null)
                throw new ApiException(400, "Missing required parameter 'creditor' when calling PartiesApi->PartiesPost_0");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesPost_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesPost_0");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}/creditor";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (creditor != null && creditor.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(creditor); // http body (model) parameter
            }
            else
            {
                localVarPostBody = creditor; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesPost_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Creditor>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Creditor) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Creditor)));
        }

        /// <summary>
        /// Assign creditor to party creditor 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="creditor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Creditor</returns>
        public async System.Threading.Tasks.Task<Creditor> PartiesPost_0Async (Creditor creditor, int? id, string clientId)
        {
             ApiResponse<Creditor> localVarResponse = await PartiesPost_0AsyncWithHttpInfo(creditor, id, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Assign creditor to party creditor 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="creditor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Creditor)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Creditor>> PartiesPost_0AsyncWithHttpInfo (Creditor creditor, int? id, string clientId)
        {
            // verify the required parameter 'creditor' is set
            if (creditor == null)
                throw new ApiException(400, "Missing required parameter 'creditor' when calling PartiesApi->PartiesPost_0");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesPost_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesPost_0");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}/creditor";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (creditor != null && creditor.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(creditor); // http body (model) parameter
            }
            else
            {
                localVarPostBody = creditor; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesPost_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Creditor>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Creditor) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Creditor)));
        }

        /// <summary>
        /// Assign debtor to party 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="debtor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Debtor</returns>
        public Debtor PartiesPost_1 (Debtor debtor, int? id, string clientId)
        {
             ApiResponse<Debtor> localVarResponse = PartiesPost_1WithHttpInfo(debtor, id, clientId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Assign debtor to party 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="debtor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>ApiResponse of Debtor</returns>
        public ApiResponse< Debtor > PartiesPost_1WithHttpInfo (Debtor debtor, int? id, string clientId)
        {
            // verify the required parameter 'debtor' is set
            if (debtor == null)
                throw new ApiException(400, "Missing required parameter 'debtor' when calling PartiesApi->PartiesPost_1");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesPost_1");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesPost_1");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}/debtor";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (debtor != null && debtor.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(debtor); // http body (model) parameter
            }
            else
            {
                localVarPostBody = debtor; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesPost_1", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Debtor>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Debtor) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Debtor)));
        }

        /// <summary>
        /// Assign debtor to party 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="debtor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of Debtor</returns>
        public async System.Threading.Tasks.Task<Debtor> PartiesPost_1Async (Debtor debtor, int? id, string clientId)
        {
             ApiResponse<Debtor> localVarResponse = await PartiesPost_1AsyncWithHttpInfo(debtor, id, clientId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Assign debtor to party 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="debtor"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <returns>Task of ApiResponse (Debtor)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Debtor>> PartiesPost_1AsyncWithHttpInfo (Debtor debtor, int? id, string clientId)
        {
            // verify the required parameter 'debtor' is set
            if (debtor == null)
                throw new ApiException(400, "Missing required parameter 'debtor' when calling PartiesApi->PartiesPost_1");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling PartiesApi->PartiesPost_1");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling PartiesApi->PartiesPost_1");

            var localVarPath = "/api/v1/clients/{clientId}/parties/{id}/debtor";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (debtor != null && debtor.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(debtor); // http body (model) parameter
            }
            else
            {
                localVarPostBody = debtor; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PartiesPost_1", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Debtor>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Debtor) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Debtor)));
        }

    }
}
