/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IVATsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get list of VATs (depricated: use vats/bydate instead )
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;VAT&gt;</returns>
        List<VAT> VATsGet (string clientId, string fiscalYearId);

        /// <summary>
        /// Get list of VATs (depricated: use vats/bydate instead )
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;VAT&gt;</returns>
        ApiResponse<List<VAT>> VATsGetWithHttpInfo (string clientId, string fiscalYearId);
        /// <summary>
        /// Get VAT by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>VAT</returns>
        VAT VATsGetByCode (string code, string clientId, string fiscalYearId);

        /// <summary>
        /// Get VAT by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of VAT</returns>
        ApiResponse<VAT> VATsGetByCodeWithHttpInfo (string code, string clientId, string fiscalYearId);
        /// <summary>
        /// Get VAT by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>VAT</returns>
        VAT VATsGetByCode_0 (int? vatPeriodId, string code, string clientId, string fiscalYearId);

        /// <summary>
        /// Get VAT by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of VAT</returns>
        ApiResponse<VAT> VATsGetByCode_0WithHttpInfo (int? vatPeriodId, string code, string clientId, string fiscalYearId);
        /// <summary>
        /// Get list of VATs by vatPeriodId
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;VAT&gt;</returns>
        List<VAT> VATsGetByVatPeriod (int? vatPeriodId, string clientId, string fiscalYearId);

        /// <summary>
        /// Get list of VATs by vatPeriodId
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;VAT&gt;</returns>
        ApiResponse<List<VAT>> VATsGetByVatPeriodWithHttpInfo (int? vatPeriodId, string clientId, string fiscalYearId);
        /// <summary>
        /// Get list of VATs of period of given date
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;VAT&gt;</returns>
        List<VAT> VATsGet_0 (DateTime? date, string clientId, string fiscalYearId);

        /// <summary>
        /// Get list of VATs of period of given date
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;VAT&gt;</returns>
        ApiResponse<List<VAT>> VATsGet_0WithHttpInfo (DateTime? date, string clientId, string fiscalYearId);
        /// <summary>
        /// Get VAT by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>VAT</returns>
        VAT VATsGet_1 (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Get VAT by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of VAT</returns>
        ApiResponse<VAT> VATsGet_1WithHttpInfo (int? id, string clientId, string fiscalYearId);
        /// <summary>
        /// Get VAT by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>VAT</returns>
        VAT VATsGet_2 (int? vatPeriodId, int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Get VAT by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of VAT</returns>
        ApiResponse<VAT> VATsGet_2WithHttpInfo (int? vatPeriodId, int? id, string clientId, string fiscalYearId);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get list of VATs (depricated: use vats/bydate instead )
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;VAT&gt;</returns>
        System.Threading.Tasks.Task<List<VAT>> VATsGetAsync (string clientId, string fiscalYearId);

        /// <summary>
        /// Get list of VATs (depricated: use vats/bydate instead )
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;VAT&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<VAT>>> VATsGetAsyncWithHttpInfo (string clientId, string fiscalYearId);
        /// <summary>
        /// Get VAT by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of VAT</returns>
        System.Threading.Tasks.Task<VAT> VATsGetByCodeAsync (string code, string clientId, string fiscalYearId);

        /// <summary>
        /// Get VAT by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (VAT)</returns>
        System.Threading.Tasks.Task<ApiResponse<VAT>> VATsGetByCodeAsyncWithHttpInfo (string code, string clientId, string fiscalYearId);
        /// <summary>
        /// Get VAT by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of VAT</returns>
        System.Threading.Tasks.Task<VAT> VATsGetByCode_0Async (int? vatPeriodId, string code, string clientId, string fiscalYearId);

        /// <summary>
        /// Get VAT by code
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (VAT)</returns>
        System.Threading.Tasks.Task<ApiResponse<VAT>> VATsGetByCode_0AsyncWithHttpInfo (int? vatPeriodId, string code, string clientId, string fiscalYearId);
        /// <summary>
        /// Get list of VATs by vatPeriodId
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;VAT&gt;</returns>
        System.Threading.Tasks.Task<List<VAT>> VATsGetByVatPeriodAsync (int? vatPeriodId, string clientId, string fiscalYearId);

        /// <summary>
        /// Get list of VATs by vatPeriodId
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;VAT&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<VAT>>> VATsGetByVatPeriodAsyncWithHttpInfo (int? vatPeriodId, string clientId, string fiscalYearId);
        /// <summary>
        /// Get list of VATs of period of given date
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;VAT&gt;</returns>
        System.Threading.Tasks.Task<List<VAT>> VATsGet_0Async (DateTime? date, string clientId, string fiscalYearId);

        /// <summary>
        /// Get list of VATs of period of given date
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;VAT&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<VAT>>> VATsGet_0AsyncWithHttpInfo (DateTime? date, string clientId, string fiscalYearId);
        /// <summary>
        /// Get VAT by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of VAT</returns>
        System.Threading.Tasks.Task<VAT> VATsGet_1Async (int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Get VAT by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (VAT)</returns>
        System.Threading.Tasks.Task<ApiResponse<VAT>> VATsGet_1AsyncWithHttpInfo (int? id, string clientId, string fiscalYearId);
        /// <summary>
        /// Get VAT by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of VAT</returns>
        System.Threading.Tasks.Task<VAT> VATsGet_2Async (int? vatPeriodId, int? id, string clientId, string fiscalYearId);

        /// <summary>
        /// Get VAT by id
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (VAT)</returns>
        System.Threading.Tasks.Task<ApiResponse<VAT>> VATsGet_2AsyncWithHttpInfo (int? vatPeriodId, int? id, string clientId, string fiscalYearId);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class VATsApi : IVATsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="VATsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public VATsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="VATsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public VATsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get list of VATs (depricated: use vats/bydate instead ) 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;VAT&gt;</returns>
        public List<VAT> VATsGet (string clientId, string fiscalYearId)
        {
             ApiResponse<List<VAT>> localVarResponse = VATsGetWithHttpInfo(clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get list of VATs (depricated: use vats/bydate instead ) 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;VAT&gt;</returns>
        public ApiResponse< List<VAT> > VATsGetWithHttpInfo (string clientId, string fiscalYearId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGet");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGet");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<VAT>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<VAT>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<VAT>)));
        }

        /// <summary>
        /// Get list of VATs (depricated: use vats/bydate instead ) 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;VAT&gt;</returns>
        public async System.Threading.Tasks.Task<List<VAT>> VATsGetAsync (string clientId, string fiscalYearId)
        {
             ApiResponse<List<VAT>> localVarResponse = await VATsGetAsyncWithHttpInfo(clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get list of VATs (depricated: use vats/bydate instead ) 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;VAT&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<VAT>>> VATsGetAsyncWithHttpInfo (string clientId, string fiscalYearId)
        {
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGet");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGet");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<VAT>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<VAT>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<VAT>)));
        }

        /// <summary>
        /// Get VAT by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>VAT</returns>
        public VAT VATsGetByCode (string code, string clientId, string fiscalYearId)
        {
             ApiResponse<VAT> localVarResponse = VATsGetByCodeWithHttpInfo(code, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get VAT by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of VAT</returns>
        public ApiResponse< VAT > VATsGetByCodeWithHttpInfo (string code, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling VATsApi->VATsGetByCode");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGetByCode");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGetByCode");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/bycode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGetByCode", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<VAT>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (VAT) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(VAT)));
        }

        /// <summary>
        /// Get VAT by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of VAT</returns>
        public async System.Threading.Tasks.Task<VAT> VATsGetByCodeAsync (string code, string clientId, string fiscalYearId)
        {
             ApiResponse<VAT> localVarResponse = await VATsGetByCodeAsyncWithHttpInfo(code, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get VAT by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (VAT)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<VAT>> VATsGetByCodeAsyncWithHttpInfo (string code, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling VATsApi->VATsGetByCode");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGetByCode");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGetByCode");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/bycode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGetByCode", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<VAT>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (VAT) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(VAT)));
        }

        /// <summary>
        /// Get VAT by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>VAT</returns>
        public VAT VATsGetByCode_0 (int? vatPeriodId, string code, string clientId, string fiscalYearId)
        {
             ApiResponse<VAT> localVarResponse = VATsGetByCode_0WithHttpInfo(vatPeriodId, code, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get VAT by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of VAT</returns>
        public ApiResponse< VAT > VATsGetByCode_0WithHttpInfo (int? vatPeriodId, string code, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'vatPeriodId' is set
            if (vatPeriodId == null)
                throw new ApiException(400, "Missing required parameter 'vatPeriodId' when calling VATsApi->VATsGetByCode_0");
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling VATsApi->VATsGetByCode_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGetByCode_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGetByCode_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats/bycode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (vatPeriodId != null) localVarPathParams.Add("vatPeriodId", this.Configuration.ApiClient.ParameterToString(vatPeriodId)); // path parameter
            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGetByCode_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<VAT>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (VAT) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(VAT)));
        }

        /// <summary>
        /// Get VAT by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of VAT</returns>
        public async System.Threading.Tasks.Task<VAT> VATsGetByCode_0Async (int? vatPeriodId, string code, string clientId, string fiscalYearId)
        {
             ApiResponse<VAT> localVarResponse = await VATsGetByCode_0AsyncWithHttpInfo(vatPeriodId, code, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get VAT by code 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="code"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (VAT)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<VAT>> VATsGetByCode_0AsyncWithHttpInfo (int? vatPeriodId, string code, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'vatPeriodId' is set
            if (vatPeriodId == null)
                throw new ApiException(400, "Missing required parameter 'vatPeriodId' when calling VATsApi->VATsGetByCode_0");
            // verify the required parameter 'code' is set
            if (code == null)
                throw new ApiException(400, "Missing required parameter 'code' when calling VATsApi->VATsGetByCode_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGetByCode_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGetByCode_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats/bycode/{code}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (vatPeriodId != null) localVarPathParams.Add("vatPeriodId", this.Configuration.ApiClient.ParameterToString(vatPeriodId)); // path parameter
            if (code != null) localVarPathParams.Add("code", this.Configuration.ApiClient.ParameterToString(code)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGetByCode_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<VAT>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (VAT) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(VAT)));
        }

        /// <summary>
        /// Get list of VATs by vatPeriodId 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;VAT&gt;</returns>
        public List<VAT> VATsGetByVatPeriod (int? vatPeriodId, string clientId, string fiscalYearId)
        {
             ApiResponse<List<VAT>> localVarResponse = VATsGetByVatPeriodWithHttpInfo(vatPeriodId, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get list of VATs by vatPeriodId 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;VAT&gt;</returns>
        public ApiResponse< List<VAT> > VATsGetByVatPeriodWithHttpInfo (int? vatPeriodId, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'vatPeriodId' is set
            if (vatPeriodId == null)
                throw new ApiException(400, "Missing required parameter 'vatPeriodId' when calling VATsApi->VATsGetByVatPeriod");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGetByVatPeriod");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGetByVatPeriod");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (vatPeriodId != null) localVarPathParams.Add("vatPeriodId", this.Configuration.ApiClient.ParameterToString(vatPeriodId)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGetByVatPeriod", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<VAT>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<VAT>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<VAT>)));
        }

        /// <summary>
        /// Get list of VATs by vatPeriodId 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;VAT&gt;</returns>
        public async System.Threading.Tasks.Task<List<VAT>> VATsGetByVatPeriodAsync (int? vatPeriodId, string clientId, string fiscalYearId)
        {
             ApiResponse<List<VAT>> localVarResponse = await VATsGetByVatPeriodAsyncWithHttpInfo(vatPeriodId, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get list of VATs by vatPeriodId 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;VAT&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<VAT>>> VATsGetByVatPeriodAsyncWithHttpInfo (int? vatPeriodId, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'vatPeriodId' is set
            if (vatPeriodId == null)
                throw new ApiException(400, "Missing required parameter 'vatPeriodId' when calling VATsApi->VATsGetByVatPeriod");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGetByVatPeriod");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGetByVatPeriod");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (vatPeriodId != null) localVarPathParams.Add("vatPeriodId", this.Configuration.ApiClient.ParameterToString(vatPeriodId)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGetByVatPeriod", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<VAT>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<VAT>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<VAT>)));
        }

        /// <summary>
        /// Get list of VATs of period of given date 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>List&lt;VAT&gt;</returns>
        public List<VAT> VATsGet_0 (DateTime? date, string clientId, string fiscalYearId)
        {
             ApiResponse<List<VAT>> localVarResponse = VATsGet_0WithHttpInfo(date, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get list of VATs of period of given date 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of List&lt;VAT&gt;</returns>
        public ApiResponse< List<VAT> > VATsGet_0WithHttpInfo (DateTime? date, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'date' is set
            if (date == null)
                throw new ApiException(400, "Missing required parameter 'date' when calling VATsApi->VATsGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGet_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/bydate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter
            if (date != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "date", date)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<VAT>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<VAT>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<VAT>)));
        }

        /// <summary>
        /// Get list of VATs of period of given date 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of List&lt;VAT&gt;</returns>
        public async System.Threading.Tasks.Task<List<VAT>> VATsGet_0Async (DateTime? date, string clientId, string fiscalYearId)
        {
             ApiResponse<List<VAT>> localVarResponse = await VATsGet_0AsyncWithHttpInfo(date, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get list of VATs of period of given date 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="date"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (List&lt;VAT&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<VAT>>> VATsGet_0AsyncWithHttpInfo (DateTime? date, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'date' is set
            if (date == null)
                throw new ApiException(400, "Missing required parameter 'date' when calling VATsApi->VATsGet_0");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGet_0");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGet_0");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/bydate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter
            if (date != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "date", date)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGet_0", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<VAT>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<VAT>) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<VAT>)));
        }

        /// <summary>
        /// Get VAT by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>VAT</returns>
        public VAT VATsGet_1 (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<VAT> localVarResponse = VATsGet_1WithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get VAT by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of VAT</returns>
        public ApiResponse< VAT > VATsGet_1WithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling VATsApi->VATsGet_1");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGet_1");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGet_1");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGet_1", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<VAT>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (VAT) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(VAT)));
        }

        /// <summary>
        /// Get VAT by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of VAT</returns>
        public async System.Threading.Tasks.Task<VAT> VATsGet_1Async (int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<VAT> localVarResponse = await VATsGet_1AsyncWithHttpInfo(id, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get VAT by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (VAT)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<VAT>> VATsGet_1AsyncWithHttpInfo (int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling VATsApi->VATsGet_1");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGet_1");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGet_1");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vats/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGet_1", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<VAT>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (VAT) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(VAT)));
        }

        /// <summary>
        /// Get VAT by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>VAT</returns>
        public VAT VATsGet_2 (int? vatPeriodId, int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<VAT> localVarResponse = VATsGet_2WithHttpInfo(vatPeriodId, id, clientId, fiscalYearId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get VAT by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>ApiResponse of VAT</returns>
        public ApiResponse< VAT > VATsGet_2WithHttpInfo (int? vatPeriodId, int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'vatPeriodId' is set
            if (vatPeriodId == null)
                throw new ApiException(400, "Missing required parameter 'vatPeriodId' when calling VATsApi->VATsGet_2");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling VATsApi->VATsGet_2");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGet_2");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGet_2");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (vatPeriodId != null) localVarPathParams.Add("vatPeriodId", this.Configuration.ApiClient.ParameterToString(vatPeriodId)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGet_2", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<VAT>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (VAT) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(VAT)));
        }

        /// <summary>
        /// Get VAT by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of VAT</returns>
        public async System.Threading.Tasks.Task<VAT> VATsGet_2Async (int? vatPeriodId, int? id, string clientId, string fiscalYearId)
        {
             ApiResponse<VAT> localVarResponse = await VATsGet_2AsyncWithHttpInfo(vatPeriodId, id, clientId, fiscalYearId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get VAT by id 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="vatPeriodId"></param>
        /// <param name="id"></param>
        /// <param name="clientId"></param>
        /// <param name="fiscalYearId"></param>
        /// <returns>Task of ApiResponse (VAT)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<VAT>> VATsGet_2AsyncWithHttpInfo (int? vatPeriodId, int? id, string clientId, string fiscalYearId)
        {
            // verify the required parameter 'vatPeriodId' is set
            if (vatPeriodId == null)
                throw new ApiException(400, "Missing required parameter 'vatPeriodId' when calling VATsApi->VATsGet_2");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling VATsApi->VATsGet_2");
            // verify the required parameter 'clientId' is set
            if (clientId == null)
                throw new ApiException(400, "Missing required parameter 'clientId' when calling VATsApi->VATsGet_2");
            // verify the required parameter 'fiscalYearId' is set
            if (fiscalYearId == null)
                throw new ApiException(400, "Missing required parameter 'fiscalYearId' when calling VATsApi->VATsGet_2");

            var localVarPath = "/api/v1/clients/{clientId}/fiscalYears/{fiscalYearId}/vatPeriods/{vatPeriodId}/vats/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (vatPeriodId != null) localVarPathParams.Add("vatPeriodId", this.Configuration.ApiClient.ParameterToString(vatPeriodId)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (clientId != null) localVarPathParams.Add("clientId", this.Configuration.ApiClient.ParameterToString(clientId)); // path parameter
            if (fiscalYearId != null) localVarPathParams.Add("fiscalYearId", this.Configuration.ApiClient.ParameterToString(fiscalYearId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VATsGet_2", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<VAT>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (VAT) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(VAT)));
        }

    }
}
