/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// BankAccount
    /// </summary>
    [DataContract]
    public partial class BankAccount :  IEquatable<BankAccount>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BankAccount" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected BankAccount() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="BankAccount" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="name">name (required).</param>
        /// <param name="iban">iban.</param>
        /// <param name="accountNum">accountNum.</param>
        /// <param name="creditLine">creditLine.</param>
        /// <param name="accountFID">accountFID.</param>
        /// <param name="bankFID">bankFID.</param>
        /// <param name="bankAccountTypeFID">bankAccountTypeFID.</param>
        /// <param name="accountCode">accountCode.</param>
        /// <param name="bankCode">bankCode.</param>
        /// <param name="currencyCode">currencyCode.</param>
        public BankAccount(int? id = default(int?), string name = default(string), string iban = default(string), string accountNum = default(string), double? creditLine = default(double?), int? accountFID = default(int?), int? bankFID = default(int?), int? bankAccountTypeFID = default(int?), string accountCode = default(string), string bankCode = default(string), string currencyCode = default(string))
        {
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new InvalidDataException("name is a required property for BankAccount and cannot be null");
            }
            else
            {
                this.Name = name;
            }
            this.Id = id;
            this.Iban = iban;
            this.AccountNum = accountNum;
            this.CreditLine = creditLine;
            this.AccountFID = accountFID;
            this.BankFID = bankFID;
            this.BankAccountTypeFID = bankAccountTypeFID;
            this.AccountCode = accountCode;
            this.BankCode = bankCode;
            this.CurrencyCode = currencyCode;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public int? Id { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets Iban
        /// </summary>
        [DataMember(Name="iban", EmitDefaultValue=false)]
        public string Iban { get; set; }

        /// <summary>
        /// Gets or Sets AccountNum
        /// </summary>
        [DataMember(Name="accountNum", EmitDefaultValue=false)]
        public string AccountNum { get; set; }

        /// <summary>
        /// Gets or Sets CreditLine
        /// </summary>
        [DataMember(Name="creditLine", EmitDefaultValue=false)]
        public double? CreditLine { get; set; }

        /// <summary>
        /// Gets or Sets AccountFID
        /// </summary>
        [DataMember(Name="accountFID", EmitDefaultValue=false)]
        public int? AccountFID { get; set; }

        /// <summary>
        /// Gets or Sets BankFID
        /// </summary>
        [DataMember(Name="bankFID", EmitDefaultValue=false)]
        public int? BankFID { get; set; }

        /// <summary>
        /// Gets or Sets BankAccountTypeFID
        /// </summary>
        [DataMember(Name="bankAccountTypeFID", EmitDefaultValue=false)]
        public int? BankAccountTypeFID { get; set; }

        /// <summary>
        /// Gets or Sets AccountCode
        /// </summary>
        [DataMember(Name="accountCode", EmitDefaultValue=false)]
        public string AccountCode { get; set; }

        /// <summary>
        /// Gets or Sets BankCode
        /// </summary>
        [DataMember(Name="bankCode", EmitDefaultValue=false)]
        public string BankCode { get; set; }

        /// <summary>
        /// Gets or Sets CurrencyCode
        /// </summary>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BankAccount {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Iban: ").Append(Iban).Append("\n");
            sb.Append("  AccountNum: ").Append(AccountNum).Append("\n");
            sb.Append("  CreditLine: ").Append(CreditLine).Append("\n");
            sb.Append("  AccountFID: ").Append(AccountFID).Append("\n");
            sb.Append("  BankFID: ").Append(BankFID).Append("\n");
            sb.Append("  BankAccountTypeFID: ").Append(BankAccountTypeFID).Append("\n");
            sb.Append("  AccountCode: ").Append(AccountCode).Append("\n");
            sb.Append("  BankCode: ").Append(BankCode).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BankAccount);
        }

        /// <summary>
        /// Returns true if BankAccount instances are equal
        /// </summary>
        /// <param name="input">Instance of BankAccount to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BankAccount input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Iban == input.Iban ||
                    (this.Iban != null &&
                    this.Iban.Equals(input.Iban))
                ) && 
                (
                    this.AccountNum == input.AccountNum ||
                    (this.AccountNum != null &&
                    this.AccountNum.Equals(input.AccountNum))
                ) && 
                (
                    this.CreditLine == input.CreditLine ||
                    (this.CreditLine != null &&
                    this.CreditLine.Equals(input.CreditLine))
                ) && 
                (
                    this.AccountFID == input.AccountFID ||
                    (this.AccountFID != null &&
                    this.AccountFID.Equals(input.AccountFID))
                ) && 
                (
                    this.BankFID == input.BankFID ||
                    (this.BankFID != null &&
                    this.BankFID.Equals(input.BankFID))
                ) && 
                (
                    this.BankAccountTypeFID == input.BankAccountTypeFID ||
                    (this.BankAccountTypeFID != null &&
                    this.BankAccountTypeFID.Equals(input.BankAccountTypeFID))
                ) && 
                (
                    this.AccountCode == input.AccountCode ||
                    (this.AccountCode != null &&
                    this.AccountCode.Equals(input.AccountCode))
                ) && 
                (
                    this.BankCode == input.BankCode ||
                    (this.BankCode != null &&
                    this.BankCode.Equals(input.BankCode))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Iban != null)
                    hashCode = hashCode * 59 + this.Iban.GetHashCode();
                if (this.AccountNum != null)
                    hashCode = hashCode * 59 + this.AccountNum.GetHashCode();
                if (this.CreditLine != null)
                    hashCode = hashCode * 59 + this.CreditLine.GetHashCode();
                if (this.AccountFID != null)
                    hashCode = hashCode * 59 + this.AccountFID.GetHashCode();
                if (this.BankFID != null)
                    hashCode = hashCode * 59 + this.BankFID.GetHashCode();
                if (this.BankAccountTypeFID != null)
                    hashCode = hashCode * 59 + this.BankAccountTypeFID.GetHashCode();
                if (this.AccountCode != null)
                    hashCode = hashCode * 59 + this.AccountCode.GetHashCode();
                if (this.BankCode != null)
                    hashCode = hashCode * 59 + this.BankCode.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Name (string) maxLength
            if(this.Name != null && this.Name.Length > 52)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Name, length must be less than 52.", new [] { "Name" });
            }

            // Name (string) minLength
            if(this.Name != null && this.Name.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Name, length must be greater than 1.", new [] { "Name" });
            }

            yield break;
        }
    }

}
