/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Currency
    /// </summary>
    [DataContract]
    public partial class Currency :  IEquatable<Currency>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Currency" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="isoCode">isoCode.</param>
        /// <param name="name">name.</param>
        /// <param name="rate">rate.</param>
        /// <param name="unit">unit.</param>
        /// <param name="profitAccountFID">profitAccountFID.</param>
        /// <param name="lossAccountFID">lossAccountFID.</param>
        /// <param name="dailyRates">dailyRates.</param>
        public Currency(int? id = default(int?), string isoCode = default(string), string name = default(string), double? rate = default(double?), double? unit = default(double?), int? profitAccountFID = default(int?), int? lossAccountFID = default(int?), List<CurrencyRate> dailyRates = default(List<CurrencyRate>))
        {
            this.Id = id;
            this.IsoCode = isoCode;
            this.Name = name;
            this.Rate = rate;
            this.Unit = unit;
            this.ProfitAccountFID = profitAccountFID;
            this.LossAccountFID = lossAccountFID;
            this.DailyRates = dailyRates;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public int? Id { get; set; }

        /// <summary>
        /// Gets or Sets IsoCode
        /// </summary>
        [DataMember(Name="isoCode", EmitDefaultValue=false)]
        public string IsoCode { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets Rate
        /// </summary>
        [DataMember(Name="rate", EmitDefaultValue=false)]
        public double? Rate { get; set; }

        /// <summary>
        /// Gets or Sets Unit
        /// </summary>
        [DataMember(Name="unit", EmitDefaultValue=false)]
        public double? Unit { get; set; }

        /// <summary>
        /// Gets or Sets ProfitAccountFID
        /// </summary>
        [DataMember(Name="profitAccountFID", EmitDefaultValue=false)]
        public int? ProfitAccountFID { get; set; }

        /// <summary>
        /// Gets or Sets LossAccountFID
        /// </summary>
        [DataMember(Name="lossAccountFID", EmitDefaultValue=false)]
        public int? LossAccountFID { get; set; }

        /// <summary>
        /// Gets or Sets DailyRates
        /// </summary>
        [DataMember(Name="dailyRates", EmitDefaultValue=false)]
        public List<CurrencyRate> DailyRates { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Currency {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  IsoCode: ").Append(IsoCode).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Rate: ").Append(Rate).Append("\n");
            sb.Append("  Unit: ").Append(Unit).Append("\n");
            sb.Append("  ProfitAccountFID: ").Append(ProfitAccountFID).Append("\n");
            sb.Append("  LossAccountFID: ").Append(LossAccountFID).Append("\n");
            sb.Append("  DailyRates: ").Append(DailyRates).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Currency);
        }

        /// <summary>
        /// Returns true if Currency instances are equal
        /// </summary>
        /// <param name="input">Instance of Currency to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Currency input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.IsoCode == input.IsoCode ||
                    (this.IsoCode != null &&
                    this.IsoCode.Equals(input.IsoCode))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Rate == input.Rate ||
                    (this.Rate != null &&
                    this.Rate.Equals(input.Rate))
                ) && 
                (
                    this.Unit == input.Unit ||
                    (this.Unit != null &&
                    this.Unit.Equals(input.Unit))
                ) && 
                (
                    this.ProfitAccountFID == input.ProfitAccountFID ||
                    (this.ProfitAccountFID != null &&
                    this.ProfitAccountFID.Equals(input.ProfitAccountFID))
                ) && 
                (
                    this.LossAccountFID == input.LossAccountFID ||
                    (this.LossAccountFID != null &&
                    this.LossAccountFID.Equals(input.LossAccountFID))
                ) && 
                (
                    this.DailyRates == input.DailyRates ||
                    this.DailyRates != null &&
                    this.DailyRates.SequenceEqual(input.DailyRates)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.IsoCode != null)
                    hashCode = hashCode * 59 + this.IsoCode.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Rate != null)
                    hashCode = hashCode * 59 + this.Rate.GetHashCode();
                if (this.Unit != null)
                    hashCode = hashCode * 59 + this.Unit.GetHashCode();
                if (this.ProfitAccountFID != null)
                    hashCode = hashCode * 59 + this.ProfitAccountFID.GetHashCode();
                if (this.LossAccountFID != null)
                    hashCode = hashCode * 59 + this.LossAccountFID.GetHashCode();
                if (this.DailyRates != null)
                    hashCode = hashCode * 59 + this.DailyRates.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
