/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Debtor
    /// </summary>
    [DataContract]
    public partial class Debtor :  IEquatable<Debtor>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Debtor" /> class.
        /// </summary>
        /// <param name="partyFID">partyFID.</param>
        /// <param name="accountFID">accountFID.</param>
        /// <param name="payMethodFID">payMethodFID.</param>
        /// <param name="payTermFID">payTermFID.</param>
        /// <param name="freeCode">freeCode.</param>
        /// <param name="isInactiv">isInactiv.</param>
        /// <param name="noReminders">noReminders.</param>
        /// <param name="noRemindersFee">noRemindersFee.</param>
        /// <param name="creditLine">creditLine.</param>
        /// <param name="maxReminderLevel">maxReminderLevel.</param>
        /// <param name="person">person.</param>
        /// <param name="payMethods">payMethods.</param>
        public Debtor(int? partyFID = default(int?), int? accountFID = default(int?), int? payMethodFID = default(int?), int? payTermFID = default(int?), string freeCode = default(string), bool? isInactiv = default(bool?), bool? noReminders = default(bool?), bool? noRemindersFee = default(bool?), double? creditLine = default(double?), int? maxReminderLevel = default(int?), Person person = default(Person), List<PayMethod> payMethods = default(List<PayMethod>))
        {
            this.PartyFID = partyFID;
            this.AccountFID = accountFID;
            this.PayMethodFID = payMethodFID;
            this.PayTermFID = payTermFID;
            this.FreeCode = freeCode;
            this.IsInactiv = isInactiv;
            this.NoReminders = noReminders;
            this.NoRemindersFee = noRemindersFee;
            this.CreditLine = creditLine;
            this.MaxReminderLevel = maxReminderLevel;
            this.Person = person;
            this.PayMethods = payMethods;
        }
        
        /// <summary>
        /// Gets or Sets PartyFID
        /// </summary>
        [DataMember(Name="partyFID", EmitDefaultValue=false)]
        public int? PartyFID { get; set; }

        /// <summary>
        /// Gets or Sets AccountFID
        /// </summary>
        [DataMember(Name="accountFID", EmitDefaultValue=false)]
        public int? AccountFID { get; set; }

        /// <summary>
        /// Gets or Sets PayMethodFID
        /// </summary>
        [DataMember(Name="payMethodFID", EmitDefaultValue=false)]
        public int? PayMethodFID { get; set; }

        /// <summary>
        /// Gets or Sets PayTermFID
        /// </summary>
        [DataMember(Name="payTermFID", EmitDefaultValue=false)]
        public int? PayTermFID { get; set; }

        /// <summary>
        /// Gets or Sets FreeCode
        /// </summary>
        [DataMember(Name="freeCode", EmitDefaultValue=false)]
        public string FreeCode { get; set; }

        /// <summary>
        /// Gets or Sets IsInactiv
        /// </summary>
        [DataMember(Name="isInactiv", EmitDefaultValue=false)]
        public bool? IsInactiv { get; set; }

        /// <summary>
        /// Gets or Sets NoReminders
        /// </summary>
        [DataMember(Name="noReminders", EmitDefaultValue=false)]
        public bool? NoReminders { get; set; }

        /// <summary>
        /// Gets or Sets NoRemindersFee
        /// </summary>
        [DataMember(Name="noRemindersFee", EmitDefaultValue=false)]
        public bool? NoRemindersFee { get; set; }

        /// <summary>
        /// Gets or Sets CreditLine
        /// </summary>
        [DataMember(Name="creditLine", EmitDefaultValue=false)]
        public double? CreditLine { get; set; }

        /// <summary>
        /// Gets or Sets MaxReminderLevel
        /// </summary>
        [DataMember(Name="maxReminderLevel", EmitDefaultValue=false)]
        public int? MaxReminderLevel { get; set; }

        /// <summary>
        /// Gets or Sets Person
        /// </summary>
        [DataMember(Name="person", EmitDefaultValue=false)]
        public Person Person { get; set; }

        /// <summary>
        /// Gets or Sets PayMethods
        /// </summary>
        [DataMember(Name="payMethods", EmitDefaultValue=false)]
        public List<PayMethod> PayMethods { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Debtor {\n");
            sb.Append("  PartyFID: ").Append(PartyFID).Append("\n");
            sb.Append("  AccountFID: ").Append(AccountFID).Append("\n");
            sb.Append("  PayMethodFID: ").Append(PayMethodFID).Append("\n");
            sb.Append("  PayTermFID: ").Append(PayTermFID).Append("\n");
            sb.Append("  FreeCode: ").Append(FreeCode).Append("\n");
            sb.Append("  IsInactiv: ").Append(IsInactiv).Append("\n");
            sb.Append("  NoReminders: ").Append(NoReminders).Append("\n");
            sb.Append("  NoRemindersFee: ").Append(NoRemindersFee).Append("\n");
            sb.Append("  CreditLine: ").Append(CreditLine).Append("\n");
            sb.Append("  MaxReminderLevel: ").Append(MaxReminderLevel).Append("\n");
            sb.Append("  Person: ").Append(Person).Append("\n");
            sb.Append("  PayMethods: ").Append(PayMethods).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Debtor);
        }

        /// <summary>
        /// Returns true if Debtor instances are equal
        /// </summary>
        /// <param name="input">Instance of Debtor to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Debtor input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PartyFID == input.PartyFID ||
                    (this.PartyFID != null &&
                    this.PartyFID.Equals(input.PartyFID))
                ) && 
                (
                    this.AccountFID == input.AccountFID ||
                    (this.AccountFID != null &&
                    this.AccountFID.Equals(input.AccountFID))
                ) && 
                (
                    this.PayMethodFID == input.PayMethodFID ||
                    (this.PayMethodFID != null &&
                    this.PayMethodFID.Equals(input.PayMethodFID))
                ) && 
                (
                    this.PayTermFID == input.PayTermFID ||
                    (this.PayTermFID != null &&
                    this.PayTermFID.Equals(input.PayTermFID))
                ) && 
                (
                    this.FreeCode == input.FreeCode ||
                    (this.FreeCode != null &&
                    this.FreeCode.Equals(input.FreeCode))
                ) && 
                (
                    this.IsInactiv == input.IsInactiv ||
                    (this.IsInactiv != null &&
                    this.IsInactiv.Equals(input.IsInactiv))
                ) && 
                (
                    this.NoReminders == input.NoReminders ||
                    (this.NoReminders != null &&
                    this.NoReminders.Equals(input.NoReminders))
                ) && 
                (
                    this.NoRemindersFee == input.NoRemindersFee ||
                    (this.NoRemindersFee != null &&
                    this.NoRemindersFee.Equals(input.NoRemindersFee))
                ) && 
                (
                    this.CreditLine == input.CreditLine ||
                    (this.CreditLine != null &&
                    this.CreditLine.Equals(input.CreditLine))
                ) && 
                (
                    this.MaxReminderLevel == input.MaxReminderLevel ||
                    (this.MaxReminderLevel != null &&
                    this.MaxReminderLevel.Equals(input.MaxReminderLevel))
                ) && 
                (
                    this.Person == input.Person ||
                    (this.Person != null &&
                    this.Person.Equals(input.Person))
                ) && 
                (
                    this.PayMethods == input.PayMethods ||
                    this.PayMethods != null &&
                    this.PayMethods.SequenceEqual(input.PayMethods)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PartyFID != null)
                    hashCode = hashCode * 59 + this.PartyFID.GetHashCode();
                if (this.AccountFID != null)
                    hashCode = hashCode * 59 + this.AccountFID.GetHashCode();
                if (this.PayMethodFID != null)
                    hashCode = hashCode * 59 + this.PayMethodFID.GetHashCode();
                if (this.PayTermFID != null)
                    hashCode = hashCode * 59 + this.PayTermFID.GetHashCode();
                if (this.FreeCode != null)
                    hashCode = hashCode * 59 + this.FreeCode.GetHashCode();
                if (this.IsInactiv != null)
                    hashCode = hashCode * 59 + this.IsInactiv.GetHashCode();
                if (this.NoReminders != null)
                    hashCode = hashCode * 59 + this.NoReminders.GetHashCode();
                if (this.NoRemindersFee != null)
                    hashCode = hashCode * 59 + this.NoRemindersFee.GetHashCode();
                if (this.CreditLine != null)
                    hashCode = hashCode * 59 + this.CreditLine.GetHashCode();
                if (this.MaxReminderLevel != null)
                    hashCode = hashCode * 59 + this.MaxReminderLevel.GetHashCode();
                if (this.Person != null)
                    hashCode = hashCode * 59 + this.Person.GetHashCode();
                if (this.PayMethods != null)
                    hashCode = hashCode * 59 + this.PayMethods.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
