/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Invoice
    /// </summary>
    [DataContract]
    public partial class Invoice :  IEquatable<Invoice>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Invoice" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected Invoice() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="Invoice" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="authorizerFID">authorizerFID.</param>
        /// <param name="partyFID">partyFID (required).</param>
        /// <param name="payMethodFID">payMethodFID (required).</param>
        /// <param name="payTermFID">payTermFID (required).</param>
        /// <param name="vatFID">vatFID.</param>
        /// <param name="personRoleFID">personRoleFID (required).</param>
        /// <param name="invoiceDate">invoiceDate (required).</param>
        /// <param name="dueDate">dueDate (required).</param>
        /// <param name="modifyDate">modifyDate.</param>
        /// <param name="invoiceNum">invoiceNum (required).</param>
        /// <param name="reminderLevel">reminderLevel.</param>
        /// <param name="freeInvoiceNum">freeInvoiceNum.</param>
        /// <param name="text">text.</param>
        /// <param name="payslipCode">payslipCode.</param>
        /// <param name="totalAmount">totalAmount (required).</param>
        /// <param name="totalAmountFC">totalAmountFC (required).</param>
        /// <param name="exchangeRate">exchangeRate.</param>
        /// <param name="isAuthorized">isAuthorized.</param>
        /// <param name="noReminders">noReminders.</param>
        /// <param name="remarks">remarks.</param>
        /// <param name="partyNum">partyNum.</param>
        /// <param name="partyName">partyName.</param>
        /// <param name="partyShortName">partyShortName.</param>
        /// <param name="payTermCode">payTermCode.</param>
        /// <param name="accountCode">accountCode.</param>
        /// <param name="currencyCode">currencyCode.</param>
        /// <param name="balance">balance.</param>
        /// <param name="balanceFC">balanceFC.</param>
        /// <param name="barCode">barCode.</param>
        /// <param name="currentReminderLevel">currentReminderLevel.</param>
        /// <param name="hasDocument">hasDocument.</param>
        /// <param name="currentReminderDate">currentReminderDate.</param>
        /// <param name="paymentPostings">paymentPostings.</param>
        /// <param name="transaction">transaction.</param>
        public Invoice(Guid? id = default(Guid?), int? authorizerFID = default(int?), int? partyFID = default(int?), int? payMethodFID = default(int?), int? payTermFID = default(int?), int? vatFID = default(int?), int? personRoleFID = default(int?), DateTime? invoiceDate = default(DateTime?), DateTime? dueDate = default(DateTime?), DateTime? modifyDate = default(DateTime?), int? invoiceNum = default(int?), int? reminderLevel = default(int?), string freeInvoiceNum = default(string), string text = default(string), string payslipCode = default(string), double? totalAmount = default(double?), double? totalAmountFC = default(double?), double? exchangeRate = default(double?), bool? isAuthorized = default(bool?), bool? noReminders = default(bool?), string remarks = default(string), int? partyNum = default(int?), string partyName = default(string), string partyShortName = default(string), string payTermCode = default(string), string accountCode = default(string), string currencyCode = default(string), double? balance = default(double?), double? balanceFC = default(double?), string barCode = default(string), int? currentReminderLevel = default(int?), int? hasDocument = default(int?), DateTime? currentReminderDate = default(DateTime?), List<Posting> paymentPostings = default(List<Posting>), Transaction transaction = default(Transaction))
        {
            // to ensure "partyFID" is required (not null)
            if (partyFID == null)
            {
                throw new InvalidDataException("partyFID is a required property for Invoice and cannot be null");
            }
            else
            {
                this.PartyFID = partyFID;
            }
            // to ensure "payMethodFID" is required (not null)
            if (payMethodFID == null)
            {
                throw new InvalidDataException("payMethodFID is a required property for Invoice and cannot be null");
            }
            else
            {
                this.PayMethodFID = payMethodFID;
            }
            // to ensure "payTermFID" is required (not null)
            if (payTermFID == null)
            {
                throw new InvalidDataException("payTermFID is a required property for Invoice and cannot be null");
            }
            else
            {
                this.PayTermFID = payTermFID;
            }
            // to ensure "personRoleFID" is required (not null)
            if (personRoleFID == null)
            {
                throw new InvalidDataException("personRoleFID is a required property for Invoice and cannot be null");
            }
            else
            {
                this.PersonRoleFID = personRoleFID;
            }
            // to ensure "invoiceDate" is required (not null)
            if (invoiceDate == null)
            {
                throw new InvalidDataException("invoiceDate is a required property for Invoice and cannot be null");
            }
            else
            {
                this.InvoiceDate = invoiceDate;
            }
            // to ensure "dueDate" is required (not null)
            if (dueDate == null)
            {
                throw new InvalidDataException("dueDate is a required property for Invoice and cannot be null");
            }
            else
            {
                this.DueDate = dueDate;
            }
            // to ensure "invoiceNum" is required (not null)
            if (invoiceNum == null)
            {
                throw new InvalidDataException("invoiceNum is a required property for Invoice and cannot be null");
            }
            else
            {
                this.InvoiceNum = invoiceNum;
            }
            // to ensure "totalAmount" is required (not null)
            if (totalAmount == null)
            {
                throw new InvalidDataException("totalAmount is a required property for Invoice and cannot be null");
            }
            else
            {
                this.TotalAmount = totalAmount;
            }
            // to ensure "totalAmountFC" is required (not null)
            if (totalAmountFC == null)
            {
                throw new InvalidDataException("totalAmountFC is a required property for Invoice and cannot be null");
            }
            else
            {
                this.TotalAmountFC = totalAmountFC;
            }
            this.Id = id;
            this.AuthorizerFID = authorizerFID;
            this.VatFID = vatFID;
            this.ModifyDate = modifyDate;
            this.ReminderLevel = reminderLevel;
            this.FreeInvoiceNum = freeInvoiceNum;
            this.Text = text;
            this.PayslipCode = payslipCode;
            this.ExchangeRate = exchangeRate;
            this.IsAuthorized = isAuthorized;
            this.NoReminders = noReminders;
            this.Remarks = remarks;
            this.PartyNum = partyNum;
            this.PartyName = partyName;
            this.PartyShortName = partyShortName;
            this.PayTermCode = payTermCode;
            this.AccountCode = accountCode;
            this.CurrencyCode = currencyCode;
            this.Balance = balance;
            this.BalanceFC = balanceFC;
            this.BarCode = barCode;
            this.CurrentReminderLevel = currentReminderLevel;
            this.HasDocument = hasDocument;
            this.CurrentReminderDate = currentReminderDate;
            this.PaymentPostings = paymentPostings;
            this.Transaction = transaction;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public Guid? Id { get; set; }

        /// <summary>
        /// Gets or Sets AuthorizerFID
        /// </summary>
        [DataMember(Name="authorizerFID", EmitDefaultValue=false)]
        public int? AuthorizerFID { get; set; }

        /// <summary>
        /// Gets or Sets PartyFID
        /// </summary>
        [DataMember(Name="partyFID", EmitDefaultValue=false)]
        public int? PartyFID { get; set; }

        /// <summary>
        /// Gets or Sets PayMethodFID
        /// </summary>
        [DataMember(Name="payMethodFID", EmitDefaultValue=false)]
        public int? PayMethodFID { get; set; }

        /// <summary>
        /// Gets or Sets PayTermFID
        /// </summary>
        [DataMember(Name="payTermFID", EmitDefaultValue=false)]
        public int? PayTermFID { get; set; }

        /// <summary>
        /// Gets or Sets VatFID
        /// </summary>
        [DataMember(Name="vatFID", EmitDefaultValue=false)]
        public int? VatFID { get; set; }

        /// <summary>
        /// Gets or Sets PersonRoleFID
        /// </summary>
        [DataMember(Name="personRoleFID", EmitDefaultValue=false)]
        public int? PersonRoleFID { get; set; }

        /// <summary>
        /// Gets or Sets InvoiceDate
        /// </summary>
        [DataMember(Name="invoiceDate", EmitDefaultValue=false)]
        public DateTime? InvoiceDate { get; set; }

        /// <summary>
        /// Gets or Sets DueDate
        /// </summary>
        [DataMember(Name="dueDate", EmitDefaultValue=false)]
        public DateTime? DueDate { get; set; }

        /// <summary>
        /// Gets or Sets ModifyDate
        /// </summary>
        [DataMember(Name="modifyDate", EmitDefaultValue=false)]
        public DateTime? ModifyDate { get; set; }

        /// <summary>
        /// Gets or Sets InvoiceNum
        /// </summary>
        [DataMember(Name="invoiceNum", EmitDefaultValue=false)]
        public int? InvoiceNum { get; set; }

        /// <summary>
        /// Gets or Sets ReminderLevel
        /// </summary>
        [DataMember(Name="reminderLevel", EmitDefaultValue=false)]
        public int? ReminderLevel { get; set; }

        /// <summary>
        /// Gets or Sets FreeInvoiceNum
        /// </summary>
        [DataMember(Name="freeInvoiceNum", EmitDefaultValue=false)]
        public string FreeInvoiceNum { get; set; }

        /// <summary>
        /// Gets or Sets Text
        /// </summary>
        [DataMember(Name="text", EmitDefaultValue=false)]
        public string Text { get; set; }

        /// <summary>
        /// Gets or Sets PayslipCode
        /// </summary>
        [DataMember(Name="PayslipCode", EmitDefaultValue=false)]
        public string PayslipCode { get; set; }

        /// <summary>
        /// Gets or Sets TotalAmount
        /// </summary>
        [DataMember(Name="totalAmount", EmitDefaultValue=false)]
        public double? TotalAmount { get; set; }

        /// <summary>
        /// Gets or Sets TotalAmountFC
        /// </summary>
        [DataMember(Name="totalAmountFC", EmitDefaultValue=false)]
        public double? TotalAmountFC { get; set; }

        /// <summary>
        /// Gets or Sets ExchangeRate
        /// </summary>
        [DataMember(Name="exchangeRate", EmitDefaultValue=false)]
        public double? ExchangeRate { get; set; }

        /// <summary>
        /// Gets or Sets IsAuthorized
        /// </summary>
        [DataMember(Name="IsAuthorized", EmitDefaultValue=false)]
        public bool? IsAuthorized { get; set; }

        /// <summary>
        /// Gets or Sets NoReminders
        /// </summary>
        [DataMember(Name="noReminders", EmitDefaultValue=false)]
        public bool? NoReminders { get; set; }

        /// <summary>
        /// Gets or Sets Remarks
        /// </summary>
        [DataMember(Name="Remarks", EmitDefaultValue=false)]
        public string Remarks { get; set; }

        /// <summary>
        /// Gets or Sets PartyNum
        /// </summary>
        [DataMember(Name="partyNum", EmitDefaultValue=false)]
        public int? PartyNum { get; set; }

        /// <summary>
        /// Gets or Sets PartyName
        /// </summary>
        [DataMember(Name="partyName", EmitDefaultValue=false)]
        public string PartyName { get; set; }

        /// <summary>
        /// Gets or Sets PartyShortName
        /// </summary>
        [DataMember(Name="partyShortName", EmitDefaultValue=false)]
        public string PartyShortName { get; set; }

        /// <summary>
        /// Gets or Sets PayTermCode
        /// </summary>
        [DataMember(Name="payTermCode", EmitDefaultValue=false)]
        public string PayTermCode { get; set; }

        /// <summary>
        /// Gets or Sets AccountCode
        /// </summary>
        [DataMember(Name="accountCode", EmitDefaultValue=false)]
        public string AccountCode { get; set; }

        /// <summary>
        /// Gets or Sets CurrencyCode
        /// </summary>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Gets or Sets Balance
        /// </summary>
        [DataMember(Name="balance", EmitDefaultValue=false)]
        public double? Balance { get; set; }

        /// <summary>
        /// Gets or Sets BalanceFC
        /// </summary>
        [DataMember(Name="balanceFC", EmitDefaultValue=false)]
        public double? BalanceFC { get; set; }

        /// <summary>
        /// Gets or Sets BarCode
        /// </summary>
        [DataMember(Name="barCode", EmitDefaultValue=false)]
        public string BarCode { get; set; }

        /// <summary>
        /// Gets or Sets CurrentReminderLevel
        /// </summary>
        [DataMember(Name="currentReminderLevel", EmitDefaultValue=false)]
        public int? CurrentReminderLevel { get; set; }

        /// <summary>
        /// Gets or Sets HasDocument
        /// </summary>
        [DataMember(Name="hasDocument", EmitDefaultValue=false)]
        public int? HasDocument { get; set; }

        /// <summary>
        /// Gets or Sets CurrentReminderDate
        /// </summary>
        [DataMember(Name="currentReminderDate", EmitDefaultValue=false)]
        public DateTime? CurrentReminderDate { get; set; }

        /// <summary>
        /// Gets or Sets PaymentPostings
        /// </summary>
        [DataMember(Name="paymentPostings", EmitDefaultValue=false)]
        public List<Posting> PaymentPostings { get; set; }

        /// <summary>
        /// Gets or Sets Transaction
        /// </summary>
        [DataMember(Name="transaction", EmitDefaultValue=false)]
        public Transaction Transaction { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Invoice {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  AuthorizerFID: ").Append(AuthorizerFID).Append("\n");
            sb.Append("  PartyFID: ").Append(PartyFID).Append("\n");
            sb.Append("  PayMethodFID: ").Append(PayMethodFID).Append("\n");
            sb.Append("  PayTermFID: ").Append(PayTermFID).Append("\n");
            sb.Append("  VatFID: ").Append(VatFID).Append("\n");
            sb.Append("  PersonRoleFID: ").Append(PersonRoleFID).Append("\n");
            sb.Append("  InvoiceDate: ").Append(InvoiceDate).Append("\n");
            sb.Append("  DueDate: ").Append(DueDate).Append("\n");
            sb.Append("  ModifyDate: ").Append(ModifyDate).Append("\n");
            sb.Append("  InvoiceNum: ").Append(InvoiceNum).Append("\n");
            sb.Append("  ReminderLevel: ").Append(ReminderLevel).Append("\n");
            sb.Append("  FreeInvoiceNum: ").Append(FreeInvoiceNum).Append("\n");
            sb.Append("  Text: ").Append(Text).Append("\n");
            sb.Append("  PayslipCode: ").Append(PayslipCode).Append("\n");
            sb.Append("  TotalAmount: ").Append(TotalAmount).Append("\n");
            sb.Append("  TotalAmountFC: ").Append(TotalAmountFC).Append("\n");
            sb.Append("  ExchangeRate: ").Append(ExchangeRate).Append("\n");
            sb.Append("  IsAuthorized: ").Append(IsAuthorized).Append("\n");
            sb.Append("  NoReminders: ").Append(NoReminders).Append("\n");
            sb.Append("  Remarks: ").Append(Remarks).Append("\n");
            sb.Append("  PartyNum: ").Append(PartyNum).Append("\n");
            sb.Append("  PartyName: ").Append(PartyName).Append("\n");
            sb.Append("  PartyShortName: ").Append(PartyShortName).Append("\n");
            sb.Append("  PayTermCode: ").Append(PayTermCode).Append("\n");
            sb.Append("  AccountCode: ").Append(AccountCode).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  Balance: ").Append(Balance).Append("\n");
            sb.Append("  BalanceFC: ").Append(BalanceFC).Append("\n");
            sb.Append("  BarCode: ").Append(BarCode).Append("\n");
            sb.Append("  CurrentReminderLevel: ").Append(CurrentReminderLevel).Append("\n");
            sb.Append("  HasDocument: ").Append(HasDocument).Append("\n");
            sb.Append("  CurrentReminderDate: ").Append(CurrentReminderDate).Append("\n");
            sb.Append("  PaymentPostings: ").Append(PaymentPostings).Append("\n");
            sb.Append("  Transaction: ").Append(Transaction).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Invoice);
        }

        /// <summary>
        /// Returns true if Invoice instances are equal
        /// </summary>
        /// <param name="input">Instance of Invoice to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Invoice input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.AuthorizerFID == input.AuthorizerFID ||
                    (this.AuthorizerFID != null &&
                    this.AuthorizerFID.Equals(input.AuthorizerFID))
                ) && 
                (
                    this.PartyFID == input.PartyFID ||
                    (this.PartyFID != null &&
                    this.PartyFID.Equals(input.PartyFID))
                ) && 
                (
                    this.PayMethodFID == input.PayMethodFID ||
                    (this.PayMethodFID != null &&
                    this.PayMethodFID.Equals(input.PayMethodFID))
                ) && 
                (
                    this.PayTermFID == input.PayTermFID ||
                    (this.PayTermFID != null &&
                    this.PayTermFID.Equals(input.PayTermFID))
                ) && 
                (
                    this.VatFID == input.VatFID ||
                    (this.VatFID != null &&
                    this.VatFID.Equals(input.VatFID))
                ) && 
                (
                    this.PersonRoleFID == input.PersonRoleFID ||
                    (this.PersonRoleFID != null &&
                    this.PersonRoleFID.Equals(input.PersonRoleFID))
                ) && 
                (
                    this.InvoiceDate == input.InvoiceDate ||
                    (this.InvoiceDate != null &&
                    this.InvoiceDate.Equals(input.InvoiceDate))
                ) && 
                (
                    this.DueDate == input.DueDate ||
                    (this.DueDate != null &&
                    this.DueDate.Equals(input.DueDate))
                ) && 
                (
                    this.ModifyDate == input.ModifyDate ||
                    (this.ModifyDate != null &&
                    this.ModifyDate.Equals(input.ModifyDate))
                ) && 
                (
                    this.InvoiceNum == input.InvoiceNum ||
                    (this.InvoiceNum != null &&
                    this.InvoiceNum.Equals(input.InvoiceNum))
                ) && 
                (
                    this.ReminderLevel == input.ReminderLevel ||
                    (this.ReminderLevel != null &&
                    this.ReminderLevel.Equals(input.ReminderLevel))
                ) && 
                (
                    this.FreeInvoiceNum == input.FreeInvoiceNum ||
                    (this.FreeInvoiceNum != null &&
                    this.FreeInvoiceNum.Equals(input.FreeInvoiceNum))
                ) && 
                (
                    this.Text == input.Text ||
                    (this.Text != null &&
                    this.Text.Equals(input.Text))
                ) && 
                (
                    this.PayslipCode == input.PayslipCode ||
                    (this.PayslipCode != null &&
                    this.PayslipCode.Equals(input.PayslipCode))
                ) && 
                (
                    this.TotalAmount == input.TotalAmount ||
                    (this.TotalAmount != null &&
                    this.TotalAmount.Equals(input.TotalAmount))
                ) && 
                (
                    this.TotalAmountFC == input.TotalAmountFC ||
                    (this.TotalAmountFC != null &&
                    this.TotalAmountFC.Equals(input.TotalAmountFC))
                ) && 
                (
                    this.ExchangeRate == input.ExchangeRate ||
                    (this.ExchangeRate != null &&
                    this.ExchangeRate.Equals(input.ExchangeRate))
                ) && 
                (
                    this.IsAuthorized == input.IsAuthorized ||
                    (this.IsAuthorized != null &&
                    this.IsAuthorized.Equals(input.IsAuthorized))
                ) && 
                (
                    this.NoReminders == input.NoReminders ||
                    (this.NoReminders != null &&
                    this.NoReminders.Equals(input.NoReminders))
                ) && 
                (
                    this.Remarks == input.Remarks ||
                    (this.Remarks != null &&
                    this.Remarks.Equals(input.Remarks))
                ) && 
                (
                    this.PartyNum == input.PartyNum ||
                    (this.PartyNum != null &&
                    this.PartyNum.Equals(input.PartyNum))
                ) && 
                (
                    this.PartyName == input.PartyName ||
                    (this.PartyName != null &&
                    this.PartyName.Equals(input.PartyName))
                ) && 
                (
                    this.PartyShortName == input.PartyShortName ||
                    (this.PartyShortName != null &&
                    this.PartyShortName.Equals(input.PartyShortName))
                ) && 
                (
                    this.PayTermCode == input.PayTermCode ||
                    (this.PayTermCode != null &&
                    this.PayTermCode.Equals(input.PayTermCode))
                ) && 
                (
                    this.AccountCode == input.AccountCode ||
                    (this.AccountCode != null &&
                    this.AccountCode.Equals(input.AccountCode))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.Balance == input.Balance ||
                    (this.Balance != null &&
                    this.Balance.Equals(input.Balance))
                ) && 
                (
                    this.BalanceFC == input.BalanceFC ||
                    (this.BalanceFC != null &&
                    this.BalanceFC.Equals(input.BalanceFC))
                ) && 
                (
                    this.BarCode == input.BarCode ||
                    (this.BarCode != null &&
                    this.BarCode.Equals(input.BarCode))
                ) && 
                (
                    this.CurrentReminderLevel == input.CurrentReminderLevel ||
                    (this.CurrentReminderLevel != null &&
                    this.CurrentReminderLevel.Equals(input.CurrentReminderLevel))
                ) && 
                (
                    this.HasDocument == input.HasDocument ||
                    (this.HasDocument != null &&
                    this.HasDocument.Equals(input.HasDocument))
                ) && 
                (
                    this.CurrentReminderDate == input.CurrentReminderDate ||
                    (this.CurrentReminderDate != null &&
                    this.CurrentReminderDate.Equals(input.CurrentReminderDate))
                ) && 
                (
                    this.PaymentPostings == input.PaymentPostings ||
                    this.PaymentPostings != null &&
                    this.PaymentPostings.SequenceEqual(input.PaymentPostings)
                ) && 
                (
                    this.Transaction == input.Transaction ||
                    (this.Transaction != null &&
                    this.Transaction.Equals(input.Transaction))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.AuthorizerFID != null)
                    hashCode = hashCode * 59 + this.AuthorizerFID.GetHashCode();
                if (this.PartyFID != null)
                    hashCode = hashCode * 59 + this.PartyFID.GetHashCode();
                if (this.PayMethodFID != null)
                    hashCode = hashCode * 59 + this.PayMethodFID.GetHashCode();
                if (this.PayTermFID != null)
                    hashCode = hashCode * 59 + this.PayTermFID.GetHashCode();
                if (this.VatFID != null)
                    hashCode = hashCode * 59 + this.VatFID.GetHashCode();
                if (this.PersonRoleFID != null)
                    hashCode = hashCode * 59 + this.PersonRoleFID.GetHashCode();
                if (this.InvoiceDate != null)
                    hashCode = hashCode * 59 + this.InvoiceDate.GetHashCode();
                if (this.DueDate != null)
                    hashCode = hashCode * 59 + this.DueDate.GetHashCode();
                if (this.ModifyDate != null)
                    hashCode = hashCode * 59 + this.ModifyDate.GetHashCode();
                if (this.InvoiceNum != null)
                    hashCode = hashCode * 59 + this.InvoiceNum.GetHashCode();
                if (this.ReminderLevel != null)
                    hashCode = hashCode * 59 + this.ReminderLevel.GetHashCode();
                if (this.FreeInvoiceNum != null)
                    hashCode = hashCode * 59 + this.FreeInvoiceNum.GetHashCode();
                if (this.Text != null)
                    hashCode = hashCode * 59 + this.Text.GetHashCode();
                if (this.PayslipCode != null)
                    hashCode = hashCode * 59 + this.PayslipCode.GetHashCode();
                if (this.TotalAmount != null)
                    hashCode = hashCode * 59 + this.TotalAmount.GetHashCode();
                if (this.TotalAmountFC != null)
                    hashCode = hashCode * 59 + this.TotalAmountFC.GetHashCode();
                if (this.ExchangeRate != null)
                    hashCode = hashCode * 59 + this.ExchangeRate.GetHashCode();
                if (this.IsAuthorized != null)
                    hashCode = hashCode * 59 + this.IsAuthorized.GetHashCode();
                if (this.NoReminders != null)
                    hashCode = hashCode * 59 + this.NoReminders.GetHashCode();
                if (this.Remarks != null)
                    hashCode = hashCode * 59 + this.Remarks.GetHashCode();
                if (this.PartyNum != null)
                    hashCode = hashCode * 59 + this.PartyNum.GetHashCode();
                if (this.PartyName != null)
                    hashCode = hashCode * 59 + this.PartyName.GetHashCode();
                if (this.PartyShortName != null)
                    hashCode = hashCode * 59 + this.PartyShortName.GetHashCode();
                if (this.PayTermCode != null)
                    hashCode = hashCode * 59 + this.PayTermCode.GetHashCode();
                if (this.AccountCode != null)
                    hashCode = hashCode * 59 + this.AccountCode.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.Balance != null)
                    hashCode = hashCode * 59 + this.Balance.GetHashCode();
                if (this.BalanceFC != null)
                    hashCode = hashCode * 59 + this.BalanceFC.GetHashCode();
                if (this.BarCode != null)
                    hashCode = hashCode * 59 + this.BarCode.GetHashCode();
                if (this.CurrentReminderLevel != null)
                    hashCode = hashCode * 59 + this.CurrentReminderLevel.GetHashCode();
                if (this.HasDocument != null)
                    hashCode = hashCode * 59 + this.HasDocument.GetHashCode();
                if (this.CurrentReminderDate != null)
                    hashCode = hashCode * 59 + this.CurrentReminderDate.GetHashCode();
                if (this.PaymentPostings != null)
                    hashCode = hashCode * 59 + this.PaymentPostings.GetHashCode();
                if (this.Transaction != null)
                    hashCode = hashCode * 59 + this.Transaction.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // PersonRoleFID (int?) maximum
            if(this.PersonRoleFID > (int?)3)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PersonRoleFID, must be a value less than or equal to 3.", new [] { "PersonRoleFID" });
            }

            // PersonRoleFID (int?) minimum
            if(this.PersonRoleFID < (int?)1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PersonRoleFID, must be a value greater than or equal to 1.", new [] { "PersonRoleFID" });
            }

            yield break;
        }
    }

}
