/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Payment
    /// </summary>
    [DataContract]
    public partial class Payment :  IEquatable<Payment>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Payment" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected Payment() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="Payment" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="accountFID">accountFID (required).</param>
        /// <param name="partyFID">partyFID.</param>
        /// <param name="personRoleFID">personRoleFID.</param>
        /// <param name="text">text.</param>
        /// <param name="paymentTransactionTypeFID">paymentTransactionTypeFID.</param>
        /// <param name="amount">amount (required).</param>
        /// <param name="amountFC">amountFC (required).</param>
        /// <param name="paymentRate">paymentRate.</param>
        /// <param name="paymentNum">paymentNum.</param>
        /// <param name="accountCode">accountCode.</param>
        /// <param name="accountName">accountName.</param>
        /// <param name="currencyCode">currencyCode.</param>
        /// <param name="currencyFID">currencyFID.</param>
        /// <param name="partyNum">partyNum.</param>
        /// <param name="partyName">partyName.</param>
        /// <param name="partyShortName">partyShortName.</param>
        /// <param name="freePartyNum">freePartyNum.</param>
        /// <param name="invoiceCount">invoiceCount.</param>
        /// <param name="paymentDetails">paymentDetails.</param>
        /// <param name="transaction">transaction.</param>
        public Payment(Guid? id = default(Guid?), int? accountFID = default(int?), int? partyFID = default(int?), int? personRoleFID = default(int?), string text = default(string), int? paymentTransactionTypeFID = default(int?), double? amount = default(double?), double? amountFC = default(double?), double? paymentRate = default(double?), int? paymentNum = default(int?), string accountCode = default(string), string accountName = default(string), string currencyCode = default(string), int? currencyFID = default(int?), int? partyNum = default(int?), string partyName = default(string), string partyShortName = default(string), string freePartyNum = default(string), int? invoiceCount = default(int?), List<PaymentDetail> paymentDetails = default(List<PaymentDetail>), Transaction transaction = default(Transaction))
        {
            // to ensure "accountFID" is required (not null)
            if (accountFID == null)
            {
                throw new InvalidDataException("accountFID is a required property for Payment and cannot be null");
            }
            else
            {
                this.AccountFID = accountFID;
            }
            // to ensure "amount" is required (not null)
            if (amount == null)
            {
                throw new InvalidDataException("amount is a required property for Payment and cannot be null");
            }
            else
            {
                this.Amount = amount;
            }
            // to ensure "amountFC" is required (not null)
            if (amountFC == null)
            {
                throw new InvalidDataException("amountFC is a required property for Payment and cannot be null");
            }
            else
            {
                this.AmountFC = amountFC;
            }
            this.Id = id;
            this.PartyFID = partyFID;
            this.PersonRoleFID = personRoleFID;
            this.Text = text;
            this.PaymentTransactionTypeFID = paymentTransactionTypeFID;
            this.PaymentRate = paymentRate;
            this.PaymentNum = paymentNum;
            this.AccountCode = accountCode;
            this.AccountName = accountName;
            this.CurrencyCode = currencyCode;
            this.CurrencyFID = currencyFID;
            this.PartyNum = partyNum;
            this.PartyName = partyName;
            this.PartyShortName = partyShortName;
            this.FreePartyNum = freePartyNum;
            this.InvoiceCount = invoiceCount;
            this.PaymentDetails = paymentDetails;
            this.Transaction = transaction;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public Guid? Id { get; set; }

        /// <summary>
        /// Gets or Sets AccountFID
        /// </summary>
        [DataMember(Name="accountFID", EmitDefaultValue=false)]
        public int? AccountFID { get; set; }

        /// <summary>
        /// Gets or Sets PartyFID
        /// </summary>
        [DataMember(Name="partyFID", EmitDefaultValue=false)]
        public int? PartyFID { get; set; }

        /// <summary>
        /// Gets or Sets PersonRoleFID
        /// </summary>
        [DataMember(Name="personRoleFID", EmitDefaultValue=false)]
        public int? PersonRoleFID { get; set; }

        /// <summary>
        /// Gets or Sets Text
        /// </summary>
        [DataMember(Name="text", EmitDefaultValue=false)]
        public string Text { get; set; }

        /// <summary>
        /// Gets or Sets PaymentTransactionTypeFID
        /// </summary>
        [DataMember(Name="paymentTransactionTypeFID", EmitDefaultValue=false)]
        public int? PaymentTransactionTypeFID { get; set; }

        /// <summary>
        /// Gets or Sets Amount
        /// </summary>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public double? Amount { get; set; }

        /// <summary>
        /// Gets or Sets AmountFC
        /// </summary>
        [DataMember(Name="amountFC", EmitDefaultValue=false)]
        public double? AmountFC { get; set; }

        /// <summary>
        /// Gets or Sets PaymentRate
        /// </summary>
        [DataMember(Name="paymentRate", EmitDefaultValue=false)]
        public double? PaymentRate { get; set; }

        /// <summary>
        /// Gets or Sets PaymentNum
        /// </summary>
        [DataMember(Name="paymentNum", EmitDefaultValue=false)]
        public int? PaymentNum { get; set; }

        /// <summary>
        /// Gets or Sets AccountCode
        /// </summary>
        [DataMember(Name="accountCode", EmitDefaultValue=false)]
        public string AccountCode { get; set; }

        /// <summary>
        /// Gets or Sets AccountName
        /// </summary>
        [DataMember(Name="accountName", EmitDefaultValue=false)]
        public string AccountName { get; set; }

        /// <summary>
        /// Gets or Sets CurrencyCode
        /// </summary>
        [DataMember(Name="currencyCode", EmitDefaultValue=false)]
        public string CurrencyCode { get; set; }

        /// <summary>
        /// Gets or Sets CurrencyFID
        /// </summary>
        [DataMember(Name="currencyFID", EmitDefaultValue=false)]
        public int? CurrencyFID { get; set; }

        /// <summary>
        /// Gets or Sets PartyNum
        /// </summary>
        [DataMember(Name="partyNum", EmitDefaultValue=false)]
        public int? PartyNum { get; set; }

        /// <summary>
        /// Gets or Sets PartyName
        /// </summary>
        [DataMember(Name="partyName", EmitDefaultValue=false)]
        public string PartyName { get; set; }

        /// <summary>
        /// Gets or Sets PartyShortName
        /// </summary>
        [DataMember(Name="partyShortName", EmitDefaultValue=false)]
        public string PartyShortName { get; set; }

        /// <summary>
        /// Gets or Sets FreePartyNum
        /// </summary>
        [DataMember(Name="freePartyNum", EmitDefaultValue=false)]
        public string FreePartyNum { get; set; }

        /// <summary>
        /// Gets or Sets InvoiceCount
        /// </summary>
        [DataMember(Name="invoiceCount", EmitDefaultValue=false)]
        public int? InvoiceCount { get; set; }

        /// <summary>
        /// Gets or Sets PaymentDetails
        /// </summary>
        [DataMember(Name="paymentDetails", EmitDefaultValue=false)]
        public List<PaymentDetail> PaymentDetails { get; set; }

        /// <summary>
        /// Gets or Sets Transaction
        /// </summary>
        [DataMember(Name="transaction", EmitDefaultValue=false)]
        public Transaction Transaction { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Payment {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  AccountFID: ").Append(AccountFID).Append("\n");
            sb.Append("  PartyFID: ").Append(PartyFID).Append("\n");
            sb.Append("  PersonRoleFID: ").Append(PersonRoleFID).Append("\n");
            sb.Append("  Text: ").Append(Text).Append("\n");
            sb.Append("  PaymentTransactionTypeFID: ").Append(PaymentTransactionTypeFID).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  AmountFC: ").Append(AmountFC).Append("\n");
            sb.Append("  PaymentRate: ").Append(PaymentRate).Append("\n");
            sb.Append("  PaymentNum: ").Append(PaymentNum).Append("\n");
            sb.Append("  AccountCode: ").Append(AccountCode).Append("\n");
            sb.Append("  AccountName: ").Append(AccountName).Append("\n");
            sb.Append("  CurrencyCode: ").Append(CurrencyCode).Append("\n");
            sb.Append("  CurrencyFID: ").Append(CurrencyFID).Append("\n");
            sb.Append("  PartyNum: ").Append(PartyNum).Append("\n");
            sb.Append("  PartyName: ").Append(PartyName).Append("\n");
            sb.Append("  PartyShortName: ").Append(PartyShortName).Append("\n");
            sb.Append("  FreePartyNum: ").Append(FreePartyNum).Append("\n");
            sb.Append("  InvoiceCount: ").Append(InvoiceCount).Append("\n");
            sb.Append("  PaymentDetails: ").Append(PaymentDetails).Append("\n");
            sb.Append("  Transaction: ").Append(Transaction).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Payment);
        }

        /// <summary>
        /// Returns true if Payment instances are equal
        /// </summary>
        /// <param name="input">Instance of Payment to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Payment input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.AccountFID == input.AccountFID ||
                    (this.AccountFID != null &&
                    this.AccountFID.Equals(input.AccountFID))
                ) && 
                (
                    this.PartyFID == input.PartyFID ||
                    (this.PartyFID != null &&
                    this.PartyFID.Equals(input.PartyFID))
                ) && 
                (
                    this.PersonRoleFID == input.PersonRoleFID ||
                    (this.PersonRoleFID != null &&
                    this.PersonRoleFID.Equals(input.PersonRoleFID))
                ) && 
                (
                    this.Text == input.Text ||
                    (this.Text != null &&
                    this.Text.Equals(input.Text))
                ) && 
                (
                    this.PaymentTransactionTypeFID == input.PaymentTransactionTypeFID ||
                    (this.PaymentTransactionTypeFID != null &&
                    this.PaymentTransactionTypeFID.Equals(input.PaymentTransactionTypeFID))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.AmountFC == input.AmountFC ||
                    (this.AmountFC != null &&
                    this.AmountFC.Equals(input.AmountFC))
                ) && 
                (
                    this.PaymentRate == input.PaymentRate ||
                    (this.PaymentRate != null &&
                    this.PaymentRate.Equals(input.PaymentRate))
                ) && 
                (
                    this.PaymentNum == input.PaymentNum ||
                    (this.PaymentNum != null &&
                    this.PaymentNum.Equals(input.PaymentNum))
                ) && 
                (
                    this.AccountCode == input.AccountCode ||
                    (this.AccountCode != null &&
                    this.AccountCode.Equals(input.AccountCode))
                ) && 
                (
                    this.AccountName == input.AccountName ||
                    (this.AccountName != null &&
                    this.AccountName.Equals(input.AccountName))
                ) && 
                (
                    this.CurrencyCode == input.CurrencyCode ||
                    (this.CurrencyCode != null &&
                    this.CurrencyCode.Equals(input.CurrencyCode))
                ) && 
                (
                    this.CurrencyFID == input.CurrencyFID ||
                    (this.CurrencyFID != null &&
                    this.CurrencyFID.Equals(input.CurrencyFID))
                ) && 
                (
                    this.PartyNum == input.PartyNum ||
                    (this.PartyNum != null &&
                    this.PartyNum.Equals(input.PartyNum))
                ) && 
                (
                    this.PartyName == input.PartyName ||
                    (this.PartyName != null &&
                    this.PartyName.Equals(input.PartyName))
                ) && 
                (
                    this.PartyShortName == input.PartyShortName ||
                    (this.PartyShortName != null &&
                    this.PartyShortName.Equals(input.PartyShortName))
                ) && 
                (
                    this.FreePartyNum == input.FreePartyNum ||
                    (this.FreePartyNum != null &&
                    this.FreePartyNum.Equals(input.FreePartyNum))
                ) && 
                (
                    this.InvoiceCount == input.InvoiceCount ||
                    (this.InvoiceCount != null &&
                    this.InvoiceCount.Equals(input.InvoiceCount))
                ) && 
                (
                    this.PaymentDetails == input.PaymentDetails ||
                    this.PaymentDetails != null &&
                    this.PaymentDetails.SequenceEqual(input.PaymentDetails)
                ) && 
                (
                    this.Transaction == input.Transaction ||
                    (this.Transaction != null &&
                    this.Transaction.Equals(input.Transaction))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.AccountFID != null)
                    hashCode = hashCode * 59 + this.AccountFID.GetHashCode();
                if (this.PartyFID != null)
                    hashCode = hashCode * 59 + this.PartyFID.GetHashCode();
                if (this.PersonRoleFID != null)
                    hashCode = hashCode * 59 + this.PersonRoleFID.GetHashCode();
                if (this.Text != null)
                    hashCode = hashCode * 59 + this.Text.GetHashCode();
                if (this.PaymentTransactionTypeFID != null)
                    hashCode = hashCode * 59 + this.PaymentTransactionTypeFID.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.AmountFC != null)
                    hashCode = hashCode * 59 + this.AmountFC.GetHashCode();
                if (this.PaymentRate != null)
                    hashCode = hashCode * 59 + this.PaymentRate.GetHashCode();
                if (this.PaymentNum != null)
                    hashCode = hashCode * 59 + this.PaymentNum.GetHashCode();
                if (this.AccountCode != null)
                    hashCode = hashCode * 59 + this.AccountCode.GetHashCode();
                if (this.AccountName != null)
                    hashCode = hashCode * 59 + this.AccountName.GetHashCode();
                if (this.CurrencyCode != null)
                    hashCode = hashCode * 59 + this.CurrencyCode.GetHashCode();
                if (this.CurrencyFID != null)
                    hashCode = hashCode * 59 + this.CurrencyFID.GetHashCode();
                if (this.PartyNum != null)
                    hashCode = hashCode * 59 + this.PartyNum.GetHashCode();
                if (this.PartyName != null)
                    hashCode = hashCode * 59 + this.PartyName.GetHashCode();
                if (this.PartyShortName != null)
                    hashCode = hashCode * 59 + this.PartyShortName.GetHashCode();
                if (this.FreePartyNum != null)
                    hashCode = hashCode * 59 + this.FreePartyNum.GetHashCode();
                if (this.InvoiceCount != null)
                    hashCode = hashCode * 59 + this.InvoiceCount.GetHashCode();
                if (this.PaymentDetails != null)
                    hashCode = hashCode * 59 + this.PaymentDetails.GetHashCode();
                if (this.Transaction != null)
                    hashCode = hashCode * 59 + this.Transaction.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
