/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Posting
    /// </summary>
    [DataContract]
    public partial class Posting :  IEquatable<Posting>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Posting" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected Posting() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="Posting" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="transactionFID">transactionFID.</param>
        /// <param name="invoiceFID">invoiceFID.</param>
        /// <param name="accountFID">accountFID (required).</param>
        /// <param name="contraAccountFID">contraAccountFID.</param>
        /// <param name="vatFID">vatFID.</param>
        /// <param name="vatAccountFID">vatAccountFID.</param>
        /// <param name="costCenterFID">costCenterFID.</param>
        /// <param name="postingTypeFID">postingTypeFID.</param>
        /// <param name="amount">amount (required).</param>
        /// <param name="fcAmount">fcAmount.</param>
        /// <param name="exchangeRate">exchangeRate.</param>
        /// <param name="vatAmount">vatAmount.</param>
        /// <param name="vatFcAmount">vatFcAmount.</param>
        /// <param name="vatPercent">vatPercent.</param>
        /// <param name="vatQuote">vatQuote.</param>
        /// <param name="text">text.</param>
        /// <param name="freeCode">freeCode.</param>
        /// <param name="isDebit">isDebit.</param>
        /// <param name="isInclusive">isInclusive.</param>
        /// <param name="isInvisible">isInvisible.</param>
        /// <param name="postingIndex">postingIndex.</param>
        public Posting(Guid? id = default(Guid?), Guid? transactionFID = default(Guid?), Guid? invoiceFID = default(Guid?), int? accountFID = default(int?), int? contraAccountFID = default(int?), int? vatFID = default(int?), int? vatAccountFID = default(int?), int? costCenterFID = default(int?), int? postingTypeFID = default(int?), double? amount = default(double?), double? fcAmount = default(double?), double? exchangeRate = default(double?), double? vatAmount = default(double?), double? vatFcAmount = default(double?), double? vatPercent = default(double?), double? vatQuote = default(double?), string text = default(string), string freeCode = default(string), bool? isDebit = default(bool?), bool? isInclusive = default(bool?), bool? isInvisible = default(bool?), int? postingIndex = default(int?))
        {
            // to ensure "accountFID" is required (not null)
            if (accountFID == null)
            {
                throw new InvalidDataException("accountFID is a required property for Posting and cannot be null");
            }
            else
            {
                this.AccountFID = accountFID;
            }
            // to ensure "amount" is required (not null)
            if (amount == null)
            {
                throw new InvalidDataException("amount is a required property for Posting and cannot be null");
            }
            else
            {
                this.Amount = amount;
            }
            this.Id = id;
            this.TransactionFID = transactionFID;
            this.InvoiceFID = invoiceFID;
            this.ContraAccountFID = contraAccountFID;
            this.VatFID = vatFID;
            this.VatAccountFID = vatAccountFID;
            this.CostCenterFID = costCenterFID;
            this.PostingTypeFID = postingTypeFID;
            this.FcAmount = fcAmount;
            this.ExchangeRate = exchangeRate;
            this.VatAmount = vatAmount;
            this.VatFcAmount = vatFcAmount;
            this.VatPercent = vatPercent;
            this.VatQuote = vatQuote;
            this.Text = text;
            this.FreeCode = freeCode;
            this.IsDebit = isDebit;
            this.IsInclusive = isInclusive;
            this.IsInvisible = isInvisible;
            this.PostingIndex = postingIndex;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public Guid? Id { get; set; }

        /// <summary>
        /// Gets or Sets TransactionFID
        /// </summary>
        [DataMember(Name="transactionFID", EmitDefaultValue=false)]
        public Guid? TransactionFID { get; set; }

        /// <summary>
        /// Gets or Sets InvoiceFID
        /// </summary>
        [DataMember(Name="invoiceFID", EmitDefaultValue=false)]
        public Guid? InvoiceFID { get; set; }

        /// <summary>
        /// Gets or Sets AccountFID
        /// </summary>
        [DataMember(Name="accountFID", EmitDefaultValue=false)]
        public int? AccountFID { get; set; }

        /// <summary>
        /// Gets or Sets ContraAccountFID
        /// </summary>
        [DataMember(Name="contraAccountFID", EmitDefaultValue=false)]
        public int? ContraAccountFID { get; set; }

        /// <summary>
        /// Gets or Sets VatFID
        /// </summary>
        [DataMember(Name="vatFID", EmitDefaultValue=false)]
        public int? VatFID { get; set; }

        /// <summary>
        /// Gets or Sets VatAccountFID
        /// </summary>
        [DataMember(Name="vatAccountFID", EmitDefaultValue=false)]
        public int? VatAccountFID { get; set; }

        /// <summary>
        /// Gets or Sets CostCenterFID
        /// </summary>
        [DataMember(Name="costCenterFID", EmitDefaultValue=false)]
        public int? CostCenterFID { get; set; }

        /// <summary>
        /// Gets or Sets PostingTypeFID
        /// </summary>
        [DataMember(Name="postingTypeFID", EmitDefaultValue=false)]
        public int? PostingTypeFID { get; set; }

        /// <summary>
        /// Gets or Sets Amount
        /// </summary>
        [DataMember(Name="amount", EmitDefaultValue=false)]
        public double? Amount { get; set; }

        /// <summary>
        /// Gets or Sets FcAmount
        /// </summary>
        [DataMember(Name="fcAmount", EmitDefaultValue=false)]
        public double? FcAmount { get; set; }

        /// <summary>
        /// Gets or Sets ExchangeRate
        /// </summary>
        [DataMember(Name="exchangeRate", EmitDefaultValue=false)]
        public double? ExchangeRate { get; set; }

        /// <summary>
        /// Gets or Sets VatAmount
        /// </summary>
        [DataMember(Name="vatAmount", EmitDefaultValue=false)]
        public double? VatAmount { get; set; }

        /// <summary>
        /// Gets or Sets VatFcAmount
        /// </summary>
        [DataMember(Name="vatFcAmount", EmitDefaultValue=false)]
        public double? VatFcAmount { get; set; }

        /// <summary>
        /// Gets or Sets VatPercent
        /// </summary>
        [DataMember(Name="vatPercent", EmitDefaultValue=false)]
        public double? VatPercent { get; set; }

        /// <summary>
        /// Gets or Sets VatQuote
        /// </summary>
        [DataMember(Name="vatQuote", EmitDefaultValue=false)]
        public double? VatQuote { get; set; }

        /// <summary>
        /// Gets or Sets Text
        /// </summary>
        [DataMember(Name="text", EmitDefaultValue=false)]
        public string Text { get; set; }

        /// <summary>
        /// Gets or Sets FreeCode
        /// </summary>
        [DataMember(Name="freeCode", EmitDefaultValue=false)]
        public string FreeCode { get; set; }

        /// <summary>
        /// Gets or Sets IsDebit
        /// </summary>
        [DataMember(Name="isDebit", EmitDefaultValue=false)]
        public bool? IsDebit { get; set; }

        /// <summary>
        /// Gets or Sets IsInclusive
        /// </summary>
        [DataMember(Name="isInclusive", EmitDefaultValue=false)]
        public bool? IsInclusive { get; set; }

        /// <summary>
        /// Gets or Sets IsInvisible
        /// </summary>
        [DataMember(Name="isInvisible", EmitDefaultValue=false)]
        public bool? IsInvisible { get; set; }

        /// <summary>
        /// Gets or Sets PostingIndex
        /// </summary>
        [DataMember(Name="postingIndex", EmitDefaultValue=false)]
        public int? PostingIndex { get; set; }

        /// <summary>
        /// Gets or Sets PartyNum
        /// </summary>
        [DataMember(Name="partyNum", EmitDefaultValue=false)]
        public int? PartyNum { get; private set; }

        /// <summary>
        /// Gets or Sets FreepartyNum
        /// </summary>
        [DataMember(Name="freepartyNum", EmitDefaultValue=false)]
        public string FreepartyNum { get; private set; }

        /// <summary>
        /// Gets or Sets PartyName
        /// </summary>
        [DataMember(Name="partyName", EmitDefaultValue=false)]
        public string PartyName { get; private set; }

        /// <summary>
        /// Gets or Sets InvoiceNum
        /// </summary>
        [DataMember(Name="invoiceNum", EmitDefaultValue=false)]
        public int? InvoiceNum { get; private set; }

        /// <summary>
        /// Gets or Sets FreeInvoiceNum
        /// </summary>
        [DataMember(Name="freeInvoiceNum", EmitDefaultValue=false)]
        public string FreeInvoiceNum { get; private set; }

        /// <summary>
        /// Gets or Sets InvoiceDate
        /// </summary>
        [DataMember(Name="invoiceDate", EmitDefaultValue=false)]
        public DateTime? InvoiceDate { get; private set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Posting {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  TransactionFID: ").Append(TransactionFID).Append("\n");
            sb.Append("  InvoiceFID: ").Append(InvoiceFID).Append("\n");
            sb.Append("  AccountFID: ").Append(AccountFID).Append("\n");
            sb.Append("  ContraAccountFID: ").Append(ContraAccountFID).Append("\n");
            sb.Append("  VatFID: ").Append(VatFID).Append("\n");
            sb.Append("  VatAccountFID: ").Append(VatAccountFID).Append("\n");
            sb.Append("  CostCenterFID: ").Append(CostCenterFID).Append("\n");
            sb.Append("  PostingTypeFID: ").Append(PostingTypeFID).Append("\n");
            sb.Append("  Amount: ").Append(Amount).Append("\n");
            sb.Append("  FcAmount: ").Append(FcAmount).Append("\n");
            sb.Append("  ExchangeRate: ").Append(ExchangeRate).Append("\n");
            sb.Append("  VatAmount: ").Append(VatAmount).Append("\n");
            sb.Append("  VatFcAmount: ").Append(VatFcAmount).Append("\n");
            sb.Append("  VatPercent: ").Append(VatPercent).Append("\n");
            sb.Append("  VatQuote: ").Append(VatQuote).Append("\n");
            sb.Append("  Text: ").Append(Text).Append("\n");
            sb.Append("  FreeCode: ").Append(FreeCode).Append("\n");
            sb.Append("  IsDebit: ").Append(IsDebit).Append("\n");
            sb.Append("  IsInclusive: ").Append(IsInclusive).Append("\n");
            sb.Append("  IsInvisible: ").Append(IsInvisible).Append("\n");
            sb.Append("  PostingIndex: ").Append(PostingIndex).Append("\n");
            sb.Append("  PartyNum: ").Append(PartyNum).Append("\n");
            sb.Append("  FreepartyNum: ").Append(FreepartyNum).Append("\n");
            sb.Append("  PartyName: ").Append(PartyName).Append("\n");
            sb.Append("  InvoiceNum: ").Append(InvoiceNum).Append("\n");
            sb.Append("  FreeInvoiceNum: ").Append(FreeInvoiceNum).Append("\n");
            sb.Append("  InvoiceDate: ").Append(InvoiceDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Posting);
        }

        /// <summary>
        /// Returns true if Posting instances are equal
        /// </summary>
        /// <param name="input">Instance of Posting to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Posting input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.TransactionFID == input.TransactionFID ||
                    (this.TransactionFID != null &&
                    this.TransactionFID.Equals(input.TransactionFID))
                ) && 
                (
                    this.InvoiceFID == input.InvoiceFID ||
                    (this.InvoiceFID != null &&
                    this.InvoiceFID.Equals(input.InvoiceFID))
                ) && 
                (
                    this.AccountFID == input.AccountFID ||
                    (this.AccountFID != null &&
                    this.AccountFID.Equals(input.AccountFID))
                ) && 
                (
                    this.ContraAccountFID == input.ContraAccountFID ||
                    (this.ContraAccountFID != null &&
                    this.ContraAccountFID.Equals(input.ContraAccountFID))
                ) && 
                (
                    this.VatFID == input.VatFID ||
                    (this.VatFID != null &&
                    this.VatFID.Equals(input.VatFID))
                ) && 
                (
                    this.VatAccountFID == input.VatAccountFID ||
                    (this.VatAccountFID != null &&
                    this.VatAccountFID.Equals(input.VatAccountFID))
                ) && 
                (
                    this.CostCenterFID == input.CostCenterFID ||
                    (this.CostCenterFID != null &&
                    this.CostCenterFID.Equals(input.CostCenterFID))
                ) && 
                (
                    this.PostingTypeFID == input.PostingTypeFID ||
                    (this.PostingTypeFID != null &&
                    this.PostingTypeFID.Equals(input.PostingTypeFID))
                ) && 
                (
                    this.Amount == input.Amount ||
                    (this.Amount != null &&
                    this.Amount.Equals(input.Amount))
                ) && 
                (
                    this.FcAmount == input.FcAmount ||
                    (this.FcAmount != null &&
                    this.FcAmount.Equals(input.FcAmount))
                ) && 
                (
                    this.ExchangeRate == input.ExchangeRate ||
                    (this.ExchangeRate != null &&
                    this.ExchangeRate.Equals(input.ExchangeRate))
                ) && 
                (
                    this.VatAmount == input.VatAmount ||
                    (this.VatAmount != null &&
                    this.VatAmount.Equals(input.VatAmount))
                ) && 
                (
                    this.VatFcAmount == input.VatFcAmount ||
                    (this.VatFcAmount != null &&
                    this.VatFcAmount.Equals(input.VatFcAmount))
                ) && 
                (
                    this.VatPercent == input.VatPercent ||
                    (this.VatPercent != null &&
                    this.VatPercent.Equals(input.VatPercent))
                ) && 
                (
                    this.VatQuote == input.VatQuote ||
                    (this.VatQuote != null &&
                    this.VatQuote.Equals(input.VatQuote))
                ) && 
                (
                    this.Text == input.Text ||
                    (this.Text != null &&
                    this.Text.Equals(input.Text))
                ) && 
                (
                    this.FreeCode == input.FreeCode ||
                    (this.FreeCode != null &&
                    this.FreeCode.Equals(input.FreeCode))
                ) && 
                (
                    this.IsDebit == input.IsDebit ||
                    (this.IsDebit != null &&
                    this.IsDebit.Equals(input.IsDebit))
                ) && 
                (
                    this.IsInclusive == input.IsInclusive ||
                    (this.IsInclusive != null &&
                    this.IsInclusive.Equals(input.IsInclusive))
                ) && 
                (
                    this.IsInvisible == input.IsInvisible ||
                    (this.IsInvisible != null &&
                    this.IsInvisible.Equals(input.IsInvisible))
                ) && 
                (
                    this.PostingIndex == input.PostingIndex ||
                    (this.PostingIndex != null &&
                    this.PostingIndex.Equals(input.PostingIndex))
                ) && 
                (
                    this.PartyNum == input.PartyNum ||
                    (this.PartyNum != null &&
                    this.PartyNum.Equals(input.PartyNum))
                ) && 
                (
                    this.FreepartyNum == input.FreepartyNum ||
                    (this.FreepartyNum != null &&
                    this.FreepartyNum.Equals(input.FreepartyNum))
                ) && 
                (
                    this.PartyName == input.PartyName ||
                    (this.PartyName != null &&
                    this.PartyName.Equals(input.PartyName))
                ) && 
                (
                    this.InvoiceNum == input.InvoiceNum ||
                    (this.InvoiceNum != null &&
                    this.InvoiceNum.Equals(input.InvoiceNum))
                ) && 
                (
                    this.FreeInvoiceNum == input.FreeInvoiceNum ||
                    (this.FreeInvoiceNum != null &&
                    this.FreeInvoiceNum.Equals(input.FreeInvoiceNum))
                ) && 
                (
                    this.InvoiceDate == input.InvoiceDate ||
                    (this.InvoiceDate != null &&
                    this.InvoiceDate.Equals(input.InvoiceDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.TransactionFID != null)
                    hashCode = hashCode * 59 + this.TransactionFID.GetHashCode();
                if (this.InvoiceFID != null)
                    hashCode = hashCode * 59 + this.InvoiceFID.GetHashCode();
                if (this.AccountFID != null)
                    hashCode = hashCode * 59 + this.AccountFID.GetHashCode();
                if (this.ContraAccountFID != null)
                    hashCode = hashCode * 59 + this.ContraAccountFID.GetHashCode();
                if (this.VatFID != null)
                    hashCode = hashCode * 59 + this.VatFID.GetHashCode();
                if (this.VatAccountFID != null)
                    hashCode = hashCode * 59 + this.VatAccountFID.GetHashCode();
                if (this.CostCenterFID != null)
                    hashCode = hashCode * 59 + this.CostCenterFID.GetHashCode();
                if (this.PostingTypeFID != null)
                    hashCode = hashCode * 59 + this.PostingTypeFID.GetHashCode();
                if (this.Amount != null)
                    hashCode = hashCode * 59 + this.Amount.GetHashCode();
                if (this.FcAmount != null)
                    hashCode = hashCode * 59 + this.FcAmount.GetHashCode();
                if (this.ExchangeRate != null)
                    hashCode = hashCode * 59 + this.ExchangeRate.GetHashCode();
                if (this.VatAmount != null)
                    hashCode = hashCode * 59 + this.VatAmount.GetHashCode();
                if (this.VatFcAmount != null)
                    hashCode = hashCode * 59 + this.VatFcAmount.GetHashCode();
                if (this.VatPercent != null)
                    hashCode = hashCode * 59 + this.VatPercent.GetHashCode();
                if (this.VatQuote != null)
                    hashCode = hashCode * 59 + this.VatQuote.GetHashCode();
                if (this.Text != null)
                    hashCode = hashCode * 59 + this.Text.GetHashCode();
                if (this.FreeCode != null)
                    hashCode = hashCode * 59 + this.FreeCode.GetHashCode();
                if (this.IsDebit != null)
                    hashCode = hashCode * 59 + this.IsDebit.GetHashCode();
                if (this.IsInclusive != null)
                    hashCode = hashCode * 59 + this.IsInclusive.GetHashCode();
                if (this.IsInvisible != null)
                    hashCode = hashCode * 59 + this.IsInvisible.GetHashCode();
                if (this.PostingIndex != null)
                    hashCode = hashCode * 59 + this.PostingIndex.GetHashCode();
                if (this.PartyNum != null)
                    hashCode = hashCode * 59 + this.PartyNum.GetHashCode();
                if (this.FreepartyNum != null)
                    hashCode = hashCode * 59 + this.FreepartyNum.GetHashCode();
                if (this.PartyName != null)
                    hashCode = hashCode * 59 + this.PartyName.GetHashCode();
                if (this.InvoiceNum != null)
                    hashCode = hashCode * 59 + this.InvoiceNum.GetHashCode();
                if (this.FreeInvoiceNum != null)
                    hashCode = hashCode * 59 + this.FreeInvoiceNum.GetHashCode();
                if (this.InvoiceDate != null)
                    hashCode = hashCode * 59 + this.InvoiceDate.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
