/* 
 * Topal REST API
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Transaction
    /// </summary>
    [DataContract]
    public partial class Transaction :  IEquatable<Transaction>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Transaction" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected Transaction() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="Transaction" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="fiscalYearFID">fiscalYearFID.</param>
        /// <param name="userFID">userFID.</param>
        /// <param name="transactionTypeFID">transactionTypeFID.</param>
        /// <param name="docType">docType.</param>
        /// <param name="docNum">docNum (required).</param>
        /// <param name="docDate">docDate.</param>
        /// <param name="modifyDate">modifyDate.</param>
        /// <param name="isConfirmed">isConfirmed.</param>
        /// <param name="numRangeFID">numRangeFID.</param>
        /// <param name="hasDocument">hasDocument.</param>
        /// <param name="postings">postings.</param>
        public Transaction(Guid? id = default(Guid?), int? fiscalYearFID = default(int?), int? userFID = default(int?), int? transactionTypeFID = default(int?), string docType = default(string), int? docNum = default(int?), DateTime? docDate = default(DateTime?), DateTime? modifyDate = default(DateTime?), bool? isConfirmed = default(bool?), int? numRangeFID = default(int?), bool? hasDocument = default(bool?), List<Posting> postings = default(List<Posting>))
        {
            // to ensure "docNum" is required (not null)
            if (docNum == null)
            {
                throw new InvalidDataException("docNum is a required property for Transaction and cannot be null");
            }
            else
            {
                this.DocNum = docNum;
            }
            this.Id = id;
            this.FiscalYearFID = fiscalYearFID;
            this.UserFID = userFID;
            this.TransactionTypeFID = transactionTypeFID;
            this.DocType = docType;
            this.DocDate = docDate;
            this.ModifyDate = modifyDate;
            this.IsConfirmed = isConfirmed;
            this.NumRangeFID = numRangeFID;
            this.HasDocument = hasDocument;
            this.Postings = postings;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public Guid? Id { get; set; }

        /// <summary>
        /// Gets or Sets FiscalYearFID
        /// </summary>
        [DataMember(Name="fiscalYearFID", EmitDefaultValue=false)]
        public int? FiscalYearFID { get; set; }

        /// <summary>
        /// Gets or Sets UserFID
        /// </summary>
        [DataMember(Name="userFID", EmitDefaultValue=false)]
        public int? UserFID { get; set; }

        /// <summary>
        /// Gets or Sets TransactionTypeFID
        /// </summary>
        [DataMember(Name="transactionTypeFID", EmitDefaultValue=false)]
        public int? TransactionTypeFID { get; set; }

        /// <summary>
        /// Gets or Sets DocType
        /// </summary>
        [DataMember(Name="docType", EmitDefaultValue=false)]
        public string DocType { get; set; }

        /// <summary>
        /// Gets or Sets DocNum
        /// </summary>
        [DataMember(Name="docNum", EmitDefaultValue=false)]
        public int? DocNum { get; set; }

        /// <summary>
        /// Gets or Sets DocDate
        /// </summary>
        [DataMember(Name="docDate", EmitDefaultValue=false)]
        public DateTime? DocDate { get; set; }

        /// <summary>
        /// Gets or Sets ModifyDate
        /// </summary>
        [DataMember(Name="modifyDate", EmitDefaultValue=false)]
        public DateTime? ModifyDate { get; set; }

        /// <summary>
        /// Gets or Sets IsConfirmed
        /// </summary>
        [DataMember(Name="isConfirmed", EmitDefaultValue=false)]
        public bool? IsConfirmed { get; set; }

        /// <summary>
        /// Gets or Sets NumRangeFID
        /// </summary>
        [DataMember(Name="numRangeFID", EmitDefaultValue=false)]
        public int? NumRangeFID { get; set; }

        /// <summary>
        /// Gets or Sets HasDocument
        /// </summary>
        [DataMember(Name="hasDocument", EmitDefaultValue=false)]
        public bool? HasDocument { get; set; }

        /// <summary>
        /// Gets or Sets Postings
        /// </summary>
        [DataMember(Name="postings", EmitDefaultValue=false)]
        public List<Posting> Postings { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Transaction {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  FiscalYearFID: ").Append(FiscalYearFID).Append("\n");
            sb.Append("  UserFID: ").Append(UserFID).Append("\n");
            sb.Append("  TransactionTypeFID: ").Append(TransactionTypeFID).Append("\n");
            sb.Append("  DocType: ").Append(DocType).Append("\n");
            sb.Append("  DocNum: ").Append(DocNum).Append("\n");
            sb.Append("  DocDate: ").Append(DocDate).Append("\n");
            sb.Append("  ModifyDate: ").Append(ModifyDate).Append("\n");
            sb.Append("  IsConfirmed: ").Append(IsConfirmed).Append("\n");
            sb.Append("  NumRangeFID: ").Append(NumRangeFID).Append("\n");
            sb.Append("  HasDocument: ").Append(HasDocument).Append("\n");
            sb.Append("  Postings: ").Append(Postings).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Transaction);
        }

        /// <summary>
        /// Returns true if Transaction instances are equal
        /// </summary>
        /// <param name="input">Instance of Transaction to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Transaction input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.FiscalYearFID == input.FiscalYearFID ||
                    (this.FiscalYearFID != null &&
                    this.FiscalYearFID.Equals(input.FiscalYearFID))
                ) && 
                (
                    this.UserFID == input.UserFID ||
                    (this.UserFID != null &&
                    this.UserFID.Equals(input.UserFID))
                ) && 
                (
                    this.TransactionTypeFID == input.TransactionTypeFID ||
                    (this.TransactionTypeFID != null &&
                    this.TransactionTypeFID.Equals(input.TransactionTypeFID))
                ) && 
                (
                    this.DocType == input.DocType ||
                    (this.DocType != null &&
                    this.DocType.Equals(input.DocType))
                ) && 
                (
                    this.DocNum == input.DocNum ||
                    (this.DocNum != null &&
                    this.DocNum.Equals(input.DocNum))
                ) && 
                (
                    this.DocDate == input.DocDate ||
                    (this.DocDate != null &&
                    this.DocDate.Equals(input.DocDate))
                ) && 
                (
                    this.ModifyDate == input.ModifyDate ||
                    (this.ModifyDate != null &&
                    this.ModifyDate.Equals(input.ModifyDate))
                ) && 
                (
                    this.IsConfirmed == input.IsConfirmed ||
                    (this.IsConfirmed != null &&
                    this.IsConfirmed.Equals(input.IsConfirmed))
                ) && 
                (
                    this.NumRangeFID == input.NumRangeFID ||
                    (this.NumRangeFID != null &&
                    this.NumRangeFID.Equals(input.NumRangeFID))
                ) && 
                (
                    this.HasDocument == input.HasDocument ||
                    (this.HasDocument != null &&
                    this.HasDocument.Equals(input.HasDocument))
                ) && 
                (
                    this.Postings == input.Postings ||
                    this.Postings != null &&
                    this.Postings.SequenceEqual(input.Postings)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.FiscalYearFID != null)
                    hashCode = hashCode * 59 + this.FiscalYearFID.GetHashCode();
                if (this.UserFID != null)
                    hashCode = hashCode * 59 + this.UserFID.GetHashCode();
                if (this.TransactionTypeFID != null)
                    hashCode = hashCode * 59 + this.TransactionTypeFID.GetHashCode();
                if (this.DocType != null)
                    hashCode = hashCode * 59 + this.DocType.GetHashCode();
                if (this.DocNum != null)
                    hashCode = hashCode * 59 + this.DocNum.GetHashCode();
                if (this.DocDate != null)
                    hashCode = hashCode * 59 + this.DocDate.GetHashCode();
                if (this.ModifyDate != null)
                    hashCode = hashCode * 59 + this.ModifyDate.GetHashCode();
                if (this.IsConfirmed != null)
                    hashCode = hashCode * 59 + this.IsConfirmed.GetHashCode();
                if (this.NumRangeFID != null)
                    hashCode = hashCode * 59 + this.NumRangeFID.GetHashCode();
                if (this.HasDocument != null)
                    hashCode = hashCode * 59 + this.HasDocument.GetHashCode();
                if (this.Postings != null)
                    hashCode = hashCode * 59 + this.Postings.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
